<?php
/**
 * This product Copyright 2010 metaVentis GmbH.  For detailed notice,
 * see the "NOTICE" file with this distribution.
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */
include_once ('../../conf.inc.php');
include_once (MC_LIB_PATH.'ESApp.php');
include_once (MC_LIB_PATH.'EsApplications.php');
include_once (MC_LIB_PATH.'EsApplication.php');
include_once (MC_LIB_PATH.'ESRepository.php');

include_once (MC_LIB_PATH.'ESModule.php');
include_once (MC_LIB_PATH.'ESObject.php');

include_once ('Alfresco/Service/Repository.php');
include_once ('Alfresco/Service/SpacesStore.php');


class estracking
{

	public function setTracking($p_obj)
	{
		require_once(MC_LIB_PATH.'Plattform.php');
		$l_Plattform = new Plattform();

		$sql = 'insert into ' . $l_Plattform->DB->quoteIdentifier('ESTRACK') . '('
			. $l_Plattform->DB->quoteIdentifier('ESTRACK_APP_ID')
			. ', ' . $l_Plattform->DB->quoteIdentifier('ESTRACK_REP_ID')
			. ', ' . $l_Plattform->DB->quoteIdentifier('ESTRACK_LMS_COURSE_ID')
			. ', ' . $l_Plattform->DB->quoteIdentifier('ESTRACK_OBJECT_ID')
			. ', ' . $l_Plattform->DB->quoteIdentifier('ESTRACK_NAME')
			. ', ' . $l_Plattform->DB->quoteIdentifier('ESTRACK_MODUL_ID')
			. ', ' . $l_Plattform->DB->quoteIdentifier('ESTRACK_MODUL_NAME')
			. ', ' . $l_Plattform->DB->quoteIdentifier('ESTRACK_VERSION')
			. ', ' . $l_Plattform->DB->quoteIdentifier('ESTRACK_USER_NAME')
			. ', ' . $l_Plattform->DB->quoteIdentifier('ESTRACK_USER_ID')
			. ', ' . $l_Plattform->DB->quoteIdentifier('ESTRACK_POINTS')
			. ', ' . $l_Plattform->DB->quoteIdentifier('STATE')
			. ') values ('
			. $l_Plattform->DB->quote($p_obj->estrack_app_id, 'text')
			. ', ' . $l_Plattform->DB->quote($p_obj->estrack_rep_id, 'text')
			. ', ' . $l_Plattform->DB->quote($p_obj->estrack_lms_course_id, 'text')
			. ', ' . $l_Plattform->DB->quote($p_obj->estrack_object_id, 'text')
			. ', ' . $l_Plattform->DB->quote($p_obj->estrack_name, 'text')
			. ', ' . $l_Plattform->DB->quote($p_obj->estrack_modul_id, 'text')
			. ', ' . $l_Plattform->DB->quote($p_obj->estrack_modul_name, 'text')
			. ', ' . $l_Plattform->DB->quote($p_obj->estrack_version, 'text')
			. ', ' . $l_Plattform->DB->quote($p_obj->estrack_user_name, 'text')
			. ', ' . $l_Plattform->DB->quote($p_obj->estrack_user_id, 'text')
			. ', ' . $l_Plattform->DB->quote($p_obj->estrack_points, 'text')
			. ', ' . $l_Plattform->DB->quote('Y', 'text')
			.');';

		$res = $l_Plattform->DB->query($sql);
		if (Plattform::isError($res))
		{
			error_log('Error inserting tracking-data.', E_USER_ERROR);

			throw new SoapFault('0', 'Error inserting tracking data.');
		}

		$LastInsertId = $l_Plattform->DB->lastInsertId();
		if ( $l_Plattform->DB->isError($LastInsertId) )
		{
			error_log('Error reading last-insert-id "ESTRACK_ESTRACK_ID".', E_USER_ERROR);

			throw new SoapFault('0', 'Error reading tracking-id.');
		}

		$ro = new stdClass();
		$ro->setTrackingReturn = $LastInsertId;

		return $ro;
  }



}// end class

$server = new SoapServer("estracking.wsdl");
$server->setClass("estracking");
$server->handle();


