<?php

/**
 *
 *
 *
 */
class ESRender_Application
extends ESRender_Application_Abstract
{

	/**
	 * (non-PHPdoc)
	 * @see ESRender_Application_Interface::trackObject()
	 */
	public function trackObject($RepositoryId, $ApplicationId, $ObjectId,
		$ObjectName, $ObjectVersion, $ModuleId, $ModuleName, $UserId,
		$UserName, $CourseId = null)
	{
		$Logger = $this->getLogger();

		if ( $Logger )
		{
			$Logger->debug('Start ESRender_Application::trackObject()');
		}

		try
		{
			$SoapClientParams = array();
			if ( defined('USE_HTTP_PROXY') && USE_HTTP_PROXY )
			{
				$SoapClientParams = array(
					'proxy_host' => HTTP_PROXY_HOST,
					'proxy_port' => HTTP_PROXY_PORT,
					'proxy_login' => HTTP_PROXY_USER,
					'proxy_password' => HTTP_PROXY_PASS,
				);
			}

			$wsdl = MC_BASE_DIR . 'application/esmain/estracking.wsdl';
			if ( ! is_readable($wsdl) )
			{
				throw new Exception('"estracking.wsdl" not readable.');
			}

			$trclient = new SoapClient($wsdl, $SoapClientParams);

			$params = array(
				"estrack_app_id" => $ApplicationId,
				"estrack_rep_id" => $RepositoryId,
				"estrack_object_id" => $ObjectId,
				"estrack_name" => $ObjectName,
				"estrack_version" => $ObjectVersion,
				"estrack_modul_id" => $ModuleId,
				"estrack_modul_name" => $ModuleName,
				"estrack_user_id" => $UserId,
				"estrack_user_name" => $UserName,
				"estrack_lms_course_id" => $CourseId,
				"estrack_points" => 0
			);

			$ret = $trclient->setTracking($params);
			$params['estrack_id'] = $ret->setTrackingReturn;

			if ( $Logger )
			{
				$Logger->info('Successfully tracked object.');
			}

			return $ret->setTrackingReturn;
		}
		catch (Exception $e)
		{
			if ( $Logger )
			{
				$Logger->error('Error while tracking object.');
				$Logger->error('Given message: "'.$e->getMessage().'".');
			}
		}

		return false;
	}

}
