<?php
error_reporting(E_ERROR);
//ini_set('display_errors', 1);
require_once (dirname(__FILE__) . '/../../../../../conf.inc.php');
require_once (dirname(__FILE__) . '/../../../../../modules/video/config.php');
require_once (dirname(__FILE__) . '/../../../../../modules/video/mod_video.php');
require_once (dirname(__FILE__) . '/../../../../extern/videotoolkit/phpvideotoolkit.php5.php');

/*
 * 
 * Loads conversion queue from DB and converts video files
 * 
 * 
 * */
class converter {

    const FORMAT_IPAD = 'FORMAT_IPAD';
    const FORMAT_FLASH = 'FORMAT_FLASH';

    /**
     * DB - Datenbankobjekt für alle Operationen
     * @var object DB
     */
    public $DB;

    /**
     * Initialisiert werden die der Klasse App zugehörige Membervariablen
     */
    public function Plattform() {
        $this -> DEBUG = MC_DEBUG;
        require_once (MC_LIB_PATH . "DB/DBMC.php");
        $this -> DB = DBMC::connect(DSN, false);
        return true;
    }


    public function __construct() {
        set_time_limit(600);
        $this -> Plattform();
    }

    /*
     * 
     * Load queue, lock and convert items.
     * 
     * @return boolean
     * 
     */
    public function convert() {
    
        if (!$convArray = $this -> getConversionQueue())
            return;

        foreach($convArray as $id => $conv) {
            $object = new ESObject($conv['ESOBJECT_CONVERSION_OBJECT_ID']);
            $object -> setConversionStateProcessing($conv['ESOBJECT_CONVERSION_OBJECT_ID'], $conv['ESOBJECT_CONVERSION_FORMAT']);
        }
 
        foreach($convArray as $id => $conv) {
            $this->convertObject($conv);
        }
        return true;
    }
    
    
    /*
     * Convert item
     * 
     * @param $conv the to convert
     * 
     * @return boolean
     */
    public function convertObject($conv) {
        
        echo '#####'.$conv['ESOBJECT_CONVERSION_FORMAT'].'#####';

        // !!! APPEND DIRECTORY_SEPARATOR to avoid confusion by phpVideoToolkit
        $tmp_dir = dirname($conv['ESOBJECT_CONVERSION_FILENAME']) . $conv['ESOBJECT_CONVERSION_DIR_SEPERATOR'];

        // init
        $toolkit = new PHPVideoToolkit($tmp_dir);
        $toolkit -> on_error_die = FALSE;
        $toolkit -> addCommand('-strict', 'experimental');

        $arr = explode("/", $conv['ESOBJECT_CONVERSION_MIMETYPE'], 2);
        $type = $arr[0];
        
        switch($type) {
            case 'audio':
                //  bit rate of audio (valid vaues are 16,32,64)
                $bitrate = 64;
                $toolkit->setAudioBitRate($bitrate);
        
                //  sampling rate (valid values are 11025, 22050, 44100)
                $samprate = 44100;
                $toolkit->setAudioSampleFrequency($samprate);
        
                $toolkit->setFormat('mp3');
                $toolkit->setAudioCodec('mp3');
                
            break;
            case 'video':
                
                $video_bitrate = 350;
                $toolkit -> setVideoBitRate($video_bitrate);
                $toolkit -> setVideoOutputDimensions(320, 240);
                
                switch( $conv['ESOBJECT_CONVERSION_FORMAT'] ) {
                    case self::FORMAT_IPAD :
                        $toolkit -> setFormat('mp4');
                        $toolkit -> setVideoCodec('libx264');
                        $fps = 30;
                        $toolkit -> setVideoFrameRate($fps);
                        $toolkit -> setAudioCodec('libfaac');
                        $audio_samprate = 48000;
                        $toolkit -> setAudioSampleFrequency($audio_samprate);
                        $audio_bitrate = 64;
                        $toolkit -> setAudioBitRate($audio_bitrate);
                        break;
                    case self::FORMAT_FLASH :
                        $audio_samprate = 44100;
                        $audio_bitrate = 64;
                        $toolkit -> setFormatToFLV($audio_samprate, $audio_bitrate);
                        break;
                    default :
                        throw new Exception('Unhandled format.');
                }
                
            break;
            default:
                echo 'no valid mimetype specified';
        }

       
        if (!$toolkit -> setInputFile($conv['ESOBJECT_CONVERSION_FILENAME'])) {
            throw new Exception($toolkit -> getLastError());
        }

        // !!! APPEND DIRECTORY_SEPARATOR to avoid confusion by phpVideoToolkit
        $output_dir = dirname($conv['ESOBJECT_CONVERSION_OUTPUT_FILENAME']) . $conv['ESOBJECT_CONVERSION_DIR_SEPERATOR'];
        if (!$toolkit -> setOutput($output_dir, basename($conv['ESOBJECT_CONVERSION_OUTPUT_FILENAME']), PHPVideoToolkit::OVERWRITE_EXISTING)) {
            //  if there was an error then get it
            throw new Exception($toolkit -> getLastError());
        }
        //  execute the ffmpeg command
        $result = false;
        $result = $toolkit -> execute(false, false);

        if (PHPVideoToolkit::RESULT_OK !== $result) {
            return false;
        } else {
            $object = new ESObject($conv['ESOBJECT_CONVERSION_OBJECT_ID']);
            $object -> setConversionStateProcessed($conv['ESOBJECT_CONVERSION_OBJECT_ID'], $conv['ESOBJECT_CONVERSION_FORMAT']);
        }

        return true;
    }

    /*
     * Loads items with status ESObject::CONVERSION_STATUS_WAIT from database
     * 
     * @return boolean or table entry
     */
    public function getConversionQueue() {

        $Sql = 'select * from ' . $this -> DB -> quoteIdentifier('ESOBJECT_CONVERSION') . 
        ' where ' . $this->DB->quoteIdentifier('ESOBJECT_CONVERSION_STATUS') . ' = ' . $this->DB->quote(ESObject::CONVERSION_STATUS_WAIT, 'text') .';';

        $res = $this -> DB -> query($Sql);
        if (Plattform::isError($res)) {
            return false;
        }
        $row = $res -> fetchAll(DBMC_FETCHMODE_ASSOC);
        if (!$row) {
            return false;
        }
        return $row;

    }

}


$c = new converter();
$c -> convert();
