<?php

if (file_exists('../_inc/standalone.php'))
{
	include_once('../_inc/standalone.php');
}

if (empty($DBStruct) || ! is_object($DBStruct) )
{
	throw new Exception('object $DBStruct is not available');
}


// beispiele addCol :
// ------------------
$DBStruct->addCol('mc_prog', 'OWNER', ' int(11) NOT NULL default 0 after idUser');
$DBStruct->addCol('SN', 'LASTCHANGE', ' timestamp NULL default CURRENT_TIMESTAMP after STATE');


// beispiele changeCol :
// ---------------------
$DBStruct->changeCol('mc_prog', 'idProg', array('Field' => 'idProg', 'Type' => 'int(11)', 'Null' => 'YES'));
$DBStruct->changeCol('mc_prog', 'idProg', array('Field' => 'idProg', 'Type' => 'int(11)', 'Null' => 'YES', 'Default' => null, 'Key' => '', 'Extra' => ''));

// erluterung array-aufbau fr ChangeCol :
// ----------------------------------------
// array(6) {
//   ["Field"]   => string "<new colname>" bspw. "idProg"
//   ["Type"]    => string "int(11)|etc."
//   ["Null"]    => string "NO|YES" --> 'NO' = not null !
//   ["Key"]     => string "PRI|UNI"
//   ["Default"] => NULL|etc.
//   ["Extra"]   => string "auto_increment"
// }


// beispiel createTable :
// ----------------------
$DBStruct->createTable('EXTFUNC_TYPE', "(
  `EXTFUNC_TYPE_ID` int(11) NOT NULL auto_increment,
  `EXTFUNC_TYPE_IDENT` int(11) default NULL,
  `EXTFUNC_TYPE_NAME` varchar(40) default NULL,
  `EXTFUNC_TYPE_GROUP` varchar(20) default NULL,
  `OWNER` int(11) default NULL,
  `WGROUP` int(11) default NULL,
  `ACCESS` int(11) default NULL,
  `INSDAT` date default NULL,
  `UPDDAT` date default NULL,
  `STATE` char(1) default NULL,
  `LASTCHANGE` timestamp NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`EXTFUNC_TYPE_ID`),
  UNIQUE KEY `EXTFUNC_TYPE_IDENT` (`EXTFUNC_TYPE_IDENT`),
  UNIQUE KEY `EXTFUNC_TYPE_NAME` (`EXTFUNC_TYPE_NAME`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
");


// beispiele createIndexOnTable :
// ------------------------------
$DBStruct->createIndexOnTable('WGROUP', 'WGROUP_NAME,COURSE_ID,STATE');
$DBStruct->createIndexOnTable('REL_G_U', 'REL_G_U_APP_IDENT,STATE,REL_G_U_USER_IDENT');
$DBStruct->createIndexOnTable('REL_G_U', 'REL_G_U_APP_IDENT,STATE,REL_G_U_WGROUP_IDENT');


// beispiel dropTables :
// ---------------------
$DBStruct->dropTables(array('FILEDIR'));


