<!--

Beschreibung fr Aufbau von MPS-Dateien
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

kurze beschreibung, damit man nicht alles immer wieder neu (h)er(aus)finden und
ausprobieren muss... ;-)

Tipp:
*.mps im editor als filetype fr xml-highlighting eintragen! ;-)

! WICHTIG !
mps-dateien (MetacoonPatchScript) werden noch nicht als echtes xml interpretiert,
sondern per Regular Expression ausgewertet. also bitte immer auf die exakte
schreibweise achten (bspw. tags und attribute in lowercase).

nachfolgend eine kurze beschreibung der notwendigen/mglichen tags und attribute


tagname   : MPSTABLE
====================
kontext   : keiner
vorkommen : einfach bis mehrfach; erforderlich
syntax    : <mpstable name="{table name}"></mpstable>
attribute :
	name (pflichtattribut)
	  -> name einer datenbank-tabelle

aufgabe   :
	weist den parser an, alle darin eingeschlossenen anweisungen im kontext der 
	genannten tabelle auszufhren (sofern nicht anders angegeben)

beispiel  :

	<mpstable name="COL">
		[anweisungen]
	</mpstable>

	oder

	<mpstable name="VIEW">
		[anweisungen]
	</mpstable>



tagname   : MPSCREATE
=====================
kontext   : MPSTABLE
vorkommen : nicht bis einfach
syntax    : <mpscreate>{create statement}</mpscreate>
attribute : keine
aufgabe   :
	weist den parser an, diese tabelle anzulegen, falls sie noch nicht existiert.
	WICHTIG: das einleitende "create table [if not exists] [table_name}" gehrt 
	         hier NICHT zum statement!

beispiel  :

	<mpscreate>
(
  `APP_ID` int(11) NOT NULL AUTO_INCREMENT,
  `APP_IDENT` int(11) DEFAULT NULL,
  `APP_NAME` char(40) DEFAULT NULL,
  `APP_DESC` char(200) DEFAULT NULL,
  `APP_UID` char(255) NOT NULL,
  `INSDAT` date DEFAULT NULL,
  `UPDDAT` date DEFAULT NULL,
  `STATE` char(1) DEFAULT NULL,
  `LASTCHANGE` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`APP_ID`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8
	</mpscreate>



tagname   : MPSDROP
===================
kontext   : MPSTABLE
vorkommen : nicht bis einfach
syntax    : <mpsdrop />
attribute : keine
aufgabe   :
	weist den parser an, diese tabelle zu droppen, falls sie existiert.

beispiel  :

	<mpsdrop />



tagname   : MPSKEY
==================
kontext   : MPSTABLE
vorkommen : nicht bis mehrfach
syntax    : <mpskey value="{column name}[{separator}{column name}[{separator}{column name}[...]]]" separator="[separator]" />
attribute :
	value (pflichtattribut)
	  -> enthlt einen oder mehrere spaltennamen bzw. die ihnen entsprechenden 
	     token, getrennt mittels =>separator
	separator (pflichtattribut)
	  -> ein oder mehrere zeichen, die als trenner im =>value und im =>key der 
	     zugehrigen items verwendet werden

aufgabe   :
	weist den parser an, die angegebenen spalten zur auflsung von vergleichs-
	schlssel zu benutzen. werden mehrere spalten angegeben, so mssen diese 
	durch ein entsprechendes zeichen getrennt und das zeichen im attribut 
	"separator" benannt werden.
	wird nur eine spalte verwendet, so darf das attribut separator zwar nicht 
	entfallen, darf aber leer bleiben.

beispiel  :

	<mpskey value="COL_TAB_IDENT.COL_NAME" separator="." />

	oder

	<mpskey value="VCOL_VIEW_IDENT@@@VCOL_COL_IDENT" separator="@@@" />

	oder

	<mpskey value="VIEW_NAME" separator="" />



tagname   : MPSMAP
==================
kontext   : MPSTABLE
vorkommen : nicht bis mehrfach
syntax    : <mpsmap value="{identifier}" />
attribute :
	value (pflichtattribut)
	  -> name einer tabellen-spalte oder tabelle, zu der eine foreign-key-map 
	     zur verfgung gestellt werden soll

aufgabe   :
	weist den parser an, eine dem identifier entsprechende fk-map zu generieren.
	als identifier kann der name der spalte selbst dienen (bspw. COL_TAB_IDENT),
	synoynm dafr knnen auch direkt der der fk-spaltenname (im falle des 
	beispiels: TAB_IDENT) bzw. der name der entsprechenden tabelle (im falle des
	beispiels: TAB) verwendet werden.
	sollte keine passende Map verfgbar sein (fehlermeldung!), so muss sie unter
	<patchverzeichnis>/_classes/core/PMap.php::getMapByColName(...)
	registriert bzw. ergnzt werden.

	die token der maps knnen sowohl in den db-statements, als auch in den 
	vergleichsschlssels der MPSITEM-tags verwendet werden und folgen stets dem 
	schema '%<fk-spaltenname>(<unique fk-key>)%'.
	fr "COL_TAB_IDENT" (ebenso fr die verkrzten schreibweisen "TAB_IDENT und 
	"TAB") erhielte man also eine map auf die fk-spalte TAB_IDENT mit dem 
	dortigen unique key TAB_NAME.

	das token fr den TAB_IDENT der tabelle LABEL wrde beispielsweise 
	%TAB_IDENT(LABEL)% geschrieben.

beispiel  :

	<mpsmap value="VCOL_VIEW_IDENT" />

	synonyme
	<mpsmap value="VIEW_IDENT" />
	<mpsmap value="VIEW" />

weiteres beispiele :

	<mpsmap value="VIEW_ELEMENT_IDENT" />

	synonyme
	<mpsmap value="ELEMENT_IDENT" />
	<mpsmap value="ELEMENT" />

hinweis : empfohlen sind die originalen namen der foreign keys, im obigen fall 
          also VIEW_IDENT und ELEMENT_IDENT



tagname   : MPSAUTO
===================
kontext   : MPSTABLE
vorkommen : nicht bis mehrfach; nur in verbindung mit einfge-operationen sinnvoll
syntax    : <mpsauto field="{column name}" method="{method}" />
attribute :
	field (pflichtattribut)
	  -> name einer tabellen-spalte
	method (pflichtattribut)
	  -> das verfahren, nach dem spalte =>field automatisch befllt werden soll
		   "INS_ID"    befllt die spalte mit der last_insert_id()
		   "NEXTIDENT" befllt die spalte mit dem wert max({column name}) + 1

aufgabe   :
	weist den parser an, beim ausfhren einer insert-operation die angegebene 
	spalte automatisch nach dem schema {method} zu befllen.

beispiel  :

	<mpsauto field="VIEW_IDENT" method="NEXTIDENT" />



tagname   : MPSREQUIRE
===================
kontext   : MPSTABLE
vorkommen : nicht bis mehrfach
syntax    : <mpsrequire table="{table}" [fields="{comma separated list of fields}"]/>
attribute :
	table (pflichtattribut)
	  -> name einer tabelle
	fields (pflichtattribut)
	  -> name einer spalte oder mehrere, durch kommata getrennte spaltennamen
	     wenn das attribut leer ist, wird nur nach {table} gesucht

aufgabe   :
	die anweisungen innerhalb des bergeordneten MPSTABLE-tags werden nur 
	ausgefhrt, wenn die aufgefhrten tabellen bzw. deren spalten existieren

beispiel :

		<mpsrequire table="MC_ADDRESS" fields=""/>
		<mpsrequire table="COL" fields="COL_DESC"/>
		<mpsrequire table="VCOL" fields="VCOL_DESC_DE,VCOL_DESC_EN"/>



tagname   : MPSITEM
===================
kontext   : MPSTABLE
vorkommen : einmal bis mehrfach
syntax    :
	<mpsitem action="{action}" key="{key}"
		[idtoken="{token}"]
		[desc="{desc}"]
		[stoponmismatch="{message}"] [erroronmismatch="{message}"]
	>{statement}</mpsitem>
attribute :
	action (pflichtattribut)
	  -> beschreibt die art der aktion, die das item ausfhrt bzw. ausfhren soll
	key (pflichtattribut bei aktionen "insert" und "delete", optional bei "update")
	  -> beschreibt nach dem im <mpskey> festgelegten schema einen schlssel, 
	     mit dem die existenz eines konkreten tabelleneintrages berprft wird
	idtoken (pflichtattribut bei aktion "getone", optional bei "insert")
	  -> speichert eine id auf das token %{token}%
	desc (optional)
	  -> kommentar, der bei der abarbeitung ausgegeben wird
	stoponmismatch (optional)
	erroronmismatch (optional)
	  -> warnung bzw. fehlermeldung, die ausgegeben wird, wenn der vergleich auf 
	     [key] fehlschlgt.
		 achtung: stopt die abarbeitung aller skripte!
		 hinweis: wirkt nur bei update- und getone-aktionen!

aufgabe   :
	weist den parser an, das angegebene statement auszufhren. bei "insert"- und
	"delete"-aktionen MUSS das attribut [key] als trigger verwendet werden.
	bei der aktion "update" KANN es als trigger verwendet werden.
	mgliche aktionen und ihre verhaltensweisen sind:
	"insert"
	  => erzwingt (!) angabe des attributes =>key.
	     fhrt {statement} nur dann aus, wenn ein zu {key} passender eintrag 
		 NICHT in der tabelle gefunden wird.
	     ist das attribut =>idtoken angegeben, so wird die insert_id als token 
		 %{token}% zur verfgung gestellt.
	"update"
	  => erlaubt angabe des attributes =>key.
	     fhrt {statement} aus, wenn ein zu {key} passender eintrag gefunden 
		 wird oder leer ist.
	"delete"
	  => erzwingt (!) angabe des attributes =>key.
	     fhrt {statement} nur dann aus, wenn ein zu {key} passender eintrag 
		 gefunden wird.
	"insert_by_user"
	  => wie "insert", fhrt aber {statement} pro gefundenem benutzer einmal aus.
	     ersetzt sowohl im {key} als auch im {statement} das token %USER_IDENT% 
		 mit dem identen des jeweiligen benutzers
	"insert_by_room"
	  => wie "insert", fhrt aber {statement} pro gefundenem raum einmal aus.
	     ersetzt sowohl im {key} als auch im {statement} das token %ROOM_ID% mit
		 der id des jeweiligen raumes
	"getone"
	  => erfordert die angabe des attributes =>idtoken.
	     fhrt {statement} aus und stellt den ermittelten wert als token 
		 %{token}% zur verfgung.

	besteht ein =>key aus den werten mehrerer spalten, so sind diese werte mit 
	dem beim tag <mpskey> angegebenen =>separator zu verbinden. daher muss zur 
	auflsung von keys die entsprechende <mpskey>-definition existieren!

	das attribut =>idtoken ist bei "insert"-aktionen optional und speichert die 
	last_insert_id(). bei der aktion "getone" ist dieses attribut erforderlich!
	token werden immer mit flankierenden prozentzeichen verwendet. bspw. erzeugt
	die angabe 'idtoken="beispieltoken"' ein token namens %beispieltoken%.

	die angabe {statement} ist eine gewhnliche mysql-anweisung, innerhalb derer
	die metacoon-typischen =>token als alias verwendet werden knnen.
	diese token knnen entweder ber entsprechende tags als <mpsmap> eingebunden
	oder zur laufzeit als =>idtoken erzeugt werden.

	das optionale attribut =>desc erzeugt vor der ausfhrung des zugehrigen 
	statements eine ausschrift
	"Note : {desc}"

	das optionale attribut =>stoponmismatch wirkt nur in zusammenhang mit einer 
	update- oder getone-aktion!



sonstiges :
===========
  die ersetzungsmatrix umfasst derzeit folgende standard-token:

  %APP_IDENT%    => enthlt die plattformtypische APP.APP_IDENT

  %MC_ROOT_PATH% => enthlt den wert der konstanten MC_ROOT_PATH

  %MC_ROOT_URI%  => enthlt den wert der konstanten MC_ROOT_URI

  whrend der script-abarbeitung knnen zustzliche token ergnzt werden. dies
  ist mglich durch
  - die einbindung von ident-maps ber das tag <mpsmap>
  - <mpsitem>-tags mit den actions "insert" oder "getone" in verbindung mit dem 
    attribut =>idtoken



beispiel unter benutzung der meisten tags :
-------------------------------------------

<!-- ffnen eines abschnittes zur modifikation der inhalte von tabelle MENUITEM -->
<mpstable name="MENUITEM" />

	<!-- alle eingeschlossenen tags beziehen sich auf tabelle MENUITEM -->


	<!-- beschreibung des zur eindeutigen datensatz-identifikation benutzten 
	     schlssels in diesem fall als kombination von _MENU_IDENT und _CSS_IDENT
	     -->
	<mpskey value="MENUITEM_MENU_IDENT@MENUITEM_CSS_IDENT" separator="@" />


	<!-- laden von maps fr tokenersetzungen der spalten MENUITEM_ELEMENT_IDENT
	     und MENUITEM_MENU_IDENT
	     WICHTIG: die map fr MENUITEM_MENU_IDENT wirkt auch fr den MPSKEY!
	     (entsprechend sollten in den key-attributen der mpsitems die passenden 
		  token benutzt werden)
	     -->
	<mpsmap value="MENUITEM_ELEMENT_IDENT" />
	<mpsmap value="MENUITEM_MENU_IDENT" />


	<!-- bei eventuellen inserts soll die spalte MENUITEM_IDENT automatisch mit 
	     der last_insert_id gefllt weren
		 -->
	<mpsauto field="MENUITEM_IDENT" method="INS_ID" />


	<!-- insert wird nur ausgefhrt, wenn noch kein menuitem fr menu leftdesk 
	     mit dem css-identen 'mycourses' existiert.
	     spalte MENUITEM_IDENT erhlt automatisch die last_insert_id (siehe tag MPSAUTO)
	     die token %ELEMENT_IDENT(EROOM_OVERVIEW)% und %MENU_IDENT(LEFTDESK)% 
		 werden mit den per <mpsmap> eingebundenen, gemappten identen ersetzt
	     die last_insert_id des eintrages wird als token %mycourses_token% zur 
		 verfgung gestellt
	     -->
	<mpsitem action="insert" key="%MENU_IDENT(LEFTDESK)%@mycourses" idtoken="mycourses_token">
	insert into MENUITEM (
	COURSE_ID, LAYOUT, MENUITEM_APP_IDENT, MENUITEM_CAP, MENUITEM_CSS, MENUITEM_CSS_IDENT, MENUITEM_DE, MENUITEM_ELEMENT_IDENT, MENUITEM_EN, MENUITEM_FROM_EXTFUNC, MENUITEM_LAYOUT, MENUITEM_MENUITEMLAY_IDENT, MENUITEM_MENU_IDENT, MENUITEM_NAME, MENUITEM_ONCLICK, MENUITEM_ONMOUSEOUT, MENUITEM_ONMOUSEOVER, MENUITEM_ORDER, MENUITEM_PARAM, MENUITEM_PICT, MENUITEM_RESTRICT, MENUITEM_SCRIPT, MENUITEM_SID, MENUITEM_SUB, MENUITEM_SUB_MENUITEM_CSS_IDENT, MENUITEM_SUB_MENU_NAME, MENUITEM_TARGET, MENUITEM_VIEW, RELDATE, RELLANG, RELSTATE, STATE, VIEW
	) values (
	0, "LMENUITEM", %APP_IDENT%, "a:2:{s:2:\"DE\";s:11:\"Meine Kurse\";s:2:\"EN\";s:0:\"\";}", "mc182menuli2", "mycourses", NULL, %ELEMENT_IDENT(EROOM_OVERVIEW)%, NULL, NULL, NULL, 2, %MENU_IDENT(LEFTDESK)%, NULL, NULL, NULL, NULL, 2, NULL, NULL, "N", "modules/roomstruct/roomstruct.php", "Y", 77, NULL, NULL, "um", NULL, NULL, NULL, "N", "Y", "VMENUITEM"
	)
	</mpsitem>


	<!-- deaktivieren des items 'serviceprovider' im menu 'LEFTDESK' sofern im 
	     gleichen menu ein item namens 'support' existiert 
		 -->
	<mpsitem action="update" key="%MENU_IDENT(LEFTDESK)%@support">
	update MENUITEM set
	  STATE = "A"
	 where
	      MENUITEM_MENU_IDENT = %MENU_IDENT(LEFTDESK)%
	  and MENUITEM_CSS_IDENT = "serviceprovider"
	</mpsitem>


	<!-- deaktivieren ALLER items mit MENUITEM_CSS_IDENT = 'groupmail', da kein 
	     spezieller key berprft wird !
	     vor dem ausfhren des statements wird die ausschrift "Note : alle 
		 menuepunkte fuer 'groupmail' rauswerfen" angezeigt
	     -->
	<mpsitem action="update" desc="alle menuepunkte fuer 'groupmail' rauswerfen">
	update MENUITEM set
	  STATE = "D"
	 where
	      MENUITEM_CSS_IDENT = "groupmail"
	</mpsitem>


	<!-- lschen aller items 'help_piece' aus dem menu 'LEFTADMIN' (wird wegen 
	     attribut 'key' nur ausgefhrt, wenn solche items existieren)
		 -->
	<mpsitem action="delete" key="%MENU_IDENT(LEFTADMIN)%@help_piece">
	delete from MENUITEM
	 where
	      MENUITEM_MENU_IDENT = %MENU_IDENT(LEFTADMIN)%
	  and MENUITEM_CSS_IDENT= "help_piece";
	</mpsitem>

</mpstable>
<!-- schliet den abschnitt fr tabelle MENUITEM -->


<!-- ffnen eines abschnittes fr tabelle COL -->
<mpstable name="COL">

	<!-- alle eingeschlossenen tags beziehen sich auf tabelle COL -->

	<!-- tabelle COL mit folgendem statement erzeugen, falls sie nicht existiert -->
	<mpscreate>
(
  `COL_ID` int(11) NOT NULL AUTO_INCREMENT,
  `COL_IDENT` int(11) DEFAULT NULL,
  `COL_APP_IDENT` int(11) DEFAULT NULL,
  `COL_TAB_IDENT` int(11) DEFAULT NULL,
  `COL_NAME` varchar(40) NOT NULL,
  `COL_DESC` varchar(255) DEFAULT NULL,
  `COL_TYPE` varchar(20) DEFAULT NULL,
  `COL_LEN` int(11) NOT NULL,
  `COL_UNIQUE_NS` varchar(255) DEFAULT NULL,
  `COL_ORDER_NS` varchar(255) DEFAULT NULL,
  `INSDAT` date DEFAULT NULL,
  `UPDDAT` date DEFAULT NULL,
  `STATE` char(1) DEFAULT NULL,
  `LASTCHANGE` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `ACCESS` int(11) DEFAULT NULL,
  `OWNER` int(11) DEFAULT NULL,
  `WGROUP` int(11) DEFAULT NULL,
  `COL_DESC_EN` varchar(20) DEFAULT NULL,
  PRIMARY KEY (`COL_ID`),
  KEY `COL_IDX1` (`COL_TAB_IDENT`,`COL_IDENT`)
) ENGINE=MyISAM AUTO_INCREMENT=2974 DEFAULT CHARSET=utf8
	</mpscreate>


	<!-- unique key fr tabelle COL definieren -->
	<mpskey value="COL_TAB_IDENT#COL_NAME" separator="#" />


	<!-- map laden (erforderlich fr allgemeingltigen unique key: tab_ident 
	     muss nach tab_name ausgelst werden) 
		 -->
	<mpsmap value="COL_TAB_IDENT" />


	<!-- berprfen, ob tabelle REGISTER tatschlich in TAB registriert ist.
	     wichtig: select "%TAB_IDENT(REGISTER)%"; kann nicht als alternative 
		 verwendet werden, weil das token im fehlerfall nicht aufgelst werden 
		 kann und das ergebnis nicht leer sondern '%TAB_IDENT(REGISTER)%' wre 
		 -->
	<mpsitem action="getone" idtoken="%tmp_register_tab_ident%" erroronmismatch="Tabelle REGISTER ist nicht in tabelle TAB registriert!">
	select TAB_IDENT
	 from TAB
	 where TAB_NAME = "REGISTER";
	</mpsitem>


	<!-- ermitteln des nchsten freien COL_IDENT und bereitstellen auf dem token 
	     %NEXT_COL_IDENT% 
		 -->
	<mpsitem action="getone" idtoken="NEXT_COL_IDENT">
select max(COL_IDENT) + 1 from COL where COL_TAB_IDENT = %TAB_IDENT(REGISTER)%;
	</mpsitem>


	<!-- erzeugen eines COL-eintrages unter verwendung von %NEXT_COL_IDENT%, 
	     sofern dieser eintrag (siehe =>key) noch nicht existiert 
		 -->
	<mpsitem action="insert" key="%TAB_IDENT(REGISTER)%#REGISTER_POLICY_ACCEPTED">
insert into COL (
COL_IDENT, COL_APP_IDENT, COL_TAB_IDENT, COL_NAME, COL_DESC, COL_TYPE, COL_LEN, INSDAT, STATE
) values (
%NEXT_COL_IDENT%, %APP_IDENT%, %TAB_IDENT(REGISTER)%, 'REGISTER_POLICY_ACCEPT', 'REGISTER_POLICY_ACCEPT', 'INT', 3, now(), 'Y'
)
	</mpsitem>


</mpstable>
<!-- schliet den abschnitt fr tabelle COL -->


