<?php

require_once(MCP_PATH.'_classes/Plattform.php');


class MpsReader
//	extends Plattform
{

	var $default_path;

	function MpsReader()
	{
		// bergeordnete Klasse instanziieren
//		$this->Plattform();

		$this->default_path = MCP_SQL_PATH;

		return true;
	} //  end of constructor

	function read($l_filename)
	{

		if (empty($this->default_path))
		{
			$this->default_path = MCP_SQL_PATH;
		}

		$l_path = $this->default_path.$l_filename;

		if (file_exists($l_path) == false)
		{
			Plattform::error($l_path, 'cannot open file');
			return false;
		}

		$l_DomDocument = new DOMDocument();
		if ($l_DomDocument->load($l_path) == false)
		{
			Plattform::error($l_DomDocument, 'error on loading '.$l_path);
		}

		return (new MpsDocument($this->default_path, $l_filename, $l_DomDocument));
	} //  end function read($l_filename)


} // end class MpsReader





class MpsDocument
//	extends Plattform
{

	var $path = null;

	var $file = null;

	var $domxmldoc = null;

	function MpsDocument($p_path, $p_file, $p_doc)
	{
		// bergeordnete Klasse instanziieren
//		$this->Plattform();

		$this->path = trim($p_path);
		if (empty($this->path))
		{
			Plattform::error($p_path, 'parameter $p_path is empty');
		}

		$this->file = trim($p_file);
		if (empty($this->file))
		{
			Plattform::error($p_file, 'parameter $p_file is empty');
		}

		if (file_exists($p_path.$p_file) == false)
		{
			Plattform::error($p_path.$p_file, 'file not found');
		}

		if (empty($p_doc))
		{
			Plattform::error('parameter $p_doc is empty');
		}

		if (is_object($p_doc) == false)
		{
			Plattform::error($p_doc, '$p_doc is not an object');
		}

		if (strtolower(get_class($p_doc)) != 'domdocument')
		{
			Plattform::error($p_doc, '$p_doc is not a DomDocument object');
		}

		$this->domxmldoc = $p_doc;

		return true;
	} //  end of constructor



	function execute()
	{
		echo 'YAY!';
		return true;
	} //  end function execute


} // end class MpsDocument

?>