<?php
/*
* $McLicense$
*
* $Id$
*
*/



class Check
{

	/**
	 * checkPhpLibs
	 */
	function checkPhpLibs($Conf)
	{
		$arrReqLibs = $Conf->getLibsRequired();
		$arrOptLibs = $Conf->getLibsOptional();

		$state = true;

		SysMsg::showMsg('checking for required php libraries...');

		foreach ($arrReqLibs as $libName => $libDesc)
		{
			$upperLibName = '<b>'.strtoupper($libName).'</b>';
			if (extension_loaded($libName))
			{
				SysMsg::showInfo('library '.$upperLibName.' found.');
			}
			else
			{
				$state = false;
				SysMsg::showError('library '.$upperLibName.' missing! '.$libDesc);
			}
		}

		SysMsg::showMsg('checking for optional php libraries...');

		foreach ($arrOptLibs as $libName => $libDesc)
		{
			$upperLibName = '<b>'.strtoupper($libName).'</b>';
			if (extension_loaded($libName))
			{
				SysMsg::showInfo('library '.$upperLibName.' found.');
			}
			else
			{
				SysMsg::showWarning('library '.$upperLibName.' missing! '.$libDesc);
			}
		}

		return $state;
	} // end method checkPhpLibs



	/**
	 * checkModInfoPath
	 */
	function checkModInfoPath($Config)
	{
		$arrDirnames = $Config->getUpdateDirnames();

		foreach ($arrDirnames as $updateDirname)
		{
			$path = $Config->getUpdateInfoPath($updateDirname);
			if ( ! @is_dir($path) )
			{
				return $path;
			}
		} // end foreach

		return true;
	} // end method checkModInfoPath



	/**
	 * static function checkHeadRevision
	 */
	function checkHeadRevision($PVersion)
	{
		if ( ! is_object($PVersion) )
		{
			mc_Debug::error($PVersion, 'parameter is not an object from class');
			return false;
		}

		$version  = $PVersion->getVersion();
		$revision = $PVersion->getRevision();
		$build    = $PVersion->getBuild();

		$result = $PVersion->DB->query(
			 'select VERSION.* from VERSION'
			.' where'
			.'     VERSION_VNUMBER  = '.$this->DB->quote($version)
			.' and VERSION_REVISION = '.$this->DB->quote($revision)
			.' and VERSION_VBUILD   = '.$this->DB->quote($build)
		);

		if ($result->numRows() == 0) {
			return false;
		}

		$head_revision = $result->fetchRow(DBMC_FETCHMODE_ASSOC);
		$result->free();

		return $head_revision;
	} // end method checkHeadRevision

} //  end class Check


