<?php
/*
* $McLicense$
*
* $Id$
*
*/


require_once(MCP_LIB_PATH.'Plattform.php');

if ( !defined('MC_PHPBB2_TABLE_PREFIX') )
{
	define('MC_PHPBB2_TABLE_PREFIX', 'mc_phpbb_');
}


class DbCleanUp
	extends Plattform
{
	public $File;

	function __construct (&$l_File)
	{
		parent::__construct();

		$this->File = $l_File;
	}



	function killRoomData($p_rid = null)
	{
		$l_course_id = intval($p_rid);

		if (empty($l_course_id)) {
			$l_query = "select COURSE_ID";
			$l_query.=" from COURSE";
			$res = $this->DB->getCol($l_query);
			if (mc_Debug::isError($res))
			{
				return false;
			}

			$condition = 'NOT in ('.implode(', ', $res).')';
			$name = 'data from all missing rooms';
		}
		else {
			SysMsg::showMsg("try to delete room $p_rid ...");

			$l_query = "select COURSE_TITEL, STATE";
			$l_query.=" from COURSE";
			$l_query.=" where";
			$l_query.=" COURSE_ID=".$l_course_id;
			$res=$this->DB->query($l_query);
			if (mc_Debug::isError($res))
			{
				return false;
			}

			if ($res->numRows() == 0)
			{
				SysMsg::showWarning("room does not exist");
				return false;
			}

			$name = $res->fetchRow();

			$condition = '= '.$l_course_id;
			$res->free();
		}

		// delete permissions (WRIGHT)
		if ( ! $this->deleteCourseGroupRights($condition) )
		{
			mc_Debug::error(null, "Error deleting course group rights -> deleteCourseGroupRights($condition)");
			return false;
		}

		// delete groups and group relations(REL_G_U, WGROUP)
		if ( ! $this->deleteCourseGroups($condition) )
		{
			mc_Debug::error(null, "Error deleting course group -> deleteCourseGroups($condition)");
			return false;
		}

		// delete user-room-relations (REL_COURSE_USER)
		$l_query = "delete from REL_COURSE_USER";
		$l_query.=" where";
		$l_query.="     REL_COURSE_USER_APP_IDENT = ".$this->APP_IDENT;
		$l_query.=" and REL_COURSE_USER_COURSE_ID ".$condition;
		$result = $this->DB->query($l_query);
		if (mc_Debug::isError($result))
		{
			return false;
		}

		// kill external pages
		if (empty($l_course_id)) {
			$this->deleteFromExtern();
			$this->deleteFromVtree($condition);
		}
		else {
			$this->deleteFromExtern($l_course_id);
			$this->deleteFromVtree($condition);
		}

 		$sel  =  "delete";
 		$sel .= " from PROFILE";
 		$sel .= " where";
 		$sel .= "     PROFILE.COURSE_ID ".$condition;
 		$result = $this->DB->query($sel);
		if (mc_Debug::isError($result))
		{
			return false;
		}

		// fetch names of component tables
		$l_sel  =  'select TAB_NAME';
		$l_sel .= ' from TAB';
		$l_sel .= ' where';
		$l_sel .= '     TAB_NAME like "M2_%"';
		$l_sel .= ' and STATE = "Y"';
		$m2tab_result = $this->DB->getCol($l_sel);
		if (mc_Debug::isError($m2tab_result))
		{
			return false;
		}

		$m2tab_result[] = 'CHAT_ROOM';
		$m2tab_result[] = 'CHAT_MESSAGE';
		$m2tab_result[] = 'CHAT_PROTOCOL';
		$m2tab_result[] = 'SIMPLADR';
		$m2tab_result[] = 'MENU';
		$m2tab_result[] = 'MENUITEM';
		$m2tab_result[] = 'EXTMENU';
		$m2tab_result[] = 'EXTMENUITEM';
		$m2tab_result[] = 'MC_TEXT';
		$m2tab_result[] = 'COURSE_CONF';
/*
DELETE FROM COURSE WHERE COURSE_ID in ();
DELETE FROM VTREE_NODE WHERE COURSE_ID in ();
*/


		// walk component tables
		foreach ( $m2tab_result as $l_tab_name )
		{
			$l_query = "select ".$l_tab_name."_ID as M2_ID, VIEW_IDENT, DS_ID";
			$l_query.=" from VIEW, TAB, ".$l_tab_name;
			$l_query.=" where";
			$l_query.="     TAB_NAME = '".$l_tab_name."'";
			$l_query.=" and VIEW_TAB_IDENT = TAB_IDENT";
			$l_query.=" and ".$l_tab_name.".COURSE_ID = ".$l_course_id;
			$m2_result=$this->DB->query($l_query);
			if (mc_Debug::isError($m2_result))
			{
				return false;
			}

			while ($l_m2_item = $m2_result->fetchRow(DBMC_FETCHMODE_ASSOC))
			{
				$l_query = "delete from LINK";
				$l_query.=" where";
				$l_query.=" (LINK_S_VIEW_IDENT=".$l_m2_item['VIEW_IDENT']." and";
				$l_query.=" LINK_S_ID=".$l_m2_item['M2_ID'].") or";
				$l_query.=" (LINK_D_VIEW_IDENT=".$l_m2_item['VIEW_IDENT']." and";
				$l_query.=" LINK_D_ID=".$l_m2_item['M2_ID'].")";
				$result=$this->DB->query($l_query);
				if (mc_Debug::isError($result))
				{
					return false;
				}

				$this->deleteDs($l_m2_item['DS_ID']);
			} // end while

			// delete room related entries of component tables
			$l_query = "delete from ".$l_tab_name;
			$l_query.=" where";
			$l_query.=" COURSE_ID=".$l_course_id;
			$result=$this->DB->query($l_query);
			if (mc_Debug::isError($result))
			{
				return false;
			}

		} // end foreach

		// delete room related room struture relations
		$l_query = "delete from REL_COURSE_ROOM_STRUCTURE ";
		$l_query.=" where";
		$l_query.=" REL_COURSE_ROOM_STRUCTURE_COURSE_ID=".$l_course_id;
		$result=$this->DB->query($l_query);
		if (mc_Debug::isError($result))
		{
			return false;
		}

		$this->deletePhpbbCategory($l_course_id);

		// delete room
		$l_query = "delete from COURSE";
		$l_query.=" where";
		$l_query.=" COURSE_ID=".$l_course_id;
		$result=$this->DB->query($l_query);
		if (mc_Debug::isError($result))
		{
			return false;
		}

		return ($name[0].'('.$l_course_id.':'.$name[1].')');
	} // end method deleteRoom





	//-------------------------------------------------------------------------
	/**
	* Rechte von Kursgruppen löschen
	*
	* Löscht alle zu einem Kurs gehörigen Rechte. Identifizierung der Einträge erfolgt
	* über WRIGHT_APP_IDENT und COURSE_ID
	*
	* @param int $p_course_ident
	* @return boolean gibt TRUE zurück, wenn löschen erfolgreich war
	* @author Steffen Gross
	*/
	function deleteCourseGroupRights($p_course_ident)
	{
		$sel = "delete from WRIGHT";
		$sel.=" where";
		$sel.=" WRIGHT_APP_IDENT=".mc_Session::getApp()." and";
		$sel.=" COURSE_ID=".$p_course_ident;
		$l_result = $this->DB->query($sel);
		if (mc_Debug::isError($sel))
		{
			return false;
		}
		return true;
	} // end deleteCourseGroupRights




	/**
	* löscht alle Gruppen eines Kurses
	*
	* Löscht alle Gruppen eines angegebenen Kurses, löscht alle entsprechenden Relationen
	* und Rechte aus den Tabellen REL_G_U und WRIGHT
	*
	* @access	public
	* @param	int	$p_course_ident		Ident des Kurses, dessen Gruppen gelöscht werden sollen
	* @return	boolean				TRUE, wenn beim Löschen keine Fehler auftraten
	*/

	function deleteCourseGroups ($p_course_id) {

		// kursgruppen finden
		$l_query = "select WGROUP_IDENT";
		$l_query.=" from WGROUP";
		$l_query.=" where";
		$l_query.=" WGROUP_APP_IDENT=".$this->APP_IDENT." and";
		$l_query.=" COURSE_ID='".$p_course_id."'";
		$grouplist=$this->DB->getCol($l_query);
		if (Plattform::isError($grouplist))
		{
			return false;
		}

		if (sizeof($grouplist) ==0) return true;

		// alle zutreffenden M2_AUFGFELD -einträge ausschalten
		$l_query = "delete from M2_AUFGFELD";
		$l_query.=" WHERE";
		$l_query.=" COURSE_ID=".$p_course_id;
		// echo $l_query.'<br>';
		$result=$this->DB->query($l_query);
		if (Plattform::isError($result))
		{
			return false;
		}

		// gruppen-user-relationen des kurses (der kurs-gruppen) löschen
		$l_query = "DELETE FROM REL_G_U ";
		$l_query.=" WHERE ";
		$l_query.=" REL_G_U_APP_IDENT=".$this->APP_IDENT." and";
		$l_query.=" REL_G_U_WGROUP_IDENT in (".implode(',',$grouplist).")";

		$result2=$this->DB->query($l_query);
		if (Plattform::isError($result2))
		{
			return false;
		}

//################### phpBB Integration ####################

		foreach($grouplist as $p_wgroup_ident)
		{

			$sel =" select group_id";
			$sel.=" from ".MC_PHPBB2_TABLE_PREFIX."groups";
			$sel.=" where";
			$sel.=" group_mc_wgroup_ident =".$p_wgroup_ident;
			$group_id = $this->DB->getOne($sel);
			if (Plattform::isError($group_id)) {
				return false;
			}

			if (empty($group_id))
			{
				continue;
			}

			$del = "delete from ".MC_PHPBB2_TABLE_PREFIX."groups";
			$del .=" where group_id=".$group_id;
			$res = $this->DB->query($del);
			if (Plattform::isError($res)) {
				return false;
			}

			$del = "delete from ".MC_PHPBB2_TABLE_PREFIX."auth_access ";
			$del.=" where group_id	=".$group_id;
			$res = $this->DB->query($del);
			if (Plattform::isError($res)) {
				return false;
			}
		}

		// kursgruppen finden
		$l_query = "select DS_ID";
		$l_query.=" from WGROUP";
		$l_query.=" where";
		$l_query.=" WGROUP_APP_IDENT=".$this->APP_IDENT." and";
		$l_query.=" COURSE_ID='".$p_course_id."'";
		$l_arr_ds_id = $this->DB->getCol($l_query);
		if (Plattform::isError($l_arr_ds_id))
		{
			return false;
		}

		foreach($l_arr_ds_id as $l_ds_id)
		{
			$this->deleteDs($l_ds_id);
		}

		// kursgruppen löschen
		$l_query = "delete from WGROUP";
		$l_query.=" where";
		$l_query.=" WGROUP_APP_IDENT=".$this->APP_IDENT." and";
		$l_query.=" COURSE_ID='".$p_course_id."'";
		$result=$this->DB->query($l_query);
		if (Plattform::isError($result))
		{
			return false;
		}

		return true;
	} // Ende  Group::deleteCourseGroups




	/**
	 * deleteDs
	 *
	 * @author	Steffen Gross <gross@metacoon.net>
	 */
	public function deleteDs($l_ds_id)
	{
		if (mc_Debug::isError($this->DB->query(
			'delete from DS where DS_ID = '.$l_ds_id
		))) { return false; }

		if (mc_Debug::isError($this->DB->query(
			'delete from DS_LINK where DS_LINK_SRC_DS_ID = '.$l_ds_id.' or DS_LINK_DEST_DS_ID = '.$l_ds_id
		))) { return false; }

		if (mc_Debug::isError($this->DB->query(
			'delete from DS_ACCESS where DS_ACCESS_DS_ID = '.$l_ds_id
		))) { return false; }

		return true;
	} // end method deleteDs





	function deletePhpbbCategory($p_room_ident) {

  	$sel = "select forum_id ";
  	$sel.=" from ".MC_PHPBB2_TABLE_PREFIX."forums";
		$sel.=" where cat_id	=".$p_room_ident;
  	$forum_id = $this->DB->getCol($sel);
  	if (Plattform::isError($forum_id)) {
  		return false;
  	}

		if (is_array($forum_id) == false) {
			return false;
		}

		if (sizeof($forum_id) == 0) {
			return false;
		}

		// delete forum
		$del = "delete from ".MC_PHPBB2_TABLE_PREFIX."forums";
		$del.=" where forum_id in (".implode(",", $forum_id).")";
		$res = $this->DB->query($del);
		if (Plattform::isError($res)) {
			return false;
		}

		// fetch forum topics
		$sel = "select topic_id";
		$sel.=" from ".MC_PHPBB2_TABLE_PREFIX."topics";
		$sel.=" where forum_id in (".implode(",", $forum_id).")";
		$topic_id = $this->DB->getCol($sel);
		if (Plattform::isError($topic_id)) {
			return false;
		}

		if (is_array($topic_id) == false) {
			return false;
		}

		if (sizeof($topic_id) == 0) {
			return false;
		}

		// delete all forum topics and topic watches
		$del = "delete from ".MC_PHPBB2_TABLE_PREFIX."topics";
		$del.=" where forum_id in (".implode(",", $forum_id).")";
  	$res = $this->DB->query($del);
  	if (Plattform::isError($res)) {
  		return false;
  	}

  	$del = "delete from ".MC_PHPBB2_TABLE_PREFIX."topics_watch";
		$del.=" where topic_id in (".implode(",", $topic_id).")";
  	$res = $this->DB->query($del);
  	if (Plattform::isError($res)) {
  		return false;
  	}

		// delete all forum posts
		$sel = "select post_id";
		$sel.=" from ".MC_PHPBB2_TABLE_PREFIX."posts";
		$sel.=" where forum_id in (".implode(",", $forum_id).")";
		$post_id = $this->DB->getCol($sel);
		if (Plattform::isError($post_id)) {
			return false;
		}

		if (is_array($post_id) == false) {
			return false;
		}

		if (sizeof($post_id) == 0) {
			return false;
		}

		// delete all forum posts
  	$del = "delete from ".MC_PHPBB2_TABLE_PREFIX."posts_text";
		$del.=" where post_id in (".implode(",", $post_id).")";
  	$res = $this->DB->query($del);
  	if (Plattform::isError($res)) {
  		return false;
  	}

 	  $del = "delete from ".MC_PHPBB2_TABLE_PREFIX."posts";
		$del.=" where forum_id in (".implode(",", $forum_id).")";
  	$res = $this->DB->query($del);
  	if (Plattform::isError($res)) {
  		return false;
  	}

		// delete category
  	$del = "delete from ".MC_PHPBB2_TABLE_PREFIX."categories";
		$del.=" where cat_id	=".$p_room_ident;
  	$res = $this->DB->query($del);
  	if (Plattform::isError($res)) {
  		return false;
  	}

		return true;

	}// Ende function deletePhpbbCategory



	function deleteFromVTree($condition)
	{

		$l_sel  =  'select PROFILE_INT_VALUE';
		$l_sel .= ' from PROFILE';
		$l_sel .= ' where';
		$l_sel .= '     PROFILE_PARAM_NAME like "ROOMNODE"';
		$l_sel .= ' and STATE = "Y"';
		$room_node_parent_id = $this->DB->getOne($l_sel);
		if (mc_Debug::isError($room_node_parent_id))
		{
			return false;
		}

		$l_sel  =  'select VTREE_NODE_ID';
		$l_sel .= ' from VTREE_NODE';
		$l_sel .= ' where';
		$l_sel .= '     VTREE_NODE_PARENT_ID = '.intval($room_node_parent_id);
		$l_sel .= ' and VTREE_NODE_COURSE_ID '.$condition;
		$arrNodeId = $this->DB->getCol($l_sel);
		if (mc_Debug::isError($arrNodeId))
		{
			return false;
		}

		if (empty($room_node_id))
		{
			SysMsg::showWarning("filemanager: room directory not found");
		}
		else
		{
			include_once(MCP_LIB_PATH.'core/PVTreeNode.php');
			$l_PVTreeNode = PVTreeNode::getInstance($room_node_id);
			if ($l_PVTreeNode)
			{
				$l_del_node_path = $l_PVTreeNode->delete();
				if ($l_del_node_path)
				{
					$l_del_node_path = str_replace(MC_ROOT_PATH, '', $l_del_node_path);
					$this->File->delete(array($l_del_node_path));
				}
			}
		}

		return true;
	} // end function deleteFromVTree



	function deleteFromExtern($roomId=null)
	{
		if ( ! empty($roomId) ) {
			$this->File->delete(array("extern/C".$roomId));
			return;
		}

		return true;
	} // end function deleteFromVTree




} // end class DbCleanUp


