<?php
/*
* $McLicense$
*
* $Id$
*
*/

/**
 * handles the current metacoon session
 *
 * @author steffen gross / matthias hupfer
 * @version 1.0
 * @package core
 * @subpackage classes.new
 */
class mc_Debug
{

	/**
	 * this function is deprecated and should be replaced by throwing exceptions directly
	 * @DEPRACATED
	 */
	public static function error($objErr, $errMsg)
	{
		throw new mc_Exception($objErr, $errMsg);
	}



	/**
	 * this function is deprecated and should be replaced by direct use of DBMC:isError
	 * @DEPRECATED
	 */
	public static function isError($err)
	{
		if (DBMC::isError($err) )
		{
			throw new mc_Exception($err, $err->getUserInfo() );
		}
		return false;
	}



	/**
	 *
	 */
	public static function isValid($err)
	{
		return ( ! mc_Debug::isError($err) );
	}



	function showBacktrace($return_result = false)
	{
		$l_backtrace = debug_backtrace();
		$l_default = array(
			'class' => '',
			'type' => '',
			'object' => '',
			'args' => '',
			'file' => null,
			'line' => null,
		);

		ob_start();
		echo ' from '.$l_backtrace[0]['file'].':'.$l_backtrace[0]['line'].'<br />';
		$l_backtrace = array_reverse($l_backtrace);
		foreach ($l_backtrace as $l_row)
		{
			if ($l_row['function'] == 'showBacktrace')
			{
				continue;
			}
			$l_row = array_merge($l_default, $l_row);

			$l_row['file'] = dirname($l_row['file']).DIRECTORY_SEPARATOR.'<b>'.basename($l_row['file']).'</b>';

			echo '<span class="txt_normal_schwarz">
'.$l_row['file'].':<b>'.$l_row['line'].'</b> ('.$l_row['class'].$l_row['type'].$l_row['function'].')</span>';
		}

		$content = ob_get_clean();

		if ($return_result)
		{
			return '<pre>'.$content.'<pre>';
		}

		echo '<pre style="padding:0px;margin:3px 0px;font-size:11px;">'.$content.'</pre><hr style="padding:0px;margin:0px;" />';

		return;
	}



	function showEnvironment($returnHtml = false)
	{
		if ( ! MC_DEBUG) { return ''; }

		global $U;

		$strHtml = '
<style>
#environment.hide {
	height: 20px;
	overflow: hidden;
}
#environment.show {
}
#environment.hide a.show { display: inline; }
#environment.hide a.hide { display: none; }
#environment.show a.show { display: none; }
#environment.show a.hide { display: inline; }

.evironment-head,
.evironment-name,
.evironment-value {
	font-size: 12px;
	font-family: verdana, arial, helvetica, serif;
}
.evironment-head {
	font-weight: bold;
	background-color: #DDDDDD;
}
.evironment-name {
	background-color: #E5E5E5;
}
.evironment-value {
	background-color: #EEEEEE;
}

.evironment-value table td {
	font-size: 11px;
	font-family: verdana, arial, helvetica, serif;
}

</style>

<div id="environment" class="hide">
<h5>
	Environment &nbsp;
	<a href="#" class="show" onclick="document.getElementById(\'environment\').className=\'show\';">show &gt;&gt;&gt;</a>
	<a href="#" class="hide" onclick="document.getElementById(\'environment\').className=\'hide\';">&lt;&lt;&lt; hide</a>
</h5>
<table cellpadding="3" cellspacing="2">';


		// update environment START

		$strHtml .= '
	<tr><td colspan="2" class="evironment-head">Update Framework</tr>
	<tr>
		<td class="evironment-name">update path</td>
		<td class="evironment-value">
			' . MCP_PATH . ' <i>(files are executed here)</i>
		</td>
	</tr>
	<tr>
		<td class="evironment-name">original path</td>
		<td class="evironment-value">
			' . dirname(dirname(__FILE__)) . ' <i>(this is where the files are coming from)</i>
		</td>
	</tr>';

		// update environment END


		// platform environment START

		$incPath = ini_get("include_path");
		$incPath = str_replace(PATH_SEPARATOR, '<br>' . PATH_SEPARATOR, $incPath);

		$strHtml .= '
	<tr><td colspan="2" class="evironment-head">Plattform</tr>
	<tr>
		<td class="evironment-name">base path</td>
		<td class="evironment-value">' . MC_BASE_DIR . '</td>
	</tr>
	<tr>
		<td class="evironment-name">base uri</td>
		<td class="evironment-value">' . MC_URL . '</td>
	</tr>
	<tr>
		<td class="evironment-name">include path</td>
		<td class="evironment-value">' . $incPath . '</td>
	</tr>';

		// platform environment END


		// database environment START

		$strHtml .= '
	<tr><td colspan="2" class="evironment-head">Database</tr>
	<tr>
		<td class="evironment-name">Name</td>
		<td class="evironment-value">' . MC_DBNAME . '</td>
	</tr>
	<tr>
		<td class="evironment-name">Settings</td>
		<td class="evironment-value">
			<table cellpadding="3" cellspacing="0">
				<tr>
					<td colspan="3">
						<i>configure list of parameters in ' . __FILE__ . ':line ' . __LINE__ . '</i>
					</td>
				</tr>';

		$dbVariables = $U->DB->query('show variables');

		$displayedVariables = array(
			'character_set_client',
			'character_set_connection',
			'character_set_database',
			'character_set_results',
			'character_set_server',
			'character_set_system',
			'general_log',
			'general_log_file',
			'read_only',
			'slow_query_log',
			'slow_query_log_file',
			'socket',
			'storage_engine',
			'table_type',
			'version',
			'version_comment',
		);

		while (list($varName, $value) = $dbVariables->fetchRow())
		{
			if (in_array($varName, $displayedVariables)) {
				$strHtml .= '
				<tr><td>' . $varName . '</td><td>:</td><td>' . $value . '</td></tr>'; }
		} // end while

		$dbVariables->free();

		$strHtml .= '
			</table>
		</td>
	</tr>';

		// database environment END


		$strHtml .= '
</table>
</div>';

		if ($returnHtml) {
			return $strHtml;
		}

		echo $strHtml;

		return true;
	}



}



/**
 *
 */
function dump(&$param)
{
	ob_start();
	$l_backtrace = debug_backtrace();
	echo ' from '.$l_backtrace[0]['file'].':'.$l_backtrace[0]['line'].'<br />';
	$header = ob_get_clean();

	ob_start();
	var_dump($param);
	$content = ob_get_clean();

	echo '<pre style="padding:0px;margin:3px 0px;font-size:11px;">'.$header.$content.'</pre><hr style="padding:0px;margin:0px;" />';

	return;
}



/**
 *
 */
function out($param = "")
{
	ob_start();

	$l_backtrace = debug_backtrace();
	echo ' from '.$l_backtrace[0]['file'].':'.$l_backtrace[0]['line'].'<br />';

	if (is_array($param) == true)
	{
		$param = implode("<br>", $param);
	}
	echo $param;

	$content = ob_get_clean();

	echo '<pre style="padding:0px;margin:3px 0px;font-size:11px;">'.$content.'</pre><hr style="padding:0px;margin:0px;" />';

	return;
}



/**
 *
 */
function startTimer($name)
{
	if (empty($name) ) {
		echo '<br>WARNING ' . __METHOD__ . ": parameter name is empty<br>";
	}
	else if ( empty($GLOBALS[$name]) ) {
		$GLOBALS[$name] = microtime(true);
	}
	else {
		echo '<br>WARNING ' . __METHOD__ . ": timer '{$name}' already exists!<br>";
	}
}



/**
 *
 */
function getTimer($name, $deleteTimer = false)
{
	if ( empty($GLOBALS[$name]) )
	{
		return '<br>WARNING ' . __METHOD__ . ": timer '{$name}' does not exist!<br>";
	}

	$microtimeStart = $GLOBALS[$name];
	$microtimeEnd = microtime(true);
	$microRunTime = $microtimeEnd - $microtimeStart;

	if ($deleteTimer) {
		deleteTimer($name);
	}

	return $microRunTime;
}



/**
 *
 */
function displayTimer($name, $deleteTimer = false)
{
	$microRunTime = getTimer($name, $deleteTimer);
	echo "<br>timer '{$name}' : {$microRunTime}<br>";
}



/**
 *
 */
function deleteTimer($name)
{
	if ( empty($GLOBALS[$name]) )
	{
		return '<br>WARNING ' . __METHOD__ . ": timer {$name} does not exist!<br>";
	}

	unset($GLOBALS[$name]);
}



/**
 *
 */
function getRunTime()
{
	$microRunTime = microtime(true) - $_SERVER['REQUEST_TIME_FLOAT'];
	return $microRunTime;
}



/**
 *
 */
function displayRunTime()
{
	$msgPrefix = ""; // preset, returned by reference
	if ( ! mc_Debug::isEnabled($msgPrefix) )
	{
		return '';
	}

	$runTime = getRunTime();

	echo <<<RUNTIME
{$msgPrefix}<hr />
<center style="font-family:verdana; font-size:9px;">
	code generated in {$runTime} sec
</center>
RUNTIME;
}



/**
 *
 */
function mc_exception_handler ($e)
{
	include_once(MCP_DEBUG_PATH.'ErrorHandler.php');
	mc_ErrorHandler::handle($e);
}

set_exception_handler('mc_exception_handler');

