<?php
/*
* $McLicense$
*
* $Id$
*
*/


class mc_ErrorHandler
{

/*
Wert	Konstante		Beschreibung			Bemerkung

1	E_ERROR			Fatale Laufzeit-Fehler. 	Zeigt nicht behebbare Fehler an (bspw. Probleme bei
								Speicherzuweisung). Ausführung des Skripts wird abgebrochen.
2	E_WARNING		Warnungen (no fatal errors)	Skript wird nicht abgebrochen.
				zur Laufzeit des Skripts.
4	E_PARSE			Parser-Fehler während		Parser-Fehler können nur vom Parser erzeugt werden.
				der Übersetzung.
8	E_NOTICE		Benachrichtigungen		Im Skript wurde irgend etwas gefunden, was einen Fehler
				während der Laufzeit. 		verursachen könnte. Möglicherweise aber auch reguläre
								Benachrichtigungen im ordnungsgemäßen Skriptablauf.
16	E_CORE_ERROR		Fatale Fehler, die beim 	Diese sind ähnlich wie E_ERROR, nur dass diese Fehler-
				Starten von PHP auftreten. 	meldungen vom PHP-Kern erzeugt werden. nur in PHP 4
32	E_CORE_WARNING	 	Warnungen (no fatal errors), 	Diese sind ähnlich wie E_WARNING, nur dass diese
				die beim PHP-Start auftreten. 	Warnungen vom PHP-Kern erzeugt werden. nur in PHP 4
64	E_COMPILE_ERROR		Fatale Fehler zur 		Diese sind ähnlich wie E_ERROR, allerdings von der
				Übersetzungszeit. 		Zend Scripting Engine erzeugt.         nur in PHP 4
128	E_COMPILE_WARNING	Warnungen zur 			Diese sind ähnlich wie E_WARNING, allerdings von der
				Übersetzungszeit. 		Zend Scripting Engine erzeugt.         nur in PHP 4
256	E_USER_ERROR		Benutzerdefinierte 		Diese sind ähnlich wie E_ERROR, werden jedoch im
				Fehlermeldungen. 		PHP-Code mit trigger_error() erzeugt.  nur in PHP 4
512	E_USER_WARNING		Benutzerdefinierte 		Diese sind ähnlich wie E_WARNING, werden jedoch im
				Warnungen.			PHP-Code mit trigger_error() erzeugt.  nur in PHP 4
1024	E_USER_NOTICE		Benutzerdefinierte 		Diese sind ähnlich wie E_NOTICE, werden jedoch im
				Benachrichtigung. 		PHP-Code mit trigger_error() erzeugt.  nur in PHP 4
-
2047	E_ALL			Alle Fehler und Warnungen die unterstützt werden, mit Ausnahme von E_STRICT.
-
2048	E_STRICT (integer) 	Benachrichtigungen des		Vorschläge von PHP für Änderungen des Programmcodes, um
				Laufzeitsystems.		bestmögliche Interoperabilität & zukünftige Kompatibilität
								des Codes zu gewährleisten.            nur in PHP 5
*/

	public static function handle($p_err, $p_err_msg = '')
	{
		$l_buffer = @ob_get_clean();

		if (is_object($p_err) && $p_err instanceof mc_Exception)
		{
			$l_backtrace = $p_err->getBackTrace();
		}
		else
		{
			$l_backtrace = debug_backtrace();
		}
		$l_backtrace = array_reverse($l_backtrace);
		$l_default_stage = array(
			'class'  => '',
			'type'   => '',
			'object' => '',
			'args'   => '',
			'file'   => '',
			'line'   => '',
		);
		$l_temp = '';
		$l_list = array();
		$l_id_count = 0;
		foreach ($l_backtrace as $l_stage)
		{
			if ($l_stage['function'] == 'handle')
			{
				continue;
			}

			$l_row = array_merge($l_default_stage, $l_stage);

			$l_temp .= '
<table style="font-size:.8em;">
	<tr><td valign="top">location : </td><td valign="top">line <b>'.$l_row['line'].'</b> in file <b>'.$l_row['file'].'</b></td></tr>
	<tr><td valign="top">calling : </td><td valign="top">'.$l_row['class'].$l_row['type'].$l_row['function'].'</td></tr>';

			if ($l_row['function'] == 'error')
			{
				$l_temp .= '
	<tr><td valign="top">with error : </td><td valign="top">{PARSED_ERROR}</td></tr>
</table>';
			}
			else
			{
				foreach ($l_row['args'] as $idx => $arg)
				{
					if (is_object($arg)) { $l_row['args'][$idx] = 'object '.get_class($arg); }
				}
				$l_id = 'args_'.$l_id_count;
				$l_list[] = $l_row['file'].':'.$l_row['line'].' ('.$l_row['class'].$l_row['type'].$l_row['function'].')';
				$l_temp .= '
	<tr>
		<td valign="top">with arguments : </td>
		<td valign="top">
			<a href="javascript:void(0);" onclick="'."switchArgList(this, '".$l_id."')".'">show argument list</a><br>
			<pre id="'.$l_id.'" style="display:none;">'.htmlentities(print_r($l_row['args'], true)).'</pre>
		</td>
	</tr>
</table>
<hr />';
			}
			$l_id_count++;
		}

		$l_location = '
	executing file <b>'.str_replace(MC_ROOT_PATH, MC_ROOT_URI, $l_row['file']).'</b>, line <b>'.$l_row['line'].'</b>';


		$l_backtrace = '<b>BACKTRACE DETAILS</b> (top =&gt; bottom)<br><p>'.$l_temp.'</p>';

		$l_msg = '';
		$p_err_result = '';

		if (is_object($p_err))
		{
			if ($p_err instanceof Exception)
			{
				if (empty($p_err_msg))
				{
					$p_err_msg = $p_err->getMessage();
				}

				if (method_exists(get_class($p_err), 'handle'))
				{
					$p_err->handle();
				}

				switch(get_class($p_err))
				{
					case 'SoapFault' :
						die("case 'SoapFault' is not supported in ".__FILE__.':'.__LINE__);

					default :
						if (method_exists($p_err, 'getErrorObject'))
						{
							$p_err = $p_err->getErrorObject();
						}
						else if (method_exists($p_err, 'getPrevious'))
						{
							$p_err = $p_err->getPrevious();
						}
						break;
				}
			} // if ($p_err instanceof Exception)

			if (is_object($p_err))
			{
				if (method_exists($p_err, "getDebugInfo"))
				{
					if ($p_err->getDebugInfo() != $p_err_msg)
					{
						$p_err_result .= '<b>RESULT=> DEBUG_INFO:</b><div class="err_debug">'.$p_err->getDebugInfo().'</div>';
					}
				}

				if (method_exists($p_err, "getMessage"))
				{
					$p_err_result .= '<b>RESULT=> MESSAGE:</b><div class="err_msg">'.$p_err->getMessage().'</div>';
				}

				if (method_exists($p_err, "getCode"))
				{
					$p_err_result .= '<b>RESULT=> CODE:</b> '.$p_err->getCode().'<br />';
				}
			}
		}

		if (empty($p_err_msg))
		{
			$l_msg .= '<div class="err_empty">no query/msg details given: (parameter is empty)</div>';
		}
		else
		{
			$l_msg .= '<b>QUERY/MSG:</b><div class="err_debug">'.$p_err_msg.'</div>';
		}

		$l_msg .= $p_err_result;

		if ($p_err === null)
		{
			$l_msg .= '<div style="err_empty">no error details given: (parameter is <b>NULL</b>)</div><div id="errdump" class="err_dump">'.$l_backtrace.'</div>';
			$l_parsed_error = 'NULL';
		}
		else
		{
			$l_msg .= '<b>RESULT=> <a href="#" onclick="var ed=document.getElementById(\'errdump\').style;if(ed.display==\'none\'){ed.display=\'block\';firstChild.data=\'hide DUMP\';}else{ed.display=\'none\';firstChild.data=\'show DUMP\';}">show DUMP</a></b><div id="errdump" style="display:none;" class="err_dump">'.$l_backtrace.'</div>';

			ob_start();
			var_dump($p_err);
			$l_err_dump = ob_get_clean();

			$l_parsed_error = '<pre>'.$l_err_dump.'</pre>';
		}

		echo '
<!-- /><!-- -->
<style type="text/css">
div {
	margin:5px;
	padding:5px;
	font-family:verdana,arial,helvetica,serif;
	font-size:11px;
}
div.err_all {
	border:solid 2px #0000A0;
}
div.err_title {
	color:#A00000;
}
div.err_debug, div.err_user, div.err_msg, div.err_dump {
background-color:#E0E0E0;
}
div.err_dump {
	font-family:courier,helvetica,serif;
}
div.err_dump pre {
	font-size:12px;
}
</style>
<script type="text/javascript">
<!--
	function switchArgList(self, args_id)
	{
		var obj = document.getElementById(args_id);
		if (obj.style.display == "none")
		{
			obj.style.display = "block";
			self.firstChild.data = "hide argument list";
		}
		else
		{
			obj.style.display = "none";
			self.firstChild.data = "show argument list";
		}
	}
//-->
</script>
<div class="err_all">
	<div class="err_title">
		Error in file <b>'.$_SERVER["PHP_SELF"].'</b><p />'.$l_location.'<p />
  	buffer : '.(($l_buffer === false) ? "NOT active" : "ACTIVE").'
	</div>
	<div style="margin-top:0px;">
	<b>SHORT BACKTRACE</b> (bottom =&gt; top) :<br>
'.implode("<br>\n", array_reverse($l_list)).'
	</div>
	<hr />
'.str_replace('{PARSED_ERROR}', $l_parsed_error, $l_msg).'
</div>
';

		switch(true)
		{
			case ($l_buffer === false) :
				// no buffer at all
				break;

			case (empty($l_buffer)) :
				// buffer running but empty
				ob_start();
				break;

			default :
				// buffer running and with content
				echo '<hr>'
					.'buffer content:'
					.'<div style="width:98%;height:200px;overflow:scroll;background-color:#F0F0F0;border:2px inset black;">'
					.nl2br(htmlentities($l_buffer))
					.'</div>'
				;
				ob_start();
				echo $l_buffer;
				break;
		}

		die();
	}


}

