<?php
/*
* $McLicense$
*
* $Id$
*
*/

/*
look for further information at http://de.php.net/manual/en/spl.exceptions.php
*/


class mc_Exception
	extends Exception
{
	/**
	 * error object
	 */
	var $err_object;



	/**
	 * for backwards compatibility: previous exception (or null)
	 */
	var $bc_previous;



	/**
	 * constructor
	 */
	public function __construct($object, $message, $code = 0, $previous = null)
	{
		parent::__construct($message, $code);

		if ($previous instanceof Exception)
		{
  		$this->bc_previous = $previous;
		}
		else
		{
		  $this->bc_previous = null;
		}

		$this->err_object = $object;
	} // end constructor



	/**
	 * getErrorObject
	 */
	public function getErrorObject()
	{
		return $this->err_object;
	} // end method getErrorObject



	/**
	 * getPrevious
	 */
	public function getPrevious()
	{
		return $this->bc_previous;
	} // end method getPrevious



	/**
	 * getBackTrace
	 */
	public function getBackTrace()
	{
		return $this->getTrace();
	} // end method getBackTrace


} // end class mc_Exception

