<?php
/*
* $McLicense$
*
* $Id$
*
*/


class mc_Error
{
	protected $name;

	protected $obj;

	protected $msg;

	/**
	 * constructor
	 */
	public function __construct($p_obj, $p_msg = null, $p_name = null)
	{
		$this->id     = 1;
		$this->cat_id = 1;
		$this->obj    = $p_obj;
		$this->msg    = $p_msg;
		$this->name   = $p_name;
//		$this->bt     = debug_backtrace();

		$this->bt = array();

		switch(true)
		{
			case method_exists($p_obj, 'getTrace') :
				break;

			case method_exists($p_obj, 'getBackTrace') :
				break;

			default :
				foreach(debug_backtrace() as $trace)
				{
					if ( !empty($trace['file']) && $trace['file'] == MCP_LIB_PATH.'Debug.class.php')
					{
						continue;
					}
					$this->bt[] = $trace;
				}
				break;
		}

		if ( empty($p_name) )
		{
			return;
		}

		$Sql = 'select'
			.' ERROR_ID'
			.', ERROR_ERRORCAT_ID'
			.' from ERROR'
			.' where ERROR_NAME = '.$U->DB->quote($p_name, 'text', true);

		global $U;
		$row = $U->DB->getRow();

		if ( empty($row) )
		{
			return;
		}

		$this->id     = intval($row[0]);
		$this->cat_id = intval($row[1]);

		return;
	} // end constructor

	function getId()
	{
		return $this->id;
	}

	function getCatId()
	{
		return $this->cat_id;
	}

	function getName()
	{
		return $this->name;
	}

	function getMessage()
	{
		return $this->msg;
	}

	function getObject()
	{
		return $this->obj;
	}

	function getBacktrace()
	{
		if (method_exists($this->obj, 'getTrace'))
		{
			return $this->obj->getTrace();
		}

		if (method_exists($this->obj, 'getBackTrace'))
		{
			return $this->obj->getBackTrace();
		}

		return $this->bt;
	}

} // end class mcp_Error

