<?php
/*
* $McLicense$
*
* $Id$
*
*/


/**
 * MpsParser
 *
 * @author [Autor]
 * @version 1.0
 */
class MpsParser
{

	var $str_filename;

	var $arr_replace;

	var $DBStruct;


	/**
	*
	*/
	function __construct($filename = null)
	{
		global $U;

		$this->DB       = &$U->DB;
		$this->DBStruct = &$U->DBStruct;

		$appId = $U->Session->getApp();
		$filename = trim($filename);
		if ( ! $this->init($filename, $appId) )
		{
			throw new Exception("error on MpsParser::init('$filename')");
		}
	}



	/**
	*
	*/
	function init($filename, $appId)
	{
		$this->arr_replace = array(
			'%APP_IDENT%'   => $appId,
			'%MC_BASE_DIR%' => MC_BASE_DIR,
			'%MC_URL%'      => MC_URL,
			'%MC_BASE_URI%' => MC_BASE_URI,
			// deprecated token
			'%MC_ROOT_PATH%' => MC_BASE_DIR,
			'%MC_PATH%'      => MC_BASE_URI,
			'%MC_ROOT_URI%'  => MC_URL,
			'%MC_URI%'       => MC_URL,
		);

		if ( empty($filename) )
		{
			return true;
		}

		if (file_exists($filename) )
		{
			$this->str_filename = $filename;
			return true;
		}

		SysMsg::showError('file "'.$filename.'" NOT found!');
		return false;
	}


	function setReplaceString($pattern, $replace)
	{
		if ($pattern === '')
		{
			throw new Exception('cannot use empty strings as replace pattern');
		}

		if ($pattern === null)
		{
			throw new Exception('cannot use NULL as replace pattern');
		}

		$this->arr_replace[$pattern] = $replace;
		return true;
	}


	function setReplaceArray($arrReplace)
	{
		if ( ! is_array($arrReplace) )
		{
			$msg = 'parameter is not an array: '.print_r($arrReplace, TRUE);
			throw new Exception($msg);
		}

		$arrPattern = array_keys($arrReplace);
		if (in_array("", $arrPattern, true) )
		{
			$msg = 'array keys contain empty strings which can not be used as replace pattern: '.print_r($arrReplace, TRUE);
			throw new Exception($msg);
		}

		$this->arr_replace = array_merge($this->arr_replace, $arrReplace);
		return true;
	}



	function execute($p_string = null)
	{
		if ($this->str_filename)
		{
			SysMsg::showMsg('executing MPS file "'.$this->str_filename.'"...');
			$l_string = trim(file_get_contents($this->str_filename));
			clearstatcache();
		}
		else
		{
			$l_string = &$p_string;
		}

		if (empty($l_string) )
		{
			throw new Exception("filename is empty (value: '{$this->str_filename}')");
		}

		$l_string = $this->replace($l_string, $this->arr_replace);

		$l_arr_MpsItems = array();

		$l_arr_tables = array();
		$l_tables_pattern = '!\<mpstable\s*name="([\w]+)"[^>]*\>(.+)\<\/mpstable\>!Usi';
		preg_match_all($l_tables_pattern, $l_string, $l_arr_tables);

		if (count($l_arr_tables[1]) == 0)
		{
			$l_arr_table = array();
			$l_table_pattern = '!\<mpstable\s*name="([\w]+)"\s*\/\>!Usi';
			preg_match_all($l_table_pattern, $l_string, $l_arr_table);

			$l_arr_tables = $l_arr_table;
			$l_arr_tables[2][0] = $l_string;
		}

		if (empty($l_arr_tables) )
		{
			throw new Exception('no match found for table pattern. need table name to check for existing rows!');
		}

		$l_key_pattern    = '!\<mpskey\s*value="([\S]*)"\s*separator="([\S]*)"\s*\/\>!Usi';
		$l_maps_pattern   = '!\<mpsmap\s*(?:value|name)="([\w:%_-]+)"\s*\/\>!Usi';
		$l_auto_pattern   = '!\<mpsauto\s*field="(\w+)"\s*method="(\w*)"\s*\/\>!Usi';
		$l_req_pattern    = '!\<mpsrequire\s*table="(\w+)"\s*fields="(\w*)"\s*\/\>!Usi';
		$l_items_pattern  = '!\<mpsitem([^>]*)\>(.+)\<\/mpsitem\>!Usi';
		$l_create_pattern = '!\<mpscreate([^>]*)\>(.+)\<\/mpscreate\>!Usi';
		$l_drop_pattern   = '!\<mpsdrop\s*\/\>!Usi';

		$l_items_action_pattern = '!action="(\w*)"!i';
		$l_items_key_pattern    = '!key="([^"]*)"!i';
		$l_items_desc_pattern   = '!desc="([^"]*)"!i';
		$l_items_token_pattern  = '!idtoken="([a-zA-Z0-9_\-\(\)]{4,128})"!i';
		$l_items_stop_pattern   = '!stoponmismatch="([^"]*)"!i';
		$l_items_error_pattern  = '!erroronmismatch="([^"]*)"!i';

		for ($tc = 0; $tc < count($l_arr_tables[1]); $tc++)
		{
			$l_arr_table = array();
			$l_arr_table[0][0] = $l_arr_tables[0][$tc];
			$l_arr_table[1][0] = $l_arr_tables[1][$tc];
			$l_string = $l_arr_tables[2][$tc];

			$l_arr_drop = array();
			preg_match_all($l_drop_pattern, $l_string, $l_arr_drop);

			$l_arr_create = array();
			preg_match_all($l_create_pattern, $l_string, $l_arr_create);

			$l_arr_key = array();
			preg_match_all($l_key_pattern,    $l_string, $l_arr_key);

			if (empty($l_arr_key))
			{
				SysMsg::showError('missing mpskey directive. need key to check for existing rows! process {CANCELED}.');
				throw new Exception('no match found for mpskey pattern "{$l_key_pattern}"');
			}

			$l_arr_maps = array();
			preg_match_all($l_maps_pattern,   $l_string, $l_arr_maps);

			$l_arr_auto = array();
			preg_match_all($l_auto_pattern,   $l_string, $l_arr_auto);

			$l_arr_req  = array();
			preg_match_all($l_req_pattern,  $l_string, $l_arr_req);

			$countReq = count($l_arr_req[0]);
			if ($countReq > 0)
			{
				if (empty($this->DBStruct))
				{
					$this->DBStruct = new DBStruct();
				}

				for ($iReq = 0; $iReq < $countReq; $iReq++)
				{
					$reqTable = trim($l_arr_req[1][$iReq]);
					if ( ! $this->DBStruct->tableExists($reqTable) )
					{
						SysMsg::showWarning('required table "'.$reqTable.'" not found. task {SKIPPED}.');
						continue 2; // for (require), for (tables)
					}
					else
					{
						SysMsg::showMsg('required table "'.$reqTable.'" found.');
					}

					$reqFields = explode(',', $l_arr_req[2][$iReq]);
					foreach($reqFields as $reqField)
					{
						$reqField = trim($reqField);
						if ( ! $this->DBStruct->fieldExistsInTable($reqTable, $reqField) )
						{
							SysMsg::showWarning('required field "'.$reqField.'" not found in table "'.$reqTable.'". task {SKIPPED}.');
							continue 3; // for (reqField) for (reqTab), for (tables)
						}
						else
						{
							SysMsg::showMsg('required field "'.$reqField.'" found.');
						}
					} // end foreach

				} // end for

			} // end if

			$l_arr_items = array();
			preg_match_all($l_items_pattern,  $l_string, $l_arr_items);

			$l_str_table = $l_arr_table[1][0];
			unset($l_arr_table);

			// drop table
			if ( ! empty($l_arr_drop[0]) )
			{
				if ( ! $this->DBStruct->tableExists($l_str_table) )
				{
					SysMsg::showMsg('table '.$l_str_table.' does not exists (drop skipped).');
					continue;
				}

				try
				{
					// $l_arr_create[1][0] may be used for attributes
					$this->DB->query('drop table `'.$l_str_table.'`');
					SysMsg::showInfo('dropping table '.$l_str_table.' {SUCCEEDED}.');
				}
				catch (Exception $e)
				{
					SysMsg::showError('dropping table '.$l_str_table.' {FAILED}. process {CANCELED}.');
					throw $e;
				}

				$this->DBStruct->refresh();
			}


			// no create statement available
			if ( $this->DBStruct->tableExists($l_str_table) )
			{
				if (empty($l_arr_create[0]) )
				{
					SysMsg::showMsg('table '.$l_str_table.' exists.');
				}
				else
				{
					SysMsg::showMsg('table '.$l_str_table.' exists (create skipped).');
				}
			}
			else
			{
				if (empty($l_arr_create[0]) )
				{
					$msg = 'table '.$l_str_table.' does not exist! no create statement found. process {CANCELED}.';
					SysMsg::showError($msg);
					throw new Exception($msg);
				}

				try
				{
					// $l_arr_create[1][0] may be used for attributes
					$this->DB->query(
						'create table if not exists `'.$l_str_table.'` '.$l_arr_create[2][0]
					);
					SysMsg::showInfo('creating table '.$l_str_table.' {SUCCEEDED}.');
				}
				catch (Exception $e)
				{
					SysMsg::showError('creating table '.$l_str_table.' {FAILED}. process {CANCELED}.');
					throw $e;
				}

				$this->DBStruct->refresh();
			}
			
			if (empty($l_arr_items[0]) )
			{
//				SysMsg::showInfo('no items found. continue with next table statement.');
				continue;
			}
			else
			{
//				SysMsg::showMsg('items found. now processing...');
			}

			$l_str_key = empty($l_arr_key[1]) ? '### no key defined ###' : $l_arr_key[1][0];
			$l_str_sep = empty($l_arr_key[2]) ? '@@@@@@@@@@@@@@@@@@@@@@' : $l_arr_key[2][0];
			unset($l_arr_key);

			if (empty($l_str_sep) == false)
			{
				$l_arr_key_cols = explode($l_str_sep, $l_str_key);
			}
			else
			{
				$l_arr_key_cols = array($l_str_key);
			}

			$l_arr_methods = array();
			if (empty($l_arr_auto[0]) == false)
			{
				foreach ($l_arr_auto[1] as $id => $key)
				{
					$l_arr_methods[$l_arr_auto[2][$id]][] = $key;
				}
			}

			if (count($l_arr_maps[0]) > 0)
			{
				include_once(MCP_LIB_PATH.'core/PMap.php');
				$l_PMap = new PMap();

				foreach($l_arr_maps[1] as $l_col_name)
				{
					$l_params = explode(':', $l_col_name.':');
					$map = $l_PMap->getMapByColName($l_params[0], $l_params[1]);
					if ( ! is_array($map) )
					{
						throw new Exception("MpsParser::addReplaceArray failed: no map found for MpsParser::getMapByColName({$l_params[0]}, {$l_params[1]})");
					}
					$this->addReplaceArray($map);
				}
			}

			unset($l_arr_maps);

			$query = 'select VIEW_IDENT from TAB, VIEW'
				.' where TAB_NAME = '.$this->DB->quote($l_str_table, 'TEXT')
				.' and VIEW_TAB_IDENT = TAB_IDENT'
			;
			$tabIdent = $this->DB->getOne($query);
			if ($tabIdent)
			{
				include_once(MCP_LIB_PATH.'DsAccess.php');
				$dsaccess = new DsAccess();
			}
			else
			{
				$dsaccess = null;
			}

			SysMsg::showMsg('(using key '.$l_str_key.' for record identification)');

			$l_item_count = count($l_arr_items[0]);

			for($i2 = 0; $i2 < $l_item_count; $i2++)
			{
				$l_item_attributes = $l_arr_items[1][$i2];

				preg_match($l_items_action_pattern, $l_item_attributes, $l_arr_items_act);
				preg_match($l_items_key_pattern,    $l_item_attributes, $l_arr_items_key);
				preg_match($l_items_desc_pattern,   $l_item_attributes, $l_arr_items_des);
				preg_match($l_items_token_pattern,  $l_item_attributes, $l_arr_items_tok);
				preg_match($l_items_stop_pattern,   $l_item_attributes, $l_arr_items_stp);
				preg_match($l_items_error_pattern,  $l_item_attributes, $l_arr_items_err);

				$l_instruction  = $l_arr_items[2][$i2];
				$l_action = (empty($l_arr_items_act)) ? '' : trim($l_arr_items_act[1]);
				$l_key    = (empty($l_arr_items_key)) ? '' : trim($l_arr_items_key[1]);
				$l_desc   = (empty($l_arr_items_des)) ? '' : trim($l_arr_items_des[1]);
				$l_token  = (empty($l_arr_items_tok)) ? '%%' : '%'.trim($l_arr_items_tok[1]).'%';
				$l_stop   = (empty($l_arr_items_stp)) ? '' : trim($l_arr_items_stp[1]);
				$l_error  = (empty($l_arr_items_err)) ? '' : trim($l_arr_items_err[1]);

 				#$l_arr_items[0][$i2] = full item match;
				$l_arr_items[1][$i2] = $l_action;
				$l_arr_items[2][$i2] = $l_key;
 				#$l_arr_items[3][$i2] = deprecated;
				$l_arr_items[4][$i2] = $l_desc;
				$l_arr_items[5][$i2] = $l_instruction;
				#$l_arr_items[6][$i2] = deprecated;
				$l_arr_items[7][$i2] = $l_token;
				$l_arr_items[8][$i2] = $l_stop;
				$l_arr_items[9][$i2] = $l_error;

				if ($l_desc)
				{
					SysMsg::showNote($l_desc);
				}

				switch($l_action)
				{
					case 'insert_by_user' :
						$query = 'select distinct USER_IDENT'
							.' from USER'
							.' where STATE != "T" and USER_IDENT is not NULL and USER_IDENT > 0'
						;
						$l_res_user = $this->DB->getCol($query);
						foreach($l_res_user as $l_user_ident)
						{
							$this->addReplaceString('%USER_IDENT%', intval($l_user_ident));
							$l_str_key_val = $this->replace($l_arr_items[2][$i2], $this->arr_replace);

							if (strpos($this->replace($l_stop, $this->arr_replace), '%') !== false)
							{
								SysMsg::showWarning('cannot solve stop-token "'.$l_stop.'" : file {SKIPPED} ! (requested)');
								return true;
							}

							if (strpos($l_str_key_val, '%') !== false)
							{
								SysMsg::showWarning('cannot solve token "'.$l_str_key_val.'" : item {SKIPPED} ! (token is not available)');
								continue;
							}

							//$l_arr_MpsItems[] = array(
							$insid = $this->parseItem($l_arr_key_cols, array(
								#'match' => $l_arr_items[0][$i],
								'table'  => $l_str_table,
								'action' => 'insert',
								'key'    => $l_str_key_val,
								'sep'    => $l_str_sep,
								'desc'   => trim($l_arr_items[4][$i2]),
								'query'  => $this->replace($l_arr_items[5][$i2], $this->arr_replace),
								'methods'	 => $l_arr_methods,
								'dsaccess' => $dsaccess,
								'stop'   => null,
							));
						} // end foreach
						break;

					case 'insert_by_room' :
						$query = 'select COURSE_ID from COURSE where STATE != "T" and COURSE_ID not in (2, 3)';
						$l_res_room = $this->DB->getCol($query);
						foreach($l_res_room as $l_room_id)
						{
							$l_room_id = intval($l_room_id);
							$this->addReplaceString('%COURSE_ID%', $l_room_id); // @deprecated token
							$this->addReplaceString('%ROOM_ID%',   $l_room_id);
							$l_str_key_val = $this->replace($l_arr_items[2][$i2], $this->arr_replace);

							if (strpos($this->replace($l_stop, $this->arr_replace), '%') !== false)
							{
								SysMsg::showWarning('cannot solve stop-token "'.$l_stop.'" : file {SKIPPED} ! (requested)');
								return true;
							}

							if (strpos($l_str_key_val, '%') !== false)
							{
								SysMsg::showWarning('cannot solve token "'.$l_str_key_val.'" : item {SKIPPED} ! (token is not available)');
								continue;
							}

							//$l_arr_MpsItems[] = array(
							$insid = $this->parseItem($l_arr_key_cols, array(
								#'match' => $l_arr_items[0][$i],
								'table'  => $l_str_table,
								'action' => 'insert',
								'key'    => $l_str_key_val,
								'sep'    => $l_str_sep,
								'desc'   => trim($l_arr_items[4][$i2]),
								'query'  => $this->replace($l_arr_items[5][$i2], $this->arr_replace),
								'methods'	 => $l_arr_methods,
								'dsaccess' => $dsaccess,
								'stop'   => null,
							));
						} // end foreach
						break;

					case 'insert_by_template_room' :
						$query = 'select ROOM_TYPE_IDENT'
							.' from ROOM_TYPE'
							.' where STATE != "T"'
							.' and ROOM_TYPE_IDENT is not null and ROOM_TYPE_IDENT > 0'
						;
						$l_res_tmpl_room = $this->DB->getCol($query);
						foreach($l_res_tmpl_room as $l_tmpl_room_id)
						{
							$this->addReplaceString('%TMPL_ROOM_ID%', intval($l_tmpl_room_id));
							$l_str_key_val = $this->replace($l_arr_items[2][$i2], $this->arr_replace);

							if (strpos($this->replace($l_stop, $this->arr_replace), '%') !== false)
							{
								SysMsg::showWarning('cannot solve stop-token "'.$l_stop.'" : file {SKIPPED} ! (requested)');
								return true;
							}

							if (strpos($l_str_key_val, '%') !== false)
							{
								SysMsg::showWarning('cannot solve token "'.$l_str_key_val.'" : item {SKIPPED} ! (token is not available)');
								continue;
							}

							//$l_arr_MpsItems[] = array(
							$insid = $this->parseItem($l_arr_key_cols, array(
								#'match' => $l_arr_items[0][$i],
								'table'  => $l_str_table,
								'action' => 'insert',
								'key'    => $l_str_key_val,
								'sep'    => $l_str_sep,
								'desc'   => trim($l_arr_items[4][$i2]),
								'query'  => $this->replace($l_arr_items[5][$i2], $this->arr_replace),
								'methods'	 => $l_arr_methods,
								'dsaccess' => $dsaccess,
								'stop'   => null,
							));
						} // end foreach
						break;

					default:
						if (strpos($this->replace($l_stop, $this->arr_replace), '%') !== false)
						{
							SysMsg::showWarning('cannot solve stop-token "'.$l_stop.'" : file {SKIPPED} ! (requested)');
							return true;
						}

						$l_str_key_val = $this->replace($l_arr_items[2][$i2], $this->arr_replace);

						if (strpos($l_str_key_val, '%') !== false)
						{
							SysMsg::showWarning('cannot solve token "'.$l_str_key_val.'" : item {SKIPPED} ! (token is not available)');
							break;
						}

						//$l_arr_MpsItems[] = array(
						$insid = $this->parseItem($l_arr_key_cols, array(
							#'match' => $l_arr_items[0][$i],
							'table'  => $l_str_table,
							'action' => $l_action,
							'key'    => $l_str_key_val,
							'sep'    => $l_str_sep,
							#'desc'  => trim($l_arr_items[4][$i]),
							'query'  => $this->replace($l_arr_items[5][$i2], $this->arr_replace),
							'methods'	 => $l_arr_methods,
							'dsaccess' => $dsaccess,
							'stop'   => $this->replace($l_arr_items[8][$i2], $this->arr_replace),
							'error'  => $this->replace($l_arr_items[9][$i2], $this->arr_replace),
						));

						break;
				} // end switch

				if ($l_token === '%%')
				{
					continue;
				}

				if (isset($this->arr_replace[$l_token]) )
				{
					throw new Exception("token '{$l_token}' is already in use");
				}

				if ( ! empty($insid) )
				{
					$this->addReplaceString($l_token, intval($insid) );
				}

			} // end for

			unset($l_arr_items);
		} // end for

		return true;
	}



	function parseItem($p_key_cols, $p_item)
	{
		if (empty($p_item) )
		{
			throw new Exception('parameter $item is empty!');
		}

		if ( ! is_array($p_item) )
		{
			throw new Exception('parameter $item is not an array!');
		}

		$l_item  = &$p_item;
		$l_table = $l_item['table'];
		$itemQuery = trim($l_item['query']);

		switch($l_item['action'])
		{
			case "getone":
				$val = $this->DB->getOne($itemQuery);
				if (empty($val))
				{
					if ($p_item['error'])
					{
						SysMsg::showError($p_item['error']);
						exit(0);
					}
					if ($p_item['stop'])
					{
						SysMsg::showWarning($p_item['stop']);
						exit(0);
					}
				}
				return $val;
				break;

			case "delete":
				if ( ! $this->checkItem($p_key_cols, $p_item) )
				{
					SysMsg::showInfo('item with unique key "'.$l_item['key'].'" not found : delete {SKIPPED}');
					return true;
				}

				if ($this->DBStruct->fieldExistsInTable($l_table, 'DS_ID') && $l_table != 'DS')
				{
					// try to delete multigroup permissions
					preg_match($l_pattern = '@\s*delete\s*from\s*'.$l_table.'\s*where\s*(.*)@ims', $itemQuery, $l_del_match);
					if ( !empty($l_del_match[1]) )
					{
						if (substr($l_del_match[1], -1) == ';')
						{
							$l_del_match[1] = substr($l_del_match[1], 0, -1);
						}
						$query = "select {$l_table}_ID, DS_ID from {$l_table} where ".$l_del_match[1];
						$l_sub_res = $this->DB->query($query);

						while($l_sub_row = $l_sub_res->fetchRow())
						{
							$query = "delete from {$l_table} where {$l_table}_ID = ".intval($l_sub_row[0]);
							$this->DB->query($query);

							if ( empty($l_sub_row[1]) )
							{
								// ds id is empty
								continue;
							}
							$dsId = intval($l_sub_row[1]);
							$this->DB->query("delete from DS where DS_ID = {$dsId}");
							$this->DB->query("delete from DS_LINK where DS_LINK_SRC_DS_ID  = {$dsId}");
							$this->DB->query("delete from DS_LINK where DS_LINK_DEST_DS_ID = {$dsId}");
							$this->DB->query("delete from DS_ACCESS where DS_ACCESS_DS_ID  = {$dsId}");
						}
					}
				} // end if
				else
				{
					$this->DB->query($itemQuery);
				}

				SysMsg::showInfo('deleting (deprecated) item with unique key "'.$l_item['key'].'" : {SUCCEED}');
				return true;

			case "update":
				if ( ! $this->checkItem($p_key_cols, $p_item) )
				{
					if ($p_item['error'])
					{
						SysMsg::showError($p_item['error']);
						exit(0);
					}
					if ($p_item['stop'])
					{
						SysMsg::showWarning($p_item['stop']);
						exit(0);
					}
					SysMsg::showWarning('updating item with unique key "'.$l_item['key'].'" : {SKIPPED} (item not found)');
					return true;
				}

				$l_res = $this->DB->query($itemQuery);
/*
				$l_affected = DB::affectedRows();
				if ($l_affected == 0)
				{
					SysMsg::showInfo('updating item with unique key "'.$l_item['key'].'" : {SKIPPED} (item was not affected)');
				}
				else
				{
					SysMsg::showInfo('updating item with unique key "'.$l_item['key'].'" : {SUCCEED}');
				}
*/
				if (empty($p_item['key']))
				{
					SysMsg::showInfo('updating items from table "'.$l_table.'" : {SUCCEED}');
				}
				else
				{
					SysMsg::showInfo('updating item "'.$p_item['key'].'" from table "'.$l_table.'" : {SUCCEED}');
				}
				return true;

			case "insert":
				if ($this->checkItem($p_key_cols, $p_item))
				{
					SysMsg::showInfo('item with unique key "'.$l_item['key'].'" already exists : insert {SKIPPED}');
					return true;
				}

				$l_res = $this->DB->query($itemQuery);
				SysMsg::showInfo('creating item with unique key "'.$l_item['key'].'" : {SUCCEED}');

				$l_last_insert_id = $this->DB->getLastInsertId();
				$l_last_insert_id = intval($l_last_insert_id);
				if ($l_item['dsaccess'])
				{
					$l_res = $this->DB->getRow(
						 'select WGROUP, ACCESS, COURSE_ID, VIEW, OWNER'
						.' from '.$l_table
						.' where '.$l_table.'_ID = '.$l_last_insert_id
					);
					$p_room_id = intval($l_res[2]);
					$p_view    = trim($l_res[3]);
					$p_owner   = intval($l_res[4]);
					$p_mgr_access = $l_item['dsaccess']->parseOldAccess($p_room_id, $l_res[0], $l_res[1]);

					$l_item['dsaccess']->createByRessource($l_table, $l_last_insert_id, $p_view, $p_owner, $p_room_id, 0, $p_mgr_access);
				} // end if

				if (empty($l_item['methods']))
				{
					return true;
				}

				foreach($l_item['methods'] as $l_method => $l_fieldlist)
				{
					switch($l_method)
					{
						case 'INS_ID' :
							$query = 'update '.$l_table
								.' set '.implode(' = '.$l_last_insert_id.', ', $l_fieldlist).' = '.$l_last_insert_id
								.' where '.$l_table.'_ID = '.$l_last_insert_id;
							break;

						case 'NEXTIDENT' :
							$query = 'select max('.$l_table.'_IDENT) from '.$l_table;
							$newIdent = $this->DB->getOne($query);
							$newIdent = intval($newIdent) + 1;
							$query = 'update '.$l_table
								.' set '.implode(' = '.$newIdent.', ', $l_fieldlist).' = '.$newIdent
								.' where '.$l_table.'_ID = '.$l_last_insert_id;
							break;

						default :
							throw new Exception("unknown method '{$l_method}'");
					}

					$this->DB->query($query);
				}

				return $l_last_insert_id;

			default :
				throw new Exception("unknown action '{$l_item['action']}'");
		}

		return true;
	}



	function checkItem($p_key_cols, $p_item)
	{
		if (empty($p_item['key']) )
		{
			if ($p_item['action'] == 'update' || $p_item['action'] == 'getone')
			{
				return TRUE;
			}
	
			throw new Exception('an empty item key is only allowed for actions "update" and "getone"! (current action: "'.$p_item['query'].'")');
		}

		if (empty($p_item['sep']) )
		{
		    $l_key_vals = array($p_item['key']);
		}
		else
		{
		    $l_key_vals = explode($p_item['sep'], $p_item['key']);
		}

		if (count($l_key_vals) != count($p_key_cols) )
		{
			$strKeyCols = "'" . implode("', '", $p_key_cols) . "'";
			$strKeyVals = "'" . implode("', '", $l_key_vals) . "'";
		    $msg = "number of required key columns ({$strKeyCols}) does not match number of key values ({$strKeyVals})";
			throw new Exception($msg);
		}

		$l_key_check = array();
		foreach($p_key_cols as $idx => $colname)
		{
			if ($l_key_vals[$idx] === '')
			{
				$l_key_check[] = '('.$colname.' = "" or '.$colname.' is null)';
			}
			else
			{
				$l_key_check[] = $colname.' = "'.$l_key_vals[$idx].'"';
			}
		}

		$l_sel = 'select count(*)'
			.' from '.$p_item['table']
			.' where'
//				.' concat_ws("_", '.implode(', ', $p_key_cols).') = "'.$p_item['key'].'"';
			.' '.implode(' and ', $l_key_check)
		;
		$l_item_exists = $this->DB->getOne($l_sel);

		$l_item_exists = empty($l_item_exists) ? false : true;

		return $l_item_exists;
	}



	private function replace($string, $arrReplace)
	{
		$arrPattern = array_keys($arrReplace);
		return str_replace($arrPattern, $arrReplace, $string);
	}



	// deprecated methods
	function addReplaceString($pattern, $replace) { return $this->setReplaceString($pattern, $replace); }
	function addReplaceArray($array) { return $this->setReplaceArray($array); }



}

