<?php
/*
* $McLicense$
*
* $Id$
*
*/


class Stack
{

	var $stack;
	var $rewrite_on_append;

	function Stack($p_rewrite_on_append = false)
	{
		$this->rewrite_on_append = $p_rewrite_on_append;
		$this->map = array();
		return true;
	}


	function create($p_handle = '') {

		if (empty($p_handle)) {
			$p_handle = md5(microtime());
		}

		if (isSet($this->stack[$p_handle])) {
			SysMsg::showError("stack handle '".$p_handle."' already exists!");
		}

		$this->stack[$p_handle] = array();

		return $p_handle;
	}


	function append($p_handle, $p_param, $p_param_value = null) {

		if (!$this->checkHandle($p_handle)) {
			return false;
		}

		if (is_array($p_param)) {
			while (list($l_key, $l_val) = each($p_param)) {
				if ( $this->rewrite_on_append == false && $this->paramExists($p_handle, $l_key) ) {
					SysMsg::showError("Error on APPEND : param '".$l_key."' already exists in stack with handle '".$p_handle."' ! (skipped)");
					continue;
				}
				$this->stack[$p_handle][$l_key] = $l_val;
			}

			return $p_handle;
		}


		$p_param_name =	trim($p_param);
		if (empty($p_param_name)) {
			SysMsg::showError("Error on APPEND : param name for handle '".$p_handle."' is empty!");
			return false;
		}

		if ( $this->rewrite_on_append == false && isSet($this->stack[$p_handle][$p_param_name])) {
			SysMsg::showError("Error on APPEND : param '".$p_param_name."' already exists in stack with handle '".$p_handle."' !");
			return false;
		}

		$this->stack[$p_handle][$p_param_name] = $p_param_value;

		return $p_handle;
	}


	function rewrite($p_handle, $p_param_name, $p_param_value) {

		if (!$this->checkHandle($p_handle)) {
			return false;
		}

		$p_param_name =	trim($p_param_name);
		if (!isSet($this->stack[$p_handle][$p_param_name])) {
			SysMsg::showError("Error on REWRITE : param '".$p_param_name."' does NOT exist in stack with handle '".$p_handle."' !");
			return false;
		}

		$this->stack[$p_handle][$p_param_name] = $p_param_value;

		return $p_handle;
	}


	function get($p_handle, $p_param_name = null) {

		if (!$this->checkHandle($p_handle)) {
			return false;
		}

		if ($p_param_name === null) {
			return $this->stack[$p_handle];
		}

		$p_param_name =	trim($p_param_name);
		if (empty($p_param_name)) {
			SysMsg::showError("Error on GET : param name for handle '".$p_handle."' is empty!");
			return false;
		}

		if ( !isSet($this->stack[$p_handle][$p_param_name]) ) {
			SysMsg::showError("Error on GET : param '".$p_param_name."' for handle '".$p_handle."' does not exist!");
			return false;
		}

		return $this->stack[$p_handle][$p_param_name];
	}


	function kill($p_handle, $p_param_name = null) {

		if (!$this->checkHandle($p_handle)) {
			return false;
		}

		if ($p_param_name === null) {
			unset($this->stack[$p_handle]);
			return true;
		}

		$p_param_name =	trim($p_param_name);
		if (empty($p_param_name)) {
			SysMsg::showError("Error on KILL : param name for handle '".$p_handle."' is empty!");
			return false;
		}

		if ( !isSet($this->stack[$p_handle][$p_param_name]) ) {
			SysMsg::showError("Error on KILL : param '".$p_param_name."' for handle '".$p_handle."' does not exist!");
			return false;
		}

		unset($this->stack[$p_handle][$p_param_name]);

		return true;
	}


	function checkHandle($p_handle) {

		if ($this->handleExists($p_handle)) {
			return true;
		}

		SysMsg::showError("stack with handle '".$p_handle."' doesn't exists!");
		return false;
	}


	function handleExists($p_handle) {

		if (isSet($this->stack[$p_handle])) {
			return true;
		}

		return false;
	}


	function paramExists($p_handle, $p_param) {

		if (!$this->checkHandle($p_handle)) {
			return false;
		}

		if (isSet($this->stack[$p_handle][$p_param])) {
			return true;
		}

		return false;
	}

	function dump($p_handle) {

		if (!$this->checkHandle($p_handle)) {
			return false;
		}

		echo '<h4>'.$p_handle.'</h4>';
		echo '<pre>';
		var_dump($this->stack[$p_handle]);
		echo '</pre>';
		echo '<hr/>';

		return true;
	}


}

