<?php
/*
* $McLicense$
*
* $Id$
*
*/

require_once(MCP_LIB_PATH . 'File.php');

class Theme
{
	private $DB;
	private $File;

	private $dirName;
	private $updateSrcTheme;

	private $pageBaseDir;
	private $tmplBaseDir;
	private $arrRoomId;
	private $arrTmplId;

	function __construct($themeSrc)
	{
		global $U;

		$this->DB   = &$U->DB;
		$this->File = new File();
		$this->dirName = 'files.theme';
		$this->updateSrcTheme = $themeSrc . '/' . $this->dirName;
	}



	public function directoryExists()
	{
		if ( is_dir($this->updateSrcTheme) )
		{
			return true;
		}

		return false;
	}


	public function updateThemeFiles()
	{
		if ( ! is_dir($this->updateSrcTheme) )
		{
			SysMsg::showError("path '{$this->updateSrcTheme}' is not available!");
			SysMsg::showTask("please maintain path '{$this->updateSrcTheme}' or remove directory '{$this->dirName}.");
			return false;
		}

		$themesDest = MC_LAYOUT_PATH;

		$handle = opendir($themesDest);
		if ( ! $handle)
		{
			SysMsg::showError("can not open path '{$themesDest}'");
			return false;
		}

		while ( ($file = readdir($handle)) !== false)
		{
			if ($file == ".")    { continue; }
			if ($file == "..")   { continue; }
			if ($file == ".svn") { continue; }
			if (strlen($file) < 7) { continue; } // '?_theme'
			if (substr($file, -6) != '_theme') { continue; }
			if ($file == 'default_theme') { continue; }

			$themeDir = $themesDest . $file;

			if ( ! is_dir($themeDir) )
			{
				SysMsg::showWarning("'{$themeDir}' is not a directory!");
				continue;
			}

			if ( ! is_writable($themeDir) )
			{
				SysMsg::showError("file '{$themeDir}' is not writable!");
				continue;
			}

			SysMsg::showMsg("updating '{$themeDir}' with '{$this->updateSrcTheme}'");

			$this->File->rcopy($this->updateSrcTheme, $themeDir);

		} // end while (readdir)

		return true;
	}


}


