<?php
/*
* $McLicense$
*
* $Id$
*
*/


require(MCP_LIB_PATH.'Debug.class.php');
require(MCP_LIB_PATH.'SysMsg.class.php');
require(MCP_LIB_PATH.'Request.class.php');
require(MCP_LIB_PATH.'Session.class.php');
require(MCP_LIB_PATH.'UConf.class.php');
require(MCP_LIB_PATH.'Version.class.php');
require(MCP_LIB_PATH . 'DB' . DIRECTORY_SEPARATOR . 'DBMC.php');



/**
 * mcp_Update api container
 */
class mc_U
{
	/**
	 * Request object
	 */
	public $Request;
	/**
	 * wrapped PEAR Database connection
	 */
	public $DB;
	
	/**
	 * Config object
	 */
	public $Config;
	
	/**
	 * Log object
	 */
	public $Log;
	
	/**
	 * Session object
	 */
	public $Session;
	
	/**
	 * View object
	 */
	public $View;
	
	/**
	 * Version object
	 */
	public $Version;
	
	/**
	 * DBStruct object
	 */
	public $DBStruct;
	
	/**
	 * MpsParser object
	 */
	public $MpsParser;

	/**
	 *
	 */
	function __construct()
	{
		$this->Request = new mc_Request();
		$this->DB = DBMC::connect();

		$this->Config  = new UConf($this->DB);
		$this->Log     = null;
		$this->Session = null;
		$this->View    = null;
		$this->Version = new mc_Version($this);

		$currentName = $this->Version->getCurrentName();
		if (version_compare($currentName, MCP_REQUIRED_VERSION, "<") )
		{
			throw new Exception("platform version is too low for updater (version '".MCP_REQUIRED_VERSION."' required)");
		}

		$this->DBStruct  = null;
		$this->MpsParser = null;

		if ($this->Config->isEnabled('enable_testmode')) 
		{
			$this->Config->enableTest();
		}
		else 
		{
			$this->Config->disableTest();
		}
	}



	/**
	 * hasSession
	 */
	public function initDBStruct()
	{
		require(MCP_LIB_PATH.'DBStruct.php');

		$this->DBStruct = new DBStruct();

		return true;
	}



	/**
	 * hasSession
	 */
	public function hasSession()
	{
		return ( is_object($this->Session) );
	}



	/**
	 * loadSession
	 */
	public function loadSession($p_name = null, $p_user_id = null)
	{
		$this->Session = mc_Session::start($p_name, $p_user_id);
		return $this->Session;
	}



	/**
	 * loadLog
	 */
	public function loadLog()
	{
		require_once(MCP_LIB_PATH . "Log.php");
		$this->Log = new mc_Log($this, $this->Config->getTimeName().'.html');
		return $this->Log;
	}



	/**
	 * loadMpsParser
	 */
	public function loadMpsParser($fileName)
	{
		require_once(MCP_LIB_PATH . "MpsParser.php");
		$this->MpsParser = new MpsParser($fileName);
		return $this->MpsParser;
	}



	/**
	 * parseMps
	 */
	public function parseMps($fileName)
	{
		if ( ! file_exists($fileName) )
		{
			SysMsg::showError('file "'.$fileName.'" not found!');
			die();
		}

		$MpsParser = $this->loadMpsParser($fileName);

		$this->Config->disableTest();

		$head = file_get_contents(MCP_LAY_PATH.'head.htm');

		$replace = array(
			'{headline}' => patch_headline,
			'{MC_CHAR_SET}' => MC_CHAR_SET,
			'{MCP_STYLE_URI}'  => MCP_STYLE_URL,
			'{MCP_SCRIPT_URI}' => MCP_SCRIPT_URL,
		);

		echo strtr($head, $replace);

		$MpsParser->execute();

		SysMsg::showMsg('{DONE}');

		return true;
	}



	/**
	 * parseMultiLang
	 */
	public static function parseMultiLang($string, $strLang = null)
	{
		if (substr($string, 0, 2) != 'a:' || substr($string, -2) != ';}')
		{
			return $string;
		}

		if (empty($strLang) )
		{
			$strLang = mc_Session::getLang();
		}

		$arrMLF = @unserialize($string);

		if ($arrMLF === false)
		{
			throw new Exception("unserialize failed! (string: {$string})");
		}

		if ( empty($arrMLF) )
		{
			return '';
		}

		if (isset($arrMLF[$strLang]) )
		{
			return $arrMLF[$strLang];
		}

		return reset($arrMLF);
	}


	/**
	 * loadView
	 */
	function loadView($__viewName = null)
	{
		die(__CLASS__.'::'.__METHOD__.' is not available here (yet?)');
	}


}

