<?php
/*
* $McLicense$
*
* $Id$
*
*/


class mc_Version
{

	var $MC_NAME;
	var $MC_DESC;
	var $MC_VERSION;
	var $MC_REVISION;

	var $MOD_TYPE;
	var $MOD_NAME;
	var $MOD_BUILD;
	var $MOD_AUTHOR;
	var $MOD_CHECK;

	var $req_version;
	var $req_revision;
	var $req_build;

	function __construct(mc_U $U)
	{
		$this->DB = &$U->DB;

		// read an set latest version
		$latestVersion = $this->getLatestVersion();
		$this->setInstalledVersion($latestVersion);

/*
	$_tmp = array(
		'DESCRIPTION' => array(
		  'type'     => 'patch|mod|bugfix',
		  'version'  => "1.9.7",
		  'revision' => ????,
		  'build'    => ????,
		),
		'REQUIREMENT' => array(
		  'version'  => "1.9.7",
		  'revision' => ????,
		  'build'    => ????,
		  'check'    => MCP_VRB_RANGE,
		),
		'DETAILS' => array(
		  'name'     => "MCDEV",
		  'desc'     => "Campussource (Botein)",
		  'product'  => "patch1.9.7",
		  'author'   => "metacoon open source team",
		),
	);
*/
		// get destined version/revision/build
		$last = $U->Config->getLastUpdate();
		if (empty($last) )
		{
			return;
		}

		$this->MC_NAME     = trim($last['DETAILS']['name']);
		$this->MC_DESC     = trim($last['DETAILS']['desc']);
		$this->MC_VERSION  = trim($last['DESCRIPTION']['version']);
		$this->MC_REVISION = intval($last['DESCRIPTION']['revision']);
		$this->MC_BUILD    = intval($last['DESCRIPTION']['build']);

		$this->MOD_TYPE   = trim($last['DESCRIPTION']['type']); // patch | bugfix | mod
		$this->MOD_CHECK  = intval($last['REQUIREMENT']['check']);
		$this->MOD_NAME   = trim($last['DETAILS']['product']);
		$this->MOD_AUTHOR = trim($last['DETAILS']['author']);

		// get patch requirements
		$first = $U->Config->getFirstUpdate();

		if (isset($first['REQUIREMENT']['version']) ) {
			$this->req_version = trim($first['REQUIREMENT']['version']);
		}
		else {
			$this->req_version = null;
		}

		if (isset($first['REQUIREMENT']['revision']) ) {
			$this->req_revision = intval($first['REQUIREMENT']['revision']);
		}
		else {
			$this->req_revision = null;
		}

		if (isset($first['REQUIREMENT']['version']) ) {
			$this->req_build = intval($first['REQUIREMENT']['build']);
		}
		else {
			$this->req_build = null;
		}

	} // Ende Konstruktor


	function getName()
	{
		return $this->MC_NAME;
	}

	function getDesc()
	{
		return $this->MC_DESC;
	}

	function getVersion()
	{
		return $this->MC_VERSION;
	}

	function getRevision()
	{
		return $this->MC_REVISION;
	}

	function getBuild()
	{
		return $this->MC_BUILD;
	}

	function getModType()
	{
		return $this->MOD_TYPE;
	}

	function getModName()
	{
		return $this->MOD_NAME;
	}

	function getModAuthor()
	{
		return $this->MOD_AUTHOR;
	}

	function getReqVersion()
	{
		return $this->req_version;
	}

	function getReqRevision()
	{
		return $this->req_revision;
	}

	function getReqBuild()
	{
		return $this->req_build;
	}

	function getReqName()
	{
		$name = $this->getReqVersion().'.R'.$this->getReqRevision().'.B'.$this->getReqBuild();
		return $name;
	}

	function getNewVersion()
	{
		return $this->getVersion();
	}

	function getNewRevision()
	{
		return $this->getRevision();
	}

	function getNewBuild()
	{
		return $this->getBuild();
	}

	function getNewName()
	{
		$name = $this->getNewVersion().'.R'.$this->getNewRevision().'.B'.$this->getNewBuild();
		return $name;
	}

	function getRequirementsInfo()
	{
		switch ($this->MOD_CHECK)
		{
			case MCP_VRB_MATCH :
				// traditional check (single version and revision)
				return '
	Version '.$this->getReqVersion().'<br>
	Revision '.$this->getReqRevision();

			case MCP_VRB_RANGE :
				// modern check (revision range)
				return ($this->getReqRevision() - 1).' < Current Revision < '.$this->getRevision();

			default :
				die('version check mode '.$this->vcm.' is unknown');
		} // end switch
	} // end method getReqInfo


	/**
	 * mysql condition, checking for patch-requirements on table VERSION
	 */
	function matchesRequirements()
	{
		$requiredName = $this->getReqName();
		$currentName  = $this->getCurrentName();
		$destinedName = $this->getNewName();

		switch ($this->MOD_CHECK)
		{
			case MCP_VRB_MATCH :
				// traditional check (single version and revision)
				if (version_compare($currentName, $requiredName, '=') )
				{
					return true;
				}
				else
				{
					return false;
				}

			case MCP_VRB_RANGE :
				// modern check (revision range)
				if (version_compare($currentName, $requiredName, '<') )
				{
					return false;
				}

				if (version_compare($currentName, $destinedName, '=>') )
				{
					return false;
				}

				return true;

			default :
				die('version check mode '.$this->vcm.' is unknown');
		}
	}



	function writeVersion(UConf $Config)
	{
		$name     = $Config->getCurrentDetailsParam('name');
		$version  = $Config->getUpdateVersion();
		$revision = $Config->getUpdateRevision();
		$build    = $Config->getUpdateBuild();
		$product  = $Config->getCurrentDetailsParam('product');
		$desc     = $Config->getCurrentDetailsParam('desc');
		$type     = $Config->getCurrentDescParam('type');
		$author   = $Config->getCurrentDetailsParam('author');

		$ins = "insert into VERSION set"
			."  VERSION_NAME     = ".$this->DB->quote($name)
			.", VERSION_VNUMBER  = ".$this->DB->quote($version)
			.", VERSION_REVISION = ".intval($revision)
			.", VERSION_VBUILD   = ".intval($build)
			.", VERSION_PATCH    = ".$this->DB->quote($product)
			.", VERSION_DESC     = ".$this->DB->quote($desc)
			.", VERSION_TYPE     = ".$this->DB->quote($type)
			.", VERSION_AUTHOR   = ".$this->DB->quote($author)
			.", OWNER  = 0"
			.", INSDAT = unix_timestamp()"
			.', STATE  = "Y"'
		;
		$res = $this->DB->query($ins);

		$res = $this->DB->getLastInsertId();

		return true;
	}


	function setInstalledVersion($version)
	{
		$this->installed_version = $version;
	}

	function getCurrentVersion()
	{
		return $this->installed_version['VERSION_VNUMBER'];
	}

	function getCurrentRevision()
	{
		return $this->installed_version['VERSION_REVISION'];
	}

	function getCurrentBuild()
	{
		return $this->installed_version['VERSION_VBUILD'];
	}

	function getCurrentName()
	{
		$name = $this->getCurrentVersion().'.R'.$this->getCurrentRevision().'.B'.$this->getCurrentBuild();
		return $name;
	}


	function getLastChange($p_Conf)
	{
		$res = $this->DB->getOne(
			 'select INSDAT'
			.'  from VERSION'
			.' where VERSION_ID = '.intval($this->installed_version['VERSION_ID'])
		);

		return ($res + MC_LASTCHANGE_OFFSET);
	}

	private function getLatestVersion()
	{
		$sel = 'select * from VERSION where STATE = "Y" order by VERSION_ID desc';
		$latestVersion = $this->DB->getRow($sel, DBMC_FETCHMODE_ASSOC);
		return $latestVersion;
	}



} // end class mc_Version


