<?php
/*
* $McLicense$
*
* $Id$
*
*/


require_once(MCP_PATH."_classes/core/PMap.php");

class PCol
{
	var $DB;

	var $tab_map;

	function __construct()
	{
		global $U;
		$this->DB = &$U->DB;

		$Map = new PMap();
		$this->tab_map = $Map->getTabMap();
	}



	function getTabIdent($tabName)
	{
		if (empty($tabName) )
		{
			SysMsg::showError('parameter $tabName is empty');
			return false;
		}

		$tabIdx = '%TAB_IDENT('.$tabName.')%';

		if (empty($this->tab_map[$tabIdx]) )
		{
			SysMsg::showError('no tabmap index found for table "'.$tabName.'"');
			return false;
		}

		return intval($this->tab_map[$tabIdx]);
	}



	public function addCol($tabName, $colName, $colDesc, $type, $len=null, $state=null)
	{
		$tabName  = trim($tabName);
		$colName  = trim($colName);
		$colDesc  = trim($colDesc);

		$type = trim($type);
		switch($type)
		{
			case 'INT' :
				$colType = 'INT';
				break;

			case 'CHAR' :
				$colType = 'CHAR';
				break;

			case 'DATE' :
				$colType = 'DATE';
				break;

			default :
				throw new Exception('unknown COL_TYPE : "'.$type.'"');
		}

		if ($len === null) {
			$colLen = 'NULL';
		}
		else {
			$colLen = intval($len);
		}

		$state = trim($state);
		if (empty($state) )
		{
			$state = 'Y';
		}

		$tabIdent = $this->getTabIdent($tabName);
		if (empty($tabIdent) )
		{
			throw new Exception('table is not registered : "'.$tabName.'"');
		}

		// search for existing entry
		$query = "select COL_IDENT from COL"
			." where COL_NAME = '{$colName}'"
			." and COL_TAB_IDENT = ".$tabIdent
		;
		$result = $this->DB->query($query);
		$num = $result->numRows();

		if ($num > 1)
		{
			throw new Exception("Column '{$colName}' is ambiguous! {$query}");
		}

		if ($num == 1)
		{
			$row = $result->fetchRow();
			$result->free();
			return intval($row[0]);
		}

		// fetch new COL_IDENT
		$query = "select max(COL_IDENT)+1 from COL where COL_TAB_IDENT = ".$tabIdent;
		$colIdent = $this->DB->getOne($query);

		$query  =  "insert into COL ("
			."  COL_IDENT, COL_APP_IDENT, COL_TAB_IDENT, COL_NAME"
			.", COL_DESC, COL_TYPE, COL_LEN, STATE"
			." ) VALUES ("
			.' '.$colIdent.', '.mc_Session::getApp().', '.$tabIdent.', "'.$colName.'"'
			.', "'.addslashes($colDesc).'", "'.$colType.'", '.$colLen.', "'.$state.'"'
			.' )'
		;
		$this->DB->query($query);

		SysMsg::showInfo('creating entry in table COL for "'.$colName.'" : {SUCCEED}');

		return $colIdent;
	}


}

