<?php
/*
* $McLicense$
*
* $Id$
*
*/



class PElement
{
	var $data;

	function PElement()
	{
		$this->data = array();
	} // end of constructor



	function getInstanceOf($element, $dieOnUnknownElement=false)
	{
		global $U;

		if ( empty($element) ) {
			throw new mc_Exception($element, 'parameter is empty');
		}

		if ( is_numeric($element) ) {
			$where = "ELEMENT_IDENT = ".intval($element);
		}
		else {
			$where = 'ELEMENT_NAME = "'.addslashes(trim($element)).'"';
		}

		$PElement = new PElement();

		$select = "select"
			."  ELEMENT_IDENT as IDENT"
			.", ELEMENT_NAME  as NAME"
			.", ELEMENT_KIND  as KIND"
			.", ELEMENT_VIEW_IDENT as VIEW_IDENT"
			.", ELEMENT_PHYSNAME   as PHYSNAME"
			.", ELEMENT_PK_NAME    as PK_NAME"
			.", ELEMENT_VTREE_NODE_ID as VTN_ID"
			." from ELEMENT"
			." where $where"
		;
		$elementResult = $U->DB->query($select);

		$numRows = $elementResult->numRows();

		if ($numRows == 0)
		{
			if ($dieOnUnknownElement)
			{
				throw new mc_Exception(null, "element '$elementName' not found");
			}
			return false;
		}

		if ($numRows > 1)
		{
			throw new mc_Exception($element, 'element is ambiguous!');
		}

		$arrElement = $elementResult->fetchRow(DBMC_FETCHMODE_ASSOC);
		$elementResult->free();

		if ( $PElement->init($arrElement) )
		{
			return $PElement;
		}

		return false;
	} // end function getInstanceOf



	function init($arrData)
	{
		if ( empty($arrData) )
		{
			throw new mc_Exception($arrData, 'parameter is empty');
		}

		$this->setIdent($arrData['IDENT']);
		$this->setName($arrData['NAME']);
		$this->setKind($arrData['KIND']);
		$this->setViewIdent($arrData['VIEW_IDENT']);
		$this->setPhysname($arrData['PHYSNAME']);
		$this->setPkName($arrData['PK_NAME']);
		$this->setVtnId($arrData['VTN_ID']);

		return true;
	} // end function init


	// setter
	function setIdent($v)    { $this->data['IDENT'] = intval($v); }
	function setName($v)     { $this->data['NAME']  = trim($v);   }
	function setKind($v)     { $this->data['KIND']  = intval($v); }
	function setViewIdent($v)
	{
		if (empty($v)) {
			$this->data['VIEW_IDENT'] = null;
		}
		else {
			$this->data['VIEW_IDENT'] = intval($v);
		}
	}
	function setPhysname($v)
	{
		if (empty($v)) {
			$this->data['PHYSNAME'] = null;
		}
		else {
			$this->data['PHYSNAME'] = trim($v);
		}
	}
	function setPkName($v)
	{
		if (empty($v)) {
			$this->data['PK_NAME'] = null;
		}
		else {
			$this->data['PK_NAME'] = trim($v);
		}
	}
	function setVtnId($v)
	{
		if (empty($v)) {
			$this->data['VTN_ID'] = null;
		}
		else {
			$this->data['VTN_ID'] = intval($v);
		}
	}


	// getter
	function getIdent()     { return $this->data['IDENT']; }
	function getName()      { return $this->data['NAME'];  }
	function getKind()      { return $this->data['KIND'];  }
	function getViewIdent() { return $this->data['VIEW_IDENT']; }
	function getPhysname()  { return $this->data['PHYSNAME'];   }
	function getPkName()    { return $this->data['PK_NAME'];    }
	function getVtnId()     { return $this->data['VTN_ID'];     }


} // end class PElement

