<?php
/*
* $McLicense$
*
* $Id: Group.php 491 2011-03-28 10:39:59Z gross $
*
*/


// visible group types
if ( ! defined('MC_GROUP_TYPE_ROOM_LOCAL') )
{
	define('MC_GROUP_TYPE_ROOM_LOCAL', 'C');
	define('MC_GROUP_TYPE_ROOM_ZERO',  'G');
	define('MC_GROUP_TYPE_SYSTEM',     'S');

	define('MC_GROUP_TYPE_LECTURE',    'R');

	// hidden group types
	define('MC_GROUP_TYPE_ROOM_MEMBER',  'A');

	define('MC_GROUP_TYPE_FRIENDS', 'F');
	define('MC_GROUP_TYPE_PRIVATE', 'U');

	define('MC_GROUP_TYPE_CSV_IMPORT',   'I');
	define('MC_GROUP_TYPE_CSV_CLASS',    'O');

	// group type sets
	define('MC_GROUP_TYPE_USER',    '"F", "U"');
	define('MC_GROUP_TYPE_CSV',     '"I", "O"');
	//define('MC_GROUP_TYPE_HIDDEN',  '"A", "F", "U", "I", "O"');
	//define('MC_GROUP_TYPE_VISIBLE', '"G", "C", "S", "R"');
	define('MC_GROUP_TYPE_HIDDEN',  '"F", "U", "I", "O"');
	define('MC_GROUP_TYPE_VISIBLE', '"A", "G", "C", "S", "R"');
	define('MC_GROUP_TYPE_NO_PERMISSION', '"I", "O"');



	# [definition of WGROUP_NAME]

	// role names
	define('MC_GROUP_NAME_ADMIN',       'ADMIN');
	define('MC_GROUP_NAME_PF_ADMIN',    'MCADMIN');
	define('MC_GROUP_NAME_ROOM_ADMIN',  'KURSADMIN');
	define('MC_GROUP_NAME_AUTHORS',     'AUTHORS');
	define('MC_GROUP_NAME_TUTORS',      'LEHRENDE');
	define('MC_GROUP_NAME_LEARNERS',    'STUDENT');
	define('MC_GROUP_NAME_GUESTS',      'GAESTE');
	//define('MC_GROUP_NAME_ALL',         'ALLE');
	define('MC_GROUP_NAME_ROOM_MEMBER', 'ROOM_MEMBER');
	define('MC_GROUP_NAME_FRIENDS',     'FRIENDS');
	define('MC_GROUP_NAME_PRIVATE',     'USER');
	define('MC_GROUP_NAME_CSV_CLASS',   'CLASS');
}



/**
 * Group
 *
 * @author [Autor]
 * @version 1.0
 * @package core
 * @subpackage classes.new
 */
class PGroup
{
	var $DB;
	var $DBStruct;

	var $DsAccess;
	var $stdResource;

	var $stdView = 'VWGROUP';
	var $stdLayout = 'LWGROUP';

	private $migrationGroupDesc = 'mc2.0';

	private $adminName;
	private $memberName;
	private $memberType;
	private $memberDesc;
	private $arrMemberCap;
	private $memberCap;

	/**
	* constructor
	*/
	function __construct($useNewAccess = true)
	{
		global $U;
		$this->DB = &$U->DB;
		$this->DBStruct = &$U->DBStruct;

		$this->adminName  = $this->DB->quote(MC_GROUP_NAME_ROOM_ADMIN);
		$this->memberName = $this->DB->quote(MC_GROUP_NAME_ROOM_MEMBER);
		$this->memberType = $this->DB->quote(MC_GROUP_TYPE_ROOM_MEMBER);
		$this->memberDesc = $this->DB->quote($this->migrationGroupDesc);
		$this->arrMemberCap  = array(
#			'DE' => 'Alle Benutzer des Raumes %s',
#			'EN' => 'all members of room %s',
			'DE' => 'Alle Benutzer des Raumes',
			'EN' => 'all members of room',
		);
		$this->memberCap = $this->DB->quote( serialize($this->arrMemberCap) );

		if ($useNewAccess)
		{
			require_once(MCP_LIB_PATH.'DsAccess.php');
			$this->DsAccess = new DsAccess();
			$select = 'select TAB_NAME, TAB_IDENT from TAB where TAB_NAME = "WGROUP"';
			$this->stdResource = $this->DB->getRow($select);
			if (empty($this->stdResource) )
			{
				die("no result for [ {$select} ] in " . __FILE__ . ':' . __LINE__);
			}
		}
		else
		{
			$this->DsAccess = null;
		}

		$this->normalize();
	} // end constructor



	/**
	* normalize
	*/
	private function normalize()
	{
		$view = $this->stdView;
		$lay  = $this->stdLayout;

		$privateType = $this->DB->quote(MC_GROUP_TYPE_PRIVATE);
		$friendsType = $this->DB->quote(MC_GROUP_TYPE_FRIENDS);
		$lectureType = $this->DB->quote(MC_GROUP_TYPE_LECTURE);

		$this->DB->query('update     WGROUP set STATE = "S" where     WGROUP_NAME = ' . $this->adminName  . ' and STATE = "Y"');
		$this->DB->query('update TPL_WGROUP set STATE = "S" where TPL_WGROUP_NAME = ' . $this->adminName  . ' and STATE = "Y"');
		$this->DB->query('update     WGROUP set STATE = "S" where     WGROUP_TYPE = ' . $this->memberType . ' and STATE = "Y"');
		$this->DB->query('update TPL_WGROUP set STATE = "S" where TPL_WGROUP_TYPE = ' . $this->memberType . ' and STATE = "Y"');
		$this->DB->query('update     WGROUP set STATE = "S" where     WGROUP_TYPE = ' . $lectureType      . ' and STATE = "Y"');
		$this->DB->query('update     WGROUP set STATE = "S" where     WGROUP_TYPE = ' . $privateType      . ' and STATE = "Y"');
		$this->DB->query('update     WGROUP set STATE = "Y" where     WGROUP_TYPE = ' . $friendsType      . ' and STATE = "S"');

		$this->DB->query("update     WGROUP set VIEW = null, LAYOUT = null, OWNER = 1,     WGROUP_CAP = ".$this->memberCap." where     WGROUP_TYPE = " . $this->memberType);
		$this->DB->query("update TPL_WGROUP set VIEW = null, LAYOUT = null, OWNER = 1, TPL_WGROUP_CAP = ".$this->memberCap." where TPL_WGROUP_TYPE = " . $this->memberType);

		$this->DB->query("update     WGROUP set VIEW = null, LAYOUT = null where WGROUP_TYPE = " . $privateType);
		$this->DB->query("update     WGROUP set VIEW = null, LAYOUT = null where WGROUP_TYPE = " . $friendsType);

		$this->DB->query("update     WGROUP set     WGROUP_DESC = '' where     WGROUP_DESC is null");
		$this->DB->query("update TPL_WGROUP set TPL_WGROUP_DESC = '' where TPL_WGROUP_DESC is null");
	} // end method normalize



	/**
	* cleanupRelations
	*/
	public function cleanupRelations()
	{
		$this->cleanupRelGU();
		$this->cleanupRelCourseUser();
	}




	/**
	* repairPrivateGroups
	*/
	public function repairPrivateGroups()
	{
		SysMsg::showMsg('repairing private user groups. hang on...');

		$appId = mc_Session::getApp();
		$count = 0;

		$name = $this->DB->quote(MC_GROUP_NAME_PRIVATE);
		$type = $this->DB->quote(MC_GROUP_TYPE_PRIVATE);

#		$arrMissingPrivate = $this->DB->getCol(
		$resMissingPrivate = $this->DB->query(
			 "select USER_IDENT, USER.STATE, WGROUP_ID, WGROUP.STATE"
			." from USER"
			." left join WGROUP"
			." on"
			."     WGROUP.OWNER = USER_IDENT"
			." and WGROUP_TYPE = ".$type
			." where"
			."     USER_IDENT is not null"
			." and USER.STATE != 'T'"
		);

#		foreach($arrMissingPrivate as $userIdent)
		while( list($userIdent, $userState, $groupId, $groupState) = $resMissingPrivate->fetchRow() )
		{
			$userIdent = intval($userIdent);
			$groupId   = intval($groupId);

			if ($userState == 'Y' || $userState == 'S')
			{
				// account is active
				if ($groupId == 0)
				{
					// ENABLED group is required but does not exist yet
				}
				else if ($groupState == 'S')
				{
					// ENABLED group already exists
					continue;
				}
				else
				{
					// group already exists but is DISABLED => enable existing group
					$this->DB->query("update WGROUP set STATE = 'S' where WGROUP_ID = {$groupId}");
					continue;
				}
			}
			else
			{
				// account is disabled
				if ($groupId == 0)
				{
					// DISABLED group is required but does not exist yet
					$disableNewGroup = true;
				}
				else if ($groupState != 'S')
				{
					// DISABLED group already exists
					continue;
				}
				else
				{
					// group already exists but is ENABLED => disable existing group
					$this->DB->query("update WGROUP set STATE = 'X' where WGROUP_ID = {$groupId}");
					continue;
				}
			}

			$userState = $this->DB->quote($userState);
			$update = "insert into WGROUP ("
				."OWNER, COURSE_ID, RELSTATE, STATE, WGROUP_APP_IDENT, WGROUP_NAME, WGROUP_TYPE, INSDAT, WGROUP, ACCESS, FLAGS"
				.") values ("
				."{$userIdent}, 0, 'N', 'S', {$appId}, {$name}, {$type}, now(), 0, 0, 0"
				.")"
			;
			$this->DB->query($update);

			$insId = $this->DB->getLastInsertId();
			$this->DB->query("update WGROUP set WGROUP_IDENT = {$insId} where WGROUP_ID = {$insId}");

			$count++;

			if ($this->DsAccess)
			{
				$this->DsAccess->createByRessource($this->stdResource, $insId, '', $userIdent, 0, 0, array());
			}

			if ( ! empty($disableNewGroup) )
			{
				$this->DB->query("update WGROUP set STATE = 'X' where WGROUP_ID = {$insId}");
			}

		} // end foreach($arrMissingPrivate)

		SysMsg::showMsg("added missing private groups over all: {$count}");

		if ($count)
		{
			$this->DBStruct->optimize('WGROUP', true);
		}
	} // end method repairPrivateGroups



	/**
	* repairFriendGroups
	*/
	public function repairFriendGroups()
	{
		SysMsg::showMsg('repairing friend groups. hang on...');

		$appId = mc_Session::getApp();
		$count = 0;

		$name = $this->DB->quote(MC_GROUP_NAME_FRIENDS);
		$type = $this->DB->quote(MC_GROUP_TYPE_FRIENDS);

		$resMissingFriend = $this->DB->query(
			 "select USER_IDENT, USER.STATE"
			." from USER"
			." left join WGROUP"
			." on"
			."     WGROUP.OWNER = USER_IDENT"
			." and WGROUP_TYPE = ".$type
			." and WGROUP.STATE != 'T'"
			." where"
			."     USER_IDENT is not null"
			." and USER.STATE != 'T'"
			." and WGROUP_ID is null"
		);

		while( list($userIdent, $userState) = $resMissingFriend->fetchRow() )
		{
			$userIdent = intval($userIdent);
			$update = "insert into WGROUP ("
				."OWNER, COURSE_ID, RELSTATE, STATE, WGROUP_APP_IDENT, WGROUP_NAME, WGROUP_TYPE, INSDAT, WGROUP, ACCESS, FLAGS"
				.") values ("
				."{$userIdent}, 0, 'N', 'Y', {$appId}, {$name}, {$type}, now(), 0, 0, 0"
				.")"
			;
			$this->DB->query($update);

			$insId = $this->DB->getLastInsertId();
			$this->DB->query("update WGROUP set WGROUP_IDENT = {$insId} where WGROUP_ID = {$insId}");

			$count++;

			if ($this->DsAccess)
			{
				$this->DsAccess->createByRessource($this->stdResource, $insId, '', $userIdent, 0, 0, array());
			}

			if ($userState == 'N')
			{
				$this->DB->query("update WGROUP set STATE = \"X\" where WGROUP_ID = {$insId}");
			}
		}
		$resMissingFriend->free();

		SysMsg::showMsg("added missing friend groups over all: {$count}");

		if ($count)
		{
			$this->DBStruct->optimize('WGROUP', true);
		}

	} // end method repairFriendGroups



	/**
	 * createMissingRoomMemberGroups
	 */
	private function createMissingRoomMemberGroups()
	{
		require_once(MCP_LIB_PATH . "core/PPhpBB2.php");
		$PPhpBB2 = new PPhpBB2();

		SysMsg::showMsg('validating room member groups. hang on...');

		$update = "update WGROUP"
			." set WGROUP_CAP = ".$this->memberCap
			." where WGROUP_NAME = ".$this->memberName
		;
		$this->DB->query($update);

		$appId = mc_Session::getApp();
		$count = 0;

		$arrMissingRoomMember = $this->DB->getCol(
			 "select COURSE.COURSE_ID"
			." from COURSE"
			." left join WGROUP"
			." on"
			."     WGROUP.COURSE_ID = COURSE.COURSE_ID"
			." and WGROUP_NAME = ".$this->memberName
			." and WGROUP.STATE = 'S'"
			." where"
			."     COURSE.STATE != 'T'"
			." and WGROUP_ID is null"
		);

		foreach($arrMissingRoomMember as $roomId)
		{
			$roomId = intval($roomId);

			$insId = $this->createMemberGroup($roomId);

			$PPhpBB2->createGroup($this->arrMemberCap['DE'], '', 0, 0, 0, $insId);

			$count++;
		} // end foreach($arrMissingRoomMember)

		SysMsg::showMsg("added missing room member groups over all: {$count}");

		if ($count)
		{
			$this->DBStruct->optimize('WGROUP', true);
		}
	}



	/**
	 * createMissingTmplMemberGroups
	 */
	private function createMissingTmplMemberGroups()
	{
		SysMsg::showMsg('validating room template member groups. hang on...');

		$update = "update TPL_WGROUP"
			." set TPL_WGROUP_CAP = ".$this->memberCap
			." where TPL_WGROUP_NAME = ".$this->memberName
		;
		$this->DB->query($update);

		$appId = mc_Session::getApp();
		$count = 0;

		$result = $this->DB->query(
			 "select ROOM_TYPE_IDENT, ROOM_TYPE_FROM_COURSE_ID, COURSE.COURSE_ID"
			." from ROOM_TYPE"
			." left join COURSE"
			." on"
			."     COURSE.COURSE_ID = ROOM_TYPE_FROM_COURSE_ID"
			." and COURSE.STATE = 'R'"
			." where"
			."     ROOM_TYPE.STATE != 'T'"
		);

		while($row = $result->fetchRow() )
		{
			$tmplId = intval($row[0]);
			$fromRoomId = intval($row[1]);
			$tmplRoomId = intval($row[2]);

			// template room exists ?
			if ( empty($tmplRoomId) )
			{
				$this->DB->query(
					"update ROOM_TYPE set ROOM_TYPE_FROM_COURSE_ID = null where ROOM_TYPE_IDENT = {$tmplId}"
				);
#				SysMsg::showMsg("_FROM_COURSE_ID set to null for template {$tmplId}, because room {$fromRoomId} does not exist.");

				$this->DB->query(
					"update TPL_WGROUP set TPL_WGROUP_FROM_WGROUP_IDENT = 0 where TPL_WGROUP_ROOM_TYPE_IDENT = {$tmplId}"
				);
#				SysMsg::showMsg("_FROM_WGROUP_IDENT set to null for existing groups of template {$tmplId}, because room {$fromRoomId} does not exist.");

				$fromGroupId = null;
			} // end if ($tmplRoomId)
			else
			{
				// fetch member group of template room (should exist by executing method repairMemberGroups earlier)
				$select = "select WGROUP_ID"
					." from WGROUP"
					." where COURSE_ID = {$tmplRoomId}"
					." and WGROUP_TYPE = ".$this->memberType
				;
				$fromGroupId = $this->DB->getOne($select);

				if (empty($fromGroupId) )
				{
					mc_Debug::error($select, "missing member group for template room {$tmplRoomId} !");
					exit(0);
				}
			}

			$qFromGroupId = $this->DB->quote($fromGroupId);

			$select = "select TPL_WGROUP_ID, TPL_WGROUP_IDENT"
				." from TPL_WGROUP"
				." where"
				."     TPL_WGROUP_ROOM_TYPE_IDENT = {$tmplId}"
				." and TPL_WGROUP_TYPE = ".$this->memberType
				." and TPL_WGROUP.STATE = 'S'"
			;
			$memberGroupResult = $this->DB->query($select);

			if ($memberGroupResult->numRows() == 0)
			{
				// thou shalt have no other member groups before me
				// note: kill all invalid groups (those without STATE= 'S')
				$delete = "delete from TPL_WGROUP"
					." where"
					."     TPL_WGROUP_ROOM_TYPE_IDENT = {$tmplId}"
					." and TPL_WGROUP_TYPE = ".$this->memberType
					." and TPL_WGROUP.STATE != 'S'"
				;
				$this->DB->query($delete);

				$insert = "insert into TPL_WGROUP ("
					."  TPL_WGROUP_ROOM_TYPE_IDENT, TPL_WGROUP_NAME, TPL_WGROUP_CAP, TPL_WGROUP_TYPE"
					.", TPL_WGROUP_IDENT, TPL_WGROUP_FROM_WGROUP_IDENT, TPL_WGROUP_DESC"
					.", TPL_WGROUP_APP_IDENT, INSDAT, OWNER, STATE"
					.") values ("
					."  {$tmplId}, ".$this->memberName.", ".$this->memberCap.", ".$this->memberType
					.", {$qFromGroupId}, {$qFromGroupId}, ".$this->memberDesc
					.", {$appId}, now(), 1, 'S'"
					.")"
				;
				$this->DB->query($insert);

				if ( empty($fromGroupId) )
				{
					$insId = $this->DB->getLastInsertId();
					$this->DB->query(
						"update TPL_WGROUP set TPL_WGROUP_IDENT = {$insId} where TPL_WGROUP_ID = {$insId}"
					);
				}

				$count++;
			}
			else
			{
				$arrGroupData = $memberGroupResult->fetchRow();
				$memberGroupResult->free();

				$tmplMemberGroupPk = intval($arrGroupData[0]); // primary key
				$tmplMemberGroupId = intval($arrGroupData[1]); // real member group id

				// thou shalt have no other member groups before me
				// note: kill all (from room) besides the selected one
				$delete = "delete from TPL_WGROUP"
					." where"
					."     TPL_WGROUP_ROOM_TYPE_IDENT = {$tmplId}"
					." and TPL_WGROUP_TYPE = ".$this->memberType
					." and TPL_WGROUP_ID != {$tmplMemberGroupPk}"
				;
				$this->DB->query($delete);

				if ($fromGroupId > 0 && $tmplMemberGroupId != $fromGroupId)
				{
					// fix wrong id in TPL_WGROUP, must match WGROUP_ID(ENT)
					$update = "update TPL_WGROUP"
						." set TPL_WGROUP_IDENT = {$fromGroupId}"
						." where TPL_WGROUP_ID = {$tmplMemberGroupPk}"
					;
					$this->DB->query($update);
				}
			}

		#	SysMsg::showInfo("adding member group for template {$tmplId} {SUCCEEDED}");
		} // end foreach($arrMissingTmplMember)

		SysMsg::showMsg("added missing template member groups over all: {$count}");

		if ($count)
		{
			$this->DBStruct->optimize('TPL_WGROUP', true);
		}

		return true;
	}



	/**
	* createGroup
	*
	* IMPORTANT NOTE : this type of group NEEDS NOT an entry in table M2_AUFGFELD
	*/
	public function createGroup($roomId, $arrData, $state = "")
	{
		$roomId = intval($roomId);
		$viewName = '""';
		$layName  = '""';
		$mgrAccess = array();
		$access = 0;
		$wgroup = 0;
		$appId = mc_Session::getApp();

		if (empty($state) ) {
			$state = $this->DB->quote("Y");
		}

		if (empty($arrData['OWNER']) ) {
			$ownerId = mc_Session::getUserId();
		}
		else {
			$ownerId = intval($arrData['OWNER']);
		}

		if ( ! $this->DsAccess )
		{
			if ( ! empty($arrData['ACCESS']) ) {
				$access = intval($arrData['ACCESS']);
			}

			if ( ! empty($arrData['WGROUP']) ) {
				$wgroup = intval($arrData['WGROUP']);
			}
		}

		if (empty($arrData['WGROUP_LONGDESC'])) {
			$groupLong = '""';
		}
		else {
			$groupLong = $this->DB->quote($arrData['WGROUP_LONGDESC']);
		}

		$groupName = $this->DB->quote($arrData['WGROUP_NAME']);
		$relState  = $this->DB->quote('N');

		switch ($arrData['WGROUP_NAME'])
		{
			case MC_GROUP_NAME_FRIENDS :
				$groupType = $this->DB->quote(MC_GROUP_TYPE_FRIENDS);
				$groupDesc = $this->DB->quote($arrData['WGROUP_DESC']);
				$groupCap  = $this->DB->quote($arrData['WGROUP_CAP']);
				$roomId = 0;
				$state = $this->DB->quote('S');
				break;

			case MC_GROUP_NAME_PRIVATE :
				$groupType = $this->DB->quote(MC_GROUP_TYPE_PRIVATE);
				$groupDesc = $this->DB->quote($arrData['WGROUP_DESC']);
				$groupCap  = $this->DB->quote($arrData['WGROUP_CAP']);
				$roomId = 0;
				$state = $this->DB->quote('S');
				break;

			case MC_GROUP_NAME_ROOM_MEMBER :
				$groupType = $this->memberType;
				$groupDesc = $this->memberDesc;
				$groupCap  = $this->memberCap;
				$state = $this->DB->quote('S');
				$ownerId = 1;

				$select = "select WGROUP_ID from WGROUP"
					." where WGROUP_NAME = ".$this->adminName
					."   and COURSE_ID = {$roomId}"
					."   and STATE in ('Y','S')"
				;
				$roomAdminId = $this->DB->getOne($select);
				$roomAdminId = intval($roomAdminId);

				if ( ! $this->DsAccess && $roomAdminId > 0)
				{
					$wgroup = $roomAdminId;
					$access = MC_DS_GROUP;
				}
				break;

			default :
				$groupType = $this->DB->quote($arrData['WGROUP_TYPE']);
				$groupDesc = $this->DB->quote($arrData['WGROUP_DESC']);
				$viewName  = $this->DB->quote($this->stdView);
				$layName   = $this->DB->quote($this->stdLayout);
				$mgrAccess = array(
					'static' => array(2 => MC_DS_GROUP)
				);
				break;
		} // end switch

		$res = $this->DB->query(
			 'insert into WGROUP ('
			.'  WGROUP_APP_IDENT, WGROUP_DESC, WGROUP_LONGDESC'
			.', WGROUP_NAME, WGROUP_CAP, WGROUP_TYPE'
			.', COURSE_ID, OWNER, WGROUP, ACCESS'
			.', INSDAT, UPDDAT, VIEW, LAYOUT'
			.', RELSTATE, RELUSER, RELDATE, STATE'
			.' ) values ('
			."  {$appId}, {$groupDesc}, {$groupLong}"
			.", {$groupName}, {$groupCap}, {$groupType}"
			.", {$roomId}, {$ownerId}, {$wgroup}, {$access}"
			.", now(), now(), {$viewName}, {$layName}"
			.", {$relState}, null, null, {$state}"
			.' )'
		);
		$insId = $this->DB->getLastInsertId();

		$this->DB->query("update WGROUP set WGROUP_IDENT = {$insId} where WGROUP_ID = {$insId}");

		if ($this->DsAccess)
		{
			if ($arrData['WGROUP_NAME'] == MC_GROUP_NAME_ROOM_MEMBER)
			{
				$mgrAccess = array();
				if ($roomAdminId > 0)
				{
					// add static permissions for group of room administrators
					$mgrAccess['static'] = array($roomAdminId => MC_DS_GROUP);
				}
				// add dynamic permissions for group itself
				$mgrAccess[$insId] = MC_GROUP_SHOW;
			}

			$this->DsAccess->createByRessource($this->stdResource, $insId, $viewName, $ownerId, $roomId, 0, $mgrAccess);
		}

#		SysMsg::showInfo("member group {$insId} created for room {$roomId}");

		return $insId;
	} // end of method createGroup



	/**
	* createMemberGroup
	*/
	public function createMemberGroup($roomId)
	{
		$arrData = array(
			'WGROUP_NAME' => MC_GROUP_NAME_ROOM_MEMBER,
		);

		$id = $this->createGroup($roomId, $arrData);

		return $id;
	}



	public function getPrivateGroup($userId, $fullJoin = true, $abortOnMiss = true)
	{
		$userId = intval($userId);

		if ($fullJoin)
		{
			$select = "select WGROUP_IDENT"
				." from WGROUP, REL_G_U"
				." where"
				."     WGROUP.OWNER = ".$userId
				." and WGROUP_TYPE = ".$this->DB->quote(MC_GROUP_TYPE_PRIVATE)
				." and WGROUP_APP_IDENT = ".mc_Session::getApp()
				." and REL_G_U_WGROUP_IDENT = WGROUP_IDENT"
				." and REL_G_U_USER_IDENT = ".$userId
				." and REL_G_U.STATE = 'Y'"
			;
		}
		else
		{
			$select = "select WGROUP_IDENT"
				." from WGROUP"
				." where"
				."     WGROUP.OWNER = ".$userId
				." and WGROUP_TYPE = ".$this->DB->quote(MC_GROUP_TYPE_PRIVATE)
				." and WGROUP_APP_IDENT = ".mc_Session::getApp()
			;
		}

		$groupId = $this->DB->getOne($select);

		if (empty($groupId) && $abortOnMiss)
		{
			throw new Exception("no private group available for user {$userId}");
		}

		return ( intval($groupId) );
	} // end function getPrivateGroup



	public function deleteUserGroup($userId)
	{
		$groupId = $this->getPrivateGroup($userId, false, false);

		if ($groupId == 0)
		{
			return true;
		}

		return $this->deleteGroup($groupId);
	} // end function deleteUserGroup



	public function deleteGroup($groupId)
	{
		$groupId = intval($groupId);
		$select = "select DS_ID from WGROUP where WGROUP_ID = {$groupId}";
		$dsId = $this->DB->getOne($select);

		if ( $this->DsAccess && ! empty($dsId) )
		{
			$dsId = intval($dsId);

			$delete = "delete from DS where DS_ID = {$dsId}";
			$this->DB->query($select);

			$delete = "delete from DS_LINK where DS_LINK_DEST_DS_ID = {$dsId}";
			$this->DB->query($select);

			$delete = "delete from DS_LINK where DS_LINK_SRC_DS_ID = {$dsId}";
			$this->DB->query($select);

			$delete = "delete from DS_ACCESS where DS_ACCESS_DS_ID = {$dsId}";
			$this->DB->query($select);
		}

		$delete = "delete from WGROUP where WGROUP_ID = {$groupId}";
		$this->DB->query($delete);

		$update = "update M2_AUFGFELD set STATE = 'D' where M2_AUFGFELD_WGROUP_IDENT = {$groupId}";
		$this->DB->query($update);

		return true;
	} // end function deleteUserGroup



	public function isMember($userId, $groupId)
	{
		$select = "select REL_G_U_ID"
			." from REL_G_U"
			." where REL_G_U_APP_IDENT    = ".mc_Session::getApp()
			."   and REL_G_U_WGROUP_IDENT = ".intval($groupId)
			."   and REL_G_U_USER_IDENT   = ".intval($userId)
			."   and STATE = 'Y'"
		;
		$relGUId = $this->DB->getOne($select);

		if (empty($relGUId) )
		{
			return false;
		}

		return true;
	} // end function isMember



###
### CLEANUP REL_COURSE_USER
###
	public function cleanupRelCourseUser()
	{
		SysMsg::showMsg(
			'cleaning up REL_COURSE_USER from invalid account ids. please hang on...'
		);

		$missing_course_users = $this->DB->getCol(
			 "select distinct REL_COURSE_USER_USER_IDENT"
			." from REL_COURSE_USER"
			." left join USER"
			." on USER_IDENT = REL_COURSE_USER_USER_IDENT"
			." where USER_ID is null"
		);

		foreach($missing_course_users as $userId)
		{
			$userId = intval($userId);
			$this->DB->query(
				"delete from REL_COURSE_USER where REL_COURSE_USER_USER_IDENT = {$userId}"
			);
		} // end foreach

		$countMiss = count($missing_course_users);
		if ($countMiss)
		{
			SysMsg::showInfo(
				"entries of {$countMiss} deprecated account ids removed from table REL_COURSE_USER"
			);
			$this->DBStruct->optimize('REL_COURSE_USER', true);
		}
		else
		{
			SysMsg::showInfo('no deprecated account ids found in table REL_COURSE_USER');
		}

		SysMsg::showMsg(
			'cleaning up REL_COURSE_USER from invalid room ids. please hang on...'
		);

		$missing_courses = $this->DB->getCol(
			 "select distinct REL_COURSE_USER_COURSE_ID"
			." from REL_COURSE_USER"
			." left join COURSE"
			." on COURSE.COURSE_ID = REL_COURSE_USER_COURSE_ID"
			." where COURSE.COURSE_ID is null"
		);

		foreach($missing_courses as $roomId)
		{
			$roomId = intval($roomId);
			$this->DB->query(
				"delete from REL_COURSE_USER where REL_COURSE_USER_COURSE_ID = {$roomId}"
			);
		} // end foreach

		$countMiss = count($missing_courses);
		if ($countMiss)
		{
			SysMsg::showInfo(
				"entries of {$countMiss} deprecated room ids removed from table REL_COURSE_USER"
			);
			$this->DBStruct->optimize('REL_COURSE_USER', true);
		}
		else
		{
			SysMsg::showInfo('no deprecated room ids found in table REL_COURSE_USER');
		}

		return true;
	}



###
### CLEANUP REL_G_U
###
	public function cleanupRelGU()
	{
		SysMsg::showMsg('cleaning up REL_G_U from invalid account ids. please hang on...');

		$missing_group_users = $this->DB->getCol(
			 "select distinct REL_G_U_USER_IDENT"
			." from REL_G_U"
			." left join USER"
			." on USER_IDENT = REL_G_U_USER_IDENT"
			." where USER_ID is null"
		);

		foreach($missing_group_users as $userId)
		{
			$userId = intval($userId);
			$this->DB->query("delete from REL_G_U where REL_G_U_USER_IDENT = {$userId}");
		} // end foreach

		$countMiss = count($missing_group_users);
		if ($countMiss)
		{
			SysMsg::showInfo(
				"entries of {$countMiss} deprecated account ids removed from table REL_G_U"
			);
			$this->DBStruct->optimize('REL_G_U', true);
		}
		else
		{
			SysMsg::showInfo('no deprecated account ids found in table REL_G_U');
		}

		SysMsg::showMsg('cleaning up REL_G_U from invalid group ids. please hang on...');

		$missing_groups = $this->DB->getCol(
			 "select distinct REL_G_U_WGROUP_IDENT"
			." from REL_G_U"
			." left join WGROUP"
			." on WGROUP_ID = REL_G_U_WGROUP_IDENT"
			." where WGROUP_ID is null"
		);

		foreach($missing_groups as $groupId)
		{
			$groupId = intval($groupId);
			$this->DB->query("delete from REL_G_U where REL_G_U_WGROUP_IDENT = {$groupId}");
		} // end foreach

		$countMiss = count($missing_groups);
		if ($countMiss)
		{
			SysMsg::showInfo(
				"entries of {$countMiss} deprecated group ids removed from table REL_G_U"
			);
			$this->DBStruct->optimize('REL_G_U', true);
		}
		else
		{
			SysMsg::showInfo('no deprecated group ids found in table REL_G_U');
		}

		return true;
	}



	public function removePre20MemberGroups()
	{
		$where  = ' where WGROUP_NAME = '.$this->memberName;
		$where .= ' and WGROUP_DESC != '.$this->memberDesc;

		SysMsg::showMsg('remove deprecated room member groups (created by pre-2.0 updates)');

		$countBefore = $this->DB->getOne("select count(WGROUP_ID) from WGROUP {$where}");

		$this->DB->query("delete from WGROUP {$where}");

		$countAfter = $this->DB->getOne("select count(WGROUP_ID) from WGROUP {$where}");

		$countDel = $countBefore - $countAfter;
		if ($countDel)
		{
			SysMsg::showInfo("{$countDel} deprecated room member groups deleted");
		}
		else
		{
			SysMsg::showMsg("no deprecated room member groups found");
		}

		$where  = ' where TPL_WGROUP_NAME = '.$this->memberName;
		$where .= ' and TPL_WGROUP_DESC != '.$this->memberDesc;

		SysMsg::showMsg('remove deprecated template member groups (created by pre-2.0 updates)');

		$countBefore = $this->DB->getOne("select count(TPL_WGROUP_ID) from TPL_WGROUP {$where}");

		$this->DB->query("delete from TPL_WGROUP {$where}");

		$countAfter = $this->DB->getOne("select count(TPL_WGROUP_ID) from TPL_WGROUP {$where}");

		$countDel = $countBefore - $countAfter;
		if ($countDel)
		{
			SysMsg::showInfo("{$countDel} deprecated template member groups deleted");
		}
		else
		{
			SysMsg::showMsg("no deprecated template member groups found");
		}

		return true;
	}



	private function transformGroupAllToMember($table, $groupId)
	{
		$groupId = intval($groupId);

		$update = "update {$table} set"
			."  {$table}_NAME = ".$this->memberName
			.", {$table}_DESC = ".$this->memberDesc
			.", {$table}_TYPE = ".$this->memberType
			.", {$table}_CAP  = ".$this->memberCap
			.', STATE = "S"'
			." where {$table}_ID = {$groupId}"
		;

		$this->DB->query($update);
	}



	public function repairMemberGroups()
	{
		// WGROUP

		SysMsg::showMsg(
			 'transform remaining groups of type "ALLE" into group "ROOM_MEMBER"'
			.' if <b><i>all</i></b> members of the room are members of the group too'
			.' (otherwise a seperate room member group is created). hang on...'
		);

		$room_list = $this->DB->query(
			 'select COURSE_ID, COURSE_TITEL, STATE'
			.'  from COURSE'
			.' where STATE != "T" and COURSE_ID not in (2, 3)'
		);

		// walk all existing rooms (including template rooms)
		while(list($room_id, $room_name, $room_state) = $room_list->fetchRow())
		{
			$select = 'select count(WGROUP_ID) from WGROUP'
				." where WGROUP.COURSE_ID = {$room_id} and WGROUP.STATE != 'T'"
			;
			$count = $this->DB->getOne($select);

			if ( empty($count) )
			{
				if ($room_state == 'Y' || $room_state == 'S')
				{
					$err = "room {$room_id} is <b>not</b> disabled but has <b>no groups</b> !";
					SysMsg::showError($err);
				}
				else if ($room_state == 'R')
				{
					$err = "template room {$room_id} is <b>not</b> disabled but has <b>no groups</b> !";
					SysMsg::showError($err);
				}
				else
				{
					$info = "room {$room_id} has no groups but is disabled anyway !";
					SysMsg::showInfo($info);
				}

				$this->createMemberGroup($room_id);
				continue;
			}

			$roomLabel = "room '{$room_name}' (id {$room_id})";

			// fetch id of new member group if group exists
			$memberGroupId = $this->DB->getOne(
				 'select WGROUP_ID'
				.' from WGROUP'
				.' where COURSE_ID = '.$room_id
				.' and WGROUP_NAME = '.$this->memberName
				.' and WGROUP_DESC = '.$this->memberDesc
				.' and STATE != "T"'
			);
			$memberGroupId = intval($memberGroupId);

			$resultGroupAll = $this->DB->query(
				 'select WGROUP_IDENT, WGROUP_CAP'
				.' from WGROUP'
				.' where COURSE_ID = '.$room_id
				.' and WGROUP_NAME = "ALLE"'
				.' and STATE != "T"'
			);

			if ($resultGroupAll->numRows() == 0)
			{
				// group "ALLE" not found
				if ($memberGroupId)
				{
					// already transformed
					SysMsg::showInfo("groups of {$roomLabel} are already up to date");
					continue;
				}

				SysMsg::showWarning("neither group 'ALLE' nor 'ROOM_MEMBER' found in {$roomLabel}. room has state '{$room_state}' but there are still {$count} groups left");

				continue;
			}

			if ($resultGroupAll->numRows() > 1)
			{
				SysMsg::showError("group 'ALLE' is ambiguous in {$roomLabel}");

				while ($agroup = $resultGroupAll->fetchRow())
				{
					$gid = intval($agroup[0]);
					$cap = mc_U::parseMultiLang($agroup[1], mc_Session::getLang());
					$task = "check group '{$cap}' (id {$gid}) of {$roomLabel}";
					SysMsg::showTask($task);
				}
				$resultGroupAll->free();

				SysMsg::showWarning("group transformation of {$roomLabel} {SKIPPED}!");

				continue;
			}

			// group 'ALLE' does (still) exist and is not ambiguous
			list($groupAllId, $groupAllCap) = $resultGroupAll->fetchRow();
			$resultGroupAll->free();

			// check if all room members are member of group "ALLE"
			$missing_user_rels = $this->DB->getCol(
				 "select distinct REL_COURSE_USER_USER_IDENT"
				." from REL_COURSE_USER"
				." left join REL_G_U"
				." on"
				."     REL_G_U_USER_IDENT = REL_COURSE_USER_USER_IDENT"
				." and REL_G_U_WGROUP_IDENT = ".$groupAllId
				." and REL_G_U.STATE in ('Y', 'S')"
				." where"
				."     REL_COURSE_USER_COURSE_ID = ".$room_id
				." and REL_COURSE_USER_CONFIRM = 'Y'"
				." and REL_COURSE_USER.STATE in ('Y', 'S')"
				." and REL_G_U_ID is null"
			);

			$missingMembersCount = count($missing_user_rels);

			if ($missingMembersCount == 0)
			{
				if ($memberGroupId)
				{
					// both groups exist
					// transfer permissions to new group
					$update = "update WRIGHT"
						." set WRIGHT_WGROUP_IDENT = {$memberGroupId}"
						." where WRIGHT_WGROUP_IDENT = {$groupAllId}"
						."   and COURSE_ID = {$room_id}"
					;
					$this->DB->query($update);
					$info = "permissions of deprecated group 'ALLE' transferred to new group 'ROOM_MEMBER'";
					SysMsg::showInfo($info);

					// delete old group
					$this->deleteGroup($groupAllId);
					$info = "deprecated group 'ALLE' was redundant now and therefore deleted";
					SysMsg::showInfo($info);

					continue;
				}

				// all fine, transform group
				$this->transformGroupAllToMember('WGROUP', $groupAllId);

				$msg = "transforming group 'ALLE' of {$roomLabel} : {SUCCEEDED} (no missing memberships)";
				SysMsg::showInfo($msg);

				continue;
			}

			// missing memberships in group "ALLE"
			$strMisses = implode(', ', $missing_user_rels);
			SysMsg::showMsg(
				"deprecated group 'ALLE' does NOT contain all members of {$roomLabel}. missing users: {$strMisses}"
			);

			// skip room if member group already exists
			if ($memberGroupId)
			{
				SysMsg::showInfo("new member group already exists (room {SKIPPED})");
				continue;
			}

			// group "ALLE" remains
			$select = "select WGROUP_CAP from WGROUP where WGROUP_ID = ".$groupAllId;
			$res = $this->DB->getOne($select);

			$arrCaps = @unserialize($res);
			$arrLangCaps = array();

			foreach($arrCaps as $lang => $cap)
			{
				$arrLangCaps[] = $lang.': "'.$cap.'"';
			}
			$strCaps = implode(', ', $arrLangCaps);

			$note = "you may rename group {$groupAllId} ({$strCaps}) in room '{$room_name}'";
			SysMsg::showNote($note);

		} // end foreach
		$room_list->free();

		$this->DBStruct->optimize('WGROUP', true);

		$this->createMissingRoomMemberGroups();

		// TPL_WGROUP

		$msg = "transform template groups of type 'ALLE' into group 'ROOM_MEMBER'. hang on...";
		SysMsg::showMsg($msg);

		$template_list = $this->DB->query(
			 'select ROOM_TYPE_IDENT, ROOM_TYPE_NAME'
			.'  from ROOM_TYPE'
			.' where ROOM_TYPE_IDENT is not null'
			.'   and STATE != "T"'
		);

		while(list($template_id, $template_name) = $template_list->fetchRow())
		{
			$tmplLabel = "template '{$template_name}' (id {$template_id})";

			// fetch ident of new member group if group exists
			$memberGroupId = $this->DB->getOne(
				 'select TPL_WGROUP_IDENT'
				.' from TPL_WGROUP'
				.' where'
				.'     TPL_WGROUP_ROOM_TYPE_IDENT = '.$template_id
				.' and TPL_WGROUP_NAME = '.$this->memberName
				.' and TPL_WGROUP_DESC = '.$this->memberDesc
			);
			$memberGroupId = intval($memberGroupId);

			if ($memberGroupId)
			{
				SysMsg::showInfo(
					"groups are already up to date in {$tmplLabel}. template {SKIPPED}."
				);
				continue;
			}

			// check for id of deprecated group 'ALLE'
			$groupAllId = $this->DB->getOne(
				 'select TPL_WGROUP_ID'
				.' from TPL_WGROUP'
				.' where'
				.'     TPL_WGROUP_ROOM_TYPE_IDENT = '.$template_id
				.' and TPL_WGROUP_NAME = "ALLE"'
			);

			if ($groupAllId)
			{
				$this->transformGroupAllToMember('TPL_WGROUP', $groupAllId);
				$info = "transforming group 'ALLE' of {$tmplLabel} {SUCCEEDED}";
				SysMsg::showInfo($info);
				continue;
			}

			// member group does not exists but neither does group "ALLE"
			SysMsg::showWarning("neither group 'ALLE' nor group 'ROOM_MEMBER' found in {$tmplLabel}");

		} // end while ($template_list)
		$template_list->free();

		$this->createMissingTmplMemberGroups();

		$this->DBStruct->optimize('TPL_WGROUP', true);

		return true;
	}


} // Ende Klasse PGroup


