<?php
/*
* $McLicense$
*
* $Id$
*
*/


class PKata
{
	var $DB;
	var $DBStruct;

	function PKata()
	{
		global $U;
		$this->DB = &$U->DB;
		$this->DBStruct = &$this->U->DBStruct;
	} // Ende Konstruktor



	function fillKataFieldFromColList($p_map)
	{
		if ($this->checkMap($p_map) == false) {
			return false;
		}

		while (list($key, $value) = each($p_map)) {
			$l_tab_name = $key;
			$l_true     = $value['TRUE'];
			$l_target   = $value['TARGET_COL'];
			$l_col_list = $value['COL_LIST'];

			if ($this->DBStruct>tableExists($l_tab_name) == false) {
				SysMsg::showWarning('PKata::createKataFromColList() => table "'.$l_tab_name.'" does not exist!');
				continue;
			}

			if ($this->DBStruct->fieldExistsInTable($l_tab_name, $l_target) == false) {
				SysMsg::showWarning('PKata::createKataFromColList() => target column "'.$l_target.'" does not exist!');
				continue;
			}

			foreach ($l_col_list as $l_col_name ) {
				if ($this->DBStruct->fieldExistsInTable($l_tab_name, $l_col_name) == false) {
					SysMsg::showWarning('PKata::createKataFromColList() => column "'.$l_col_name.'" from list does not exist!');
					continue;
				}
			}

			$l_sel  =  "select ".$l_tab_name."_ID as ID, ".implode(', ', $l_col_list);
			$l_sel .= " from ".$l_tab_name;
			$l_row_list = $this->DB->query($l_sel);

			$l_sum = $l_row_list->numRows();

			if ($l_sum > 0) {

				$l_count = 0;

				while ($l_row = $l_row_list->fetchRow(DBMC_FETCHMODE_ASSOC)) {

					$l_target_value = array();

					reset($l_col_list);
					while ( list($index, $l_col_name) = each($l_col_list) ) {
//						echo "(\$l_row[{$l_col_name}] == {$l_true}) ==&gt; ".(($l_row[$l_col_name] == $l_true) ? 1 : 0)."<br/>";
						if ($l_row[$l_col_name] == $l_true) {
							$l_target_value[] = $index + 1;
						}
					}

					$l_target_value = implode(',', $l_target_value);

					if ( !empty($l_target_value) ) {
						$l_upd  =  "update ".$l_tab_name;
						$l_upd .= " set";
						$l_upd .= " ".$l_target." = '".$l_target_value."'";
						$l_upd .= " where";
						$l_upd .= " ".$l_tab_name."_ID = ".$l_row['ID'];
						$l_res = $this->DB->query($l_upd);

						$l_count++;
					}

				}

				SysMsg::showInfo($l_count.' out of '.$l_sum.' entry/entries update in table '.$l_tab_name.'.');
			}
			else {
				SysMsg::showInfo('no entries found in table '.$l_tab_name.'. no entries modified.');
			}


		}

		return true;

	}




	function checkMap($p_map) {

		if (is_array($p_map) == true) {

			$is_ok = true;

			while (list($key, $value) = each($p_map)) {
				if ( !is_array($value) ) {
					$is_ok = false;
					break;
				}
				if ( !isSet($value['TRUE']) ||  !isSet($value['TARGET_COL']) || !isSet($value['COL_LIST']) ) {
					$is_ok = false;
					break;
				}
				if ( !is_array($value['COL_LIST']) && !sizeof($value['COL_LIST']) > 0) {
					$is_ok = false;
					break;
				}
			}

			if ($is_ok) {
				return true;
			}
		}

		$l_msg = "wrong map!<br/><br/>map should be like this:<br/><br/>
<pre>
array(<br/>
	\$TAB_NAME => array(<br/>
		'TRUE'       => \$VALUE_4_TRUE,<br/>
		'TARGET_COL' => \$TARGET_COL_NAME,<br/>
		'COL_LIST'   => array (\$COL_NAME_1, \$COL_NAME_2, \$COL_NAME_3, ...)<br/>
	),<br/>
)</pre>";

		mc_Debug::error($p_map, $l_msg);

		return false;

	}


} // Ende Klasse PKata

