<?php
/*
* $McLicense$
*
* $Id$
*
*/


class PLangtxt
{
	private $DB;

	public function __construct()
	{
		global $U;
		$this->DB = &$U->DB;
	}


	function insert($arrInserts)
	{
		$mps = <<<MPSHEAD

<mpstable name="LANGTXT">
  <mpskey value="COURSE_ID@LANGTXT_VIEW_IDENT@LANGTXT_SCRIPT_IDENT@LANGTXT_VARIABLE@LANGUAGE" separator="@" />
  <mpsmap value="SCRIPT_IDENT" />
  <mpsmap value="VIEW_IDENT" />
  <mpsmap value="LANGUAGE_ID" />

MPSHEAD;

		foreach($arrInserts as $ins)
		{
			if (empty($ins['VARIABLE']) )
			{
				mc_Debug::error($ins, 'index "VARIABLE" is empty!');
				die();
			}


			if (empty($ins['COURSE_ID']) ) {
				$ins['COURSE_ID'] = 0;
			}
			else {
				$ins['COURSE_ID'] = intval($ins['COURSE_ID']);
			}

			if (empty($ins['VIEW']) ) {
				$ins['VIEW'] = 'zero_entry';
			}

			if (empty($ins['SCRIPT']) ) {
				$ins['SCRIPT'] = 'zero_entry';
			}

			if (empty($ins['VALUE']) ) {
				$ins['VALUE'] = '';
			}

			if (empty($ins['LANGUAGE']) ) {
				$ins['LANGUAGE'] = 'zero_entry';
			}

			if (empty($ins['ORDER']) ) {
				$ins['ORDER'] = 'null';
			}
			else {
				$ins['ORDER'] = intval($ins['ORDER']);
			}

			if (empty($ins['STATE']) ) {
				$ins['STATE'] = 'Y';
			}

			$quotedVariable = $this->DB->quote($ins['VARIABLE']);
			$quotedValue = $this->DB->quote($ins['VALUE']);
			$quotedState = $this->DB->quote($ins['STATE']);

			$mps .= <<<MPSITEM

  <mpsitem action="insert" key="{$ins['COURSE_ID']}@%VIEW_IDENT({$ins['VIEW']})%@%SCRIPT_IDENT({$ins['SCRIPT']})%@{$ins['VARIABLE']}@%LANGUAGE_ID({$ins['LANGUAGE']})%">
insert into LANGTXT (
  COURSE_ID, LANGTXT_VIEW_IDENT, LANGTXT_SCRIPT_IDENT
, LANGTXT_VARIABLE, LANGTXT_VALUE, LANGUAGE
, LANGTXT_ORDER, STATE, LANGTXT_APP_IDENT
) values (
  {$ins['COURSE_ID']}, %VIEW_IDENT({$ins['VIEW']})%, %SCRIPT_IDENT({$ins['SCRIPT']})%
, {$quotedVariable}, {$quotedValue},  %LANGUAGE_ID({$ins['LANGUAGE']})%
, {$ins['ORDER']}, {$quotedState}, %APP_IDENT%
)
  </mpsitem>

MPSITEM;

		} // end foreach

		$mps .= <<<MPSFOOT

</mpstable>

MPSFOOT;

		include_once(MCP_PATH.'_classes/MpsParser.php');
		$MpsParser = new MpsParser();
		$state = $MpsParser->execute($mps);
		return $state;
	}




}

