<?php
/*
* $McLicense$
*
* $Id$
*
*/


class PMap
{
	var $DB;

	// tables without column COURSE_ID
	private $no_cid;

	// room type id
	private $rt_id;

	// room type id
	private $mapFlip;

	function PMap()
	{
		global $U;

		$this->DB = &$U->DB;

		// initialising private array $no_cid
		// array contains names of tables without column COURSE_ID
		$this->no_cid = array();

		$arrTables = $this->DB->getCol('show tables');

		foreach($arrTables as $tableName) {
			$cidExists = $this->DB->getOne("describe {$tableName} COURSE_ID");
#			out("$cidExists = describe {$tableName} COURSE_ID");

			if ($cidExists) {
				continue;
			}

			$this->no_cid[$tableName] = $tableName;
		}

		$this->rt_id = array(
//			'',
		);

	} // end of constructor



	function setConnection($connect)
	{
		return $this->DB = $connect;
	} // end of method setConnection



	function setMapFlip($state)
	{
		$this->mapFlip = (bool)$state;
	} // end of method setMapFlip



	function isMapFlipEnabled()
	{
		return $this->mapFlip;
	} // end of method isMapFlipEnabled



	// @deprecated method hasCid
	function hasCid($tableName) { return $this->cidExists($tableName); }

	function cidExists($tableName)
	{
		if ( isset($this->no_cid[$tableName]) ) {
			return false;
		}
		else {
			return true;
		}
	} // end of method cidExists



	function mapResultRow(&$row, &$arrColMap, &$arrMultiMap, &$arrMapFails)
	{
		$mappedRow = $row;

		// replace NULL with string "NULL" for use in sql statement
		foreach ($row as $colName => $value) {
			if ($value === null) {
				$row[$colName] = 'NULL';
				$mappedRow[$colName] = 'NULL';
			}
		} // end foreach

		foreach($arrColMap as $colName => $map)
		{
			if (empty($map) ) {
				continue;
			}

			switch ($colName)
			{
				# COL_IDENT

				case 'COL_IDENT' :
					$mapIndex = "{$row['COL_TAB_IDENT']}:{$row['COL_IDENT']}";
					break;

				case 'VCOL_COL_IDENT' :
					$viewId = intval($row['VCOL_VIEW_IDENT']);
					$tabId = $arrMultiMap[$viewId];
					$mapIndex = "{$tabId}:{$row['VCOL_COL_IDENT']}";
					break;


				# TPL_MENU_MENU_IDENT

				case 'TPL_MENUITEM_MENUITEM_MENU_IDENT' :
					$roomTypeId = intval($row['TPL_MENUITEM_ROOM_TYPE_IDENT']);
					$menuId = intval($row['TPL_MENUITEM_MENUITEM_MENU_IDENT']);
					$mapIndex = "{$roomTypeId}:{$menuId}";
					break;

				case 'TPL_MENU_MENU_IDENT' :
					$roomTypeId = intval($row['TPL_MENU_ROOM_TYPE_IDENT']);
					$menuId = intval($row['TPL_MENU_MENU_IDENT']);
					$mapIndex = "{$roomTypeId}:{$menuId}";
					break;


				# VCOL_IDENT

				case 'VCOL_IDENT' :
					$vcolId = intval($row['VCOL_IDENT']);
					$viewId = intval($row['VCOL_VIEW_IDENT']);
					$mapIndex = "{$viewId}:{$vcolId}";
					break;

				case 'ENTREL_ITEM_M_VCOL_IDENT' :
					$viewId = $arrMultiMap["M{$row['ENTREL_ITEM_ENTREL_IDENT']}"];
					$vcolId = $row['ENTREL_ITEM_M_VCOL_IDENT'];
					$mapIndex = "{$viewId}:{$vcolId}";
					break;

				case 'ENTREL_ITEM_S_VCOL_IDENT' :
					$viewId = $arrMultiMap["S{$row['ENTREL_ITEM_ENTREL_IDENT']}"];
					$vcolId = $row['ENTREL_ITEM_S_VCOL_IDENT'];
					$mapIndex = "{$viewId}:{$vcolId}";
					break;

				case 'LABELITEM_VCOL_IDENT' :
					$viewId = $arrMultiMap[$row['LABELITEM_LABEL_IDENT']];
					$vcolId = $row['LABELITEM_VCOL_IDENT'];
					$mapIndex = "{$viewId}:{$vcolId}";
					break;


				# standard _IDENT => _NAME, e.g. 'VIEW_IDENT' => 'VIEW_NAME'

				default :
					// e.g.
					// $colName == 'VCOL_VIEW_IDENT';
					// = $row['VCOL_VIEW_IDENT'] = 11;
					$mapIndex = $row[$colName];
					break;
			} // end switch

			// e.g. = $arrTokenMap['VCOL_VIEW_IDENT'][11] = 'VPINNWAND_INT'
			if ( isset($map[$mapIndex]) ) {
				$mappedRow[$colName] = $map[$mapIndex];
			}
			else {
				// note: using $mapIndex as array index generates a unique list
				$arrMapFails[$colName][$mapIndex] = $mapIndex;
				$mappedRow[$colName] = $mapIndex;
			}

		} // end foreach ($arrFkTokenMapOld)

		return $mappedRow;
	} // end function mapResultRow



	function getViewTabIdentMap()
	{
		$arrMap = array();

		$select = 'select VIEW_IDENT, VIEW_TAB_IDENT from VIEW';
		$result = $this->DB->query($select);

		while ($row = $result->fetchRow() ) {
			$viewId = intval($row[0]);
			$tabId = intval($row[1]);
			$arrMap[$viewId] = $tabId;
		}
		$result->free();

		return $arrMap;
	} // end function getViewTabIdentMap



	function getEntrelViewIdentMap()
	{
		$arrMap = array();

		$select = 'select ENTREL_IDENT, ENTREL_M_VIEW_IDENT, ENTREL_S_VIEW_IDENT from ENTREL';
		$result = $this->DB->query($select);

		while ($row = $result->fetchRow() ) {
			$entrelId = intval($row[0]);
			$mViewId = intval($row[1]);
			$sViewId = intval($row[2]);
			$arrMap["M{$entrelId}"] = $mViewId;
			$arrMap["S{$entrelId}"] = $sViewId;
		}
		$result->free();

		return $arrMap;
	} // end function getEntrelViewIdentMap



	function getLabelViewIdentMap()
	{
		$arrMap = array();

		$select = 'select LABEL_IDENT, LABEL_VIEW_IDENT from LABEL';
		$result = $this->DB->query($select);

		while ($row = $result->fetchRow() )
		{
			$labelId = intval($row[0]);
			$viewId = intval($row[1]);
			$arrMap[$labelId] = $viewId;
		}
		$result->free();

		return $arrMap;
	}



	function getMap($tableName, $roomId = null, $nameSuffix = '_NAME')
	{
		switch($tableName)
		{
			case 'COL' :
				return $this->getColMap();

			case 'TPL_MENU' :
				return $this->getTplMenuMap();

			case 'VCOL' :
				return $this->getVcolMap();

			case 'WGROUP' :
				return $this->getWgroupMap($roomId);

			default :
				break;
		}

		if ($this->cidExists($tableName) )
		{
			$condition = " where {$tableName}.STATE != 'T'";
			if (is_numeric($roomId) )
			{
				$roomId = intval($roomId);
				$condition .= " and {$tableName}.COURSE_ID = {$roomId}";
			}
		}
		else
		{
			$condition = "";
		}

		$idColumn = $this->getMapIndexByTableName($tableName);
		$nameColumn = $tableName.$nameSuffix;

		$uFieldName = "{$tableName}.{$nameColumn}";

		$select  = "select {$idColumn}, {$nameColumn} from {$tableName}";
		$select .= "{$condition}";
		$select .= " order by {$idColumn}";

		$result = $this->DB->query($select);

		$map = array();
		$eStrExists = false;
		$nullExists = false;
		$zeroExists = false;

		while ($row = $result->fetchRow() )
		{
#			if ($row[0] === ""  ) { $eStrExists = true; }
			if ($row[0] === ""  ) { mc_Debug::error($row, 'eStrExists'); }
#			if ($row[0] === null) { $nullExists = true; }
#			if ($row[0] === null) { mc_Debug::error($row, 'nullExists'); }
#			if ($row[0] === "0" ) { $zeroExists = true; }
#			if ($row[0] === "0" ) { mc_Debug::error($row, 'zeroExists'); }

			if (empty($row[1]) )
			{
				$msg = "Unique Field {$uFieldName} is empty for {$idColumn} = {$row[0]}";
				SysMsg::showError($msg);
				continue;
			}

			$map["%{$idColumn}({$row[1]})%"] = $row[0];
		} // end while
		$result->free();

#		if ( ! $eStrExists)
#		$map['%'.$idColumn.'()%'] = '""';
#		if ( ! $nullExists)
		$map['%'.$idColumn.'(NULL)%'] = 'NULL';
#		if ( ! $zeroExists)
		$map['%'.$idColumn.'(zero_entry)%'] = 0;

		if ($this->isMapFlipEnabled() )
		{
			$map = array_flip($map);
		}

		return $map;
	}



	function getMapIndexByTableName($tableName)
	{
		switch ($tableName)
		{
			case 'ERRORCAT' :
				$index = 'ERRORCAT_ID';
				break;

			case 'EXTENSION' :
				$index = 'EXTENSION_ID';
				break;

			case 'LANGUAGE' :
				$index = 'LANGUAGE_ID';
				break;

			case 'ROOM_MODEL' :
				$index = 'ROOM_MODEL_ID';
				break;

			case '' :
				mc_Debug::error($tableName, 'table name is empty');
				die();

			default :
				$index = $tableName . '_IDENT';
				break;
		} // end switch

		return $index;
	} // end of method getMapIndexByTableName



	private function getFkMapByColName($indentifier, $roomId = null)
	{
		 return $this->getMapByIdentifier($indentifier, $roomId, true);
	}



	public function getMapByColName($indentifier, $roomId = null)
	{
		$arrMap = $this->getMapByIdentifier($indentifier, $roomId, false);

		if ( is_array($arrMap) )
		{
			return $arrMap;
		}

		throw new Exception("no matching map found for identifier '{$indentifier}'");
	}



	private function getMapByIdentifier($indentifier, $roomId, $mapFlip)
	{
		$this->setMapFlip($mapFlip);

		switch ($indentifier)
		{
			case 'COL_IDENT' :
			case 'VCOL_COL_IDENT' :
			  return $this->getColMap();

			case 'COND_TYPE_IDENT' :
			case 'COND_ITEM_COND_TYPE_IDENT' :
			case 'COND_TYPE_PROFILE_COND_TYPE_IDENT' :
			  return $this->getCondTypeMap();

			case 'ELEMENT_IDENT' :
			case 'EXTFUNC_ELEMENT_IDENT' :
			case 'MENUITEM_ELEMENT_IDENT' :
			case 'TOOL_ELEMENT_IDENT' :
			case 'TPL_MENUITEM_MENUITEM_ELEMENT_IDENT' :
			case 'TPL_WRIGHT_WRIGHT_ELEMENT_IDENT' :
			case 'VIEW_ELEMENT_IDENT' :
			case 'WRIGHT_ELEMENT_IDENT' :
			  return $this->getElementMap();

			case 'ENTREL_IDENT' :
			case 'ENTREL_ITEM_ENTREL_IDENT' :
			  return $this->getEntrelMap();

			case 'ERRORCAT_ID' :
			case 'ERROR_ERRORCAT_ID' :
			  return $this->getErrorCatMap();

			case 'EVENT_IDENT' :
			  return $this->getEventMap();

			case 'EVENT_TYPE_IDENT' :
			case 'EVENT_EVENT_TYPE_IDENT' :
			  return $this->getEventTypeMap();

			case 'EXTENSION_ID' :
			case 'EXTFUNC_EXTENSION_ID' :
			case 'EXTENSION_CONFIG_EXTENSION_ID' :
			  return $this->getExtensionMap();

			case 'EXTFUNC_TYPE_IDENT' :
			case 'EXTFUNC_EXTFUNC_TYPE_IDENT' :
			  return $this->getExtfuncTypeMap();

#			case 'EXTMENULAY_IDENT' :
#			case 'TPL_EXTMENUITEM_MENULAY_IDENT' :
#			  return $this->getExtMenuLayMap(); // identifier does not exist yet

#			case 'EXTMENUITEMLAY_IDENT' :
#			  return $this->getExtMenuitemLayMap(); // identifier does not exist yet

			case 'LABEL_IDENT' :
			case 'LABELITEM_LABEL_IDENT' :
			  return $this->getLabelMap();

			case 'LANGUAGE' :
			case 'LANGUAGE_ID' :
			  return $this->getLanguageMap();

#			case 'LAYOUT' : // layouts are always called by name, not by ident
#			  return $this->getLayoutMap();

			case 'LINK_TYPE_IDENT' :
			case 'LINK_LINK_TYPE_IDENT' :
			  return $this->getLinkTypeMap();

			case 'MENU_IDENT' :
			case 'MENUITEM_MENU_IDENT' :
				if ($roomId === null)
				{
					$msg  = 'no specific room id given (for fetching menu ident map)';
					$msg .= ' - assuming 0 for room id (entrance room)';
					SysMsg::showWarning($msg);
					$roomId = 0;
				}
			  return $this->getMenuMap($roomId);

			case 'MENULAY_IDENT' :
			case 'MENU_MENULAY_IDENT' :
			case 'MENUITEMLAY_MENULAY_IDENT' :
			case 'TPL_MENU_MENU_MENULAY_IDENT' :
			  return $this->getMenulayMap();

			case 'MIMETYPE_IDENT' :
			case 'VTREE_NODE_MIMETYPE' :
			  return $this->getMimetypeMap();

			case 'PARAM_IDENT' :
			case 'PROFILE_PARAM_IDENT' :
			case 'PROFILE_ROOM_TYPE_PARAM_IDENT' :
			  return $this->getParamMap();

			case 'PARAMCAT_IDENT' :
			case 'PARAM_PARAMCAT_IDENT' :
			  return $this->getParamCatMap();

			#		case '?' :
			#		    return $this->getRegExpTplMap();

			case 'ROOM_MODEL_ID' :
			case 'ROOM_TYPE_ROOM_MODEL_ID' :
			  return $this->getRoomModelMap();

			case 'ROOM_TYPE_IDENT' :
			case 'PROFILE_ROOM_TYPE_ROOM_TYPE_IDENT' :
			case 'TPL_EXTMENU_ROOM_TYPE_IDENT' :
			case 'TPL_EXTMENUITEM_ROOM_TYPE_IDENT' :
			case 'TPL_MENU_ROOM_TYPE_IDENT' :
			case 'TPL_MENUITEM_ROOM_TYPE_IDENT' :
			case 'TPL_WRIGHT_ROOM_TYPE_IDENT' :
			  return $this->getRoomTypeMap();

			case 'SCRIPT_IDENT' :
			case 'LANGTXT_SCRIPT_IDENT' :
			case 'MC_TEXT_SCRIPT_IDENT' :
			case 'STDVALUE_SCRIPT_IDENT' :
			  return $this->getScriptMap();

			case 'TAB_IDENT' :
			case 'COL_TAB_IDENT' :
			case 'VIEW_TAB_IDENT' :
			  return $this->getTabMap();

			case 'TOOL_IDENT' :
			case 'EVENT_TOOL_IDENT' :
			  return $this->getToolMap();

#			case 'TPL_EXTMENU_IDENT' :
#			case 'TPL_EXTMENUITEM_MENU_IDENT' :
#			  return $this->getMap('TPL_EXTMENU'); // name is not a valid identifier

			case 'TPL_MENU_IDENT' :
			case 'TPL_MENUITEM_MENUITEM_MENU_IDENT' :
			  return $this->getTplMenuMap();

#			case 'TPL_WGROUP_IDENT' :
#			case 'TPL_WRIGHT_TPL_WGROUP_IDENT' :
#			  return $this->getTplMenuMap();

			case 'VCOL_IDENT' :
			case 'ENTREL_ITEM_M_VCOL_IDENT' :
			case 'ENTREL_ITEM_S_VCOL_IDENT' :
			case 'LABELITEM_VCOL_IDENT' :
			  return $this->getVcolMap();

			case 'VIEW_IDENT' :
			case 'ELEMENT_VIEW_IDENT' :
			case 'ENTREL_M_VIEW_IDENT' :
			case 'ENTREL_S_VIEW_IDENT' :
			case 'EXTFUNC_VIEW_IDENT' :
			case 'LABEL_VIEW_IDENT' :
			case 'LANGTXT_VIEW_IDENT' :
			case 'LAYOUT_VIEW_IDENT' :
			case 'PROFILE_VIEW_IDENT' :
			case 'PROFILE_ROOM_TYPE_VIEW_IDENT' :
			case 'STDVALUE_VIEW_IDENT' :
			case 'VCOL_VIEW_IDENT' :
			case 'VIEW_FUNC_VIEW_IDENT' :
			  return $this->getViewMap();

			case 'VIEW_MODE_IDENT' :
			case 'VIEW_FUNC_VIEW_MODE_IDENT' :
			  return $this->getViewModeMap();

			case 'VERSION_MODULES_IDENT' :
			case 'COND_TYPE_VERSION_MODULES_IDENT' :
			case 'LINK_TYPE_MODULE_IDENT' :
			  return $this->getVersionModulesMap();

			case 'WGROUP_IDENT' :
			case 'WRIGHT_WGROUP_IDENT' :
			  return $this->getWgroupMap();

			default :
			  break;
		}

		return false;
	}



	function getColMap($arrTables = false)
	{
		if (is_array($arrTables) && ! empty($arrTables) ) {
			$tabCondition = ' and TAB_NAME in ("'.implode('", "', $arrTables).'")';
		}
		else {
			$tabCondition = '';
		}

		$select  = "select COL_IDENT, TAB_NAME, COL_NAME, TAB_IDENT";
		$select .= " from COL, TAB";
		$select .= " where TAB_IDENT  = COL_TAB_IDENT {$tabCondition}";
		$result  = $this->DB->query($select);

		$map = array();
		if ($this->isMapFlipEnabled() ) {
			// build value map
			while ($row = $result->fetchRow() )
			{
				// TAB_IDENT:COL_IDENT => COL_IDENT(TAB_NAME:COL_NAME)
				$map["{$row[3]}:{$row[0]}"] = "%COL_IDENT({$row[1]}:{$row[2]})%";
			}
		}
		else {
			// build token map
			while ($row = $result->fetchRow() )
			{
				// COL_IDENT(TAB_NAME:COL_NAME) => COL_IDENT
				$map["%COL_IDENT({$row[1]}:{$row[2]})%"] = $row[0];
			}
		}
		$result->free();

		return $map;
	} // end of method getColMap



	function getCondTypeMap() {
		return $this->getMap('COND_TYPE');
	}

	function getElementMap() {
		return $this->getMap('ELEMENT');
	}

	function getErrorCatMap() {
		return $this->getMap('ERRORCAT');
	}

	function getEventMap() {
		return $this->getMap('EVENT');
	}

	function getEntrelMap() {
		return $this->getMap('ENTREL', null, '_DESC');
	}

	function getEventTypeMap() {
		return $this->getMap('EVENT_TYPE');
	}

	function getExtensionMap() {
		return $this->getMap('EXTENSION');
	}

	function getExtfuncTypeMap()
	{
		$select  = 'select EXTFUNC_TYPE_IDENT, EXTFUNC_TYPE_NAME, EXTFUNC_TYPE_GROUP';
		$select .= ' from EXTFUNC_TYPE';
		$select .= ' where STATE in ("Y", "S")';
		$result  = $this->DB->query($select);

		$map = array();
		if ($this->isMapFlipEnabled() ) {
			// build value map
			while ($row = $result->fetchRow() )
			{
				// EXTFUNC_TYPE_IDENT => EXTFUNC_TYPE_IDENT(EXTFUNC_TYPE_NAME:EXTFUNC_TYPE_GROUP)
				$map["{$row[0]}"] = "%EXTFUNC_TYPE_IDENT({$row[1]}:{$row[2]})%";
			}
		}
		else {
			// build token map
			while ($row = $result->fetchRow() )
			{
				// EXTFUNC_TYPE_IDENT(EXTFUNC_TYPE_NAME) => EXTFUNC_TYPE_IDENT
				// EXTFUNC_TYPE_IDENT(EXTFUNC_TYPE_NAME:EXTFUNC_TYPE_GROUP) => EXTFUNC_TYPE_IDENT
				$map["%EXTFUNC_TYPE_IDENT({$row[1]})%"] = $row[0];
				$map["%EXTFUNC_TYPE_IDENT({$row[1]}:{$row[2]})%"] = $row[0];
			}
		}
		$result->free();

		return $map;
	}

	function getLanguageMap() {
		return $this->getMap('LANGUAGE', null, '_SHORT');
	}

#	function getLayoutMap() {
#		return $this->getMap('LAYOUT');
#	}

	function getLabelMap() {
		return $this->getMap('LABEL');
	}

	function getLinkTypeMap() {
		return $this->getMap('LINK_TYPE');
	}

	function getMenuMap($roomId = null) {
		if ($roomId === null)
		{
			$msg = 'MENU_NAME is room specific! you must <b>specify a room id</b>!';
			mc_Debug::error($roomId, $msg);
			return false;
		}
		return $this->getMap('MENU', $roomId);
	}

	function getMenulayMap() {
		return $this->getMap('MENULAY');
	}

	function getMimetypeMap() {
		return $this->getMap('MIMETYPE', null, '_EXT');
	}

	function getParamMap() {
		return $this->getMap('PARAM');
	}

	function getParamCatMap() {
		return $this->getMap('PARAMCAT');
	}

	function getRegExpTplMap() {
		return $this->getMap('REGEXP_TPL');
	}

	function getRoomModelMap() {
		return $this->getMap('ROOM_MODEL');
	}

	function getRoomTypeMap($roomId = null) {
		return $this->getMap('ROOM_TYPE', $roomId, '_UID');
	}

	function getScriptMap() {
		return $this->getMap('SCRIPT');
	}

	function getTabMap() {
		return $this->getMap('TAB');
	}

	function getToolMap() {
		return $this->getMap('TOOL');
	}

	function getTplMenuMap()
	{
		$select  = "select TPL_MENU_MENU_IDENT, ROOM_TYPE_NAME, TPL_MENU_MENU_NAME";
		$select .= ", TPL_MENU_ROOM_TYPE_IDENT";
		$select .= " from TPL_MENU, ROOM_TYPE";
		$select .= " where ROOM_TYPE_IDENT = TPL_MENU_ROOM_TYPE_IDENT";
		$result  = $this->DB->query($select);

		$map = array();
		if ($this->isMapFlipEnabled() ) {
			// build value map
			while ($row = $result->fetchRow() )
			{
				// TPL_MENU_ROOM_TYPE_IDENT:TPL_MENU_MENU_IDENT
				//   => TPL_MENU_MENU_IDENT(ROOM_TYPE_NAME:TPL_MENU_MENU_NAME)
				$map["{$row[3]}:{$row[0]}"] = "%TPL_MENU_MENU_IDENT({$row[1]}:{$row[2]})%";
			}
		}
		else {
			// build token map
			while ($row = $result->fetchRow() )
			{
				// TPL_MENU_MENU_IDENT(ROOM_TYPE_NAME:TPL_MENU_MENU_NAME)
				//   => TPL_MENU_MENU_IDENT
				$map["%TPL_MENU_MENU_IDENT({$row[1]}:{$row[2]})%"] = $row[0];
			}
		}
		$result->free();

		return $map;
	}

	function getVcolMap($arrView = false)
	{
		if (is_array($arrView) && ! empty($arrView) ) {
			$viewCondition = ' and VIEW_NAME in ("'.implode('", "', $arrView).'")';
		}
		else {
			$viewCondition = '';
		}

		$select  =  "select VCOL_IDENT, VIEW_NAME, COL_NAME, VIEW_IDENT";
		$select .= " from VIEW, COL, VCOL, TAB";
		$select .= " where";
		$select .= "     VIEW_IDENT = VCOL_VIEW_IDENT";
		$select .= " and TAB_IDENT  = COL_TAB_IDENT";
		$select .= " and TAB_IDENT  = VIEW_TAB_IDENT";
		$select .= " and COL_IDENT  = VCOL_COL_IDENT";
		$select .= "{$viewCondition}";
		$result  = $this->DB->query($select);

		$map = array();
		if ($this->isMapFlipEnabled() ) {
			// build value map
			while ($row = $result->fetchRow() )
			{
				// VIEW_IDENT:VCOL_IDENT => VCOL_IDENT(VIEW_NAME:COL_NAME)
				$map["{$row[3]}:{$row[0]}"] = "%VCOL_IDENT({$row[1]}:{$row[2]})%";
			}
		}
		else {
			// build token map
			while ($row = $result->fetchRow() )
			{
				// VCOL_IDENT(VIEW_NAME:COL_NAME) => VCOL_IDENT
				$map["%VCOL_IDENT({$row[1]}:{$row[2]})%"] = $row[0];
			}
		}
		$result->free();

		return $map;
	}

	function getViewMap() {
		return $this->getMap('VIEW');
	}

	function getViewModeMap() {
		return $this->getMap('VIEW_MODE');
	}

	function getVersionModulesMap() {
		return $this->getMap('VERSION_MODULES');
	}

	function getWgroupMap($roomId = null)
	{
		if ($roomId === NULL) {
			$roomId = intval($roomId);
			$roomCondition = " and COURSE_ID = {$roomId}";
		}
		else {
			$roomCondition = '';
		}

		$select  = "select WGROUP_ID, COURSE_ID, WGROUP_NAME";
		$select .= " from WGROUP";
		$select .= " where STATE != 'T'";
		$select .= "{$roomCondition}";
		$result  = $this->DB->query($select);

		$map = array();
		if ($this->isMapFlipEnabled() ) {
			// build value map
			while ($row = $result->fetchRow() )
			{
				if (empty($row[2]) ) {
					$map["{$row[0]}"] = "{$row[0]}";
				}
				else {
					$map["{$row[0]}"] = "%WGROUP_IDENT({$row[1]}:{$row[2]})%";
				}
			}
		}
		else {
			// build token map
			while ($row = $result->fetchRow() )
			{
				if (empty($row[2]) ) {
					$map["{$row[0]}"] = $row[0];
				}
				else {
					$map["%WGROUP_IDENT({$row[1]}:{$row[2]})%"] = $row[0];
				}
			}
		}
		$result->free();

		return $map;
	}



} // Ende Klasse PMap


