<?php
/*
* $McLicense$
*
* $Id$
*
*/



/**
 * @package core
 * @subpackage classes.new
 */
class PMenuitem
{
	private $DB;

	private $DATA;
	private $CONTEXT;
	private $CONTEXT_TABLE;
	private $CONTEXT_PREFIX;
	private $CONTEXT_FK_NAME;
	private $CONTEXT_ID;
	private $mgrAccess;

	// constructor
	function PMenuitem ($context, $contextId)
	{
		global $U;
		$this->DB = &$U->DB;
	}


	function getInstancesOf($context, $contextId, $cssIdent, $state='')
	{
		global $U;

		if ($context == 'room')
		{
			$table  = 'MENUITEM';
			$prefix = 'MENUITEM_';
			$fkName = 'COURSE_ID';
		}
		else if ($context == 'template')
		{
			$table  = 'TPL_MENUITEM';
			$prefix = 'TPL_MENUITEM_MENUITEM_';
			$fkName = 'TPL_MENUITEM_ROOM_TYPE_IDENT';
		}
		else
		{
			throw new Exception("unknown context '$context'");
		}

		$cssIdent = trim($cssIdent);
		$state = trim($state);

		$query =
		   "select * from {$table}"
			." where"
			."     {$prefix}CSS_IDENT = ".$U->DB->quote($cssIdent)
			." and {$fkName} = {$contextId}"
			.(($state)
				? " and STATE = ".$U->DB->quote($state)
				: ""
			)
		;
		$r = $U->DB->query($query);

		if ($r->numRows() == 0)
		{
			// item not found
			return false;
		}

		$arrPMenuitem = array();
		$i = 0;
		while ($m = $r->fetchRow(DBMC_FETCHMODE_ASSOC))
		{
			$arrPMenuitem[$i] = new PMenuitem($context, $contextId);
			$rPMenuitem = &$arrPMenuitem[$i];
			$i++;

			if ($table == 'MENUITEM')
			{
				$roomId = intval($m['COURSE_ID']);

				$query = "select WGROUP_ID from WGROUP"
					." where WGROUP_NAME = 'KURSADMIN' and COURSE_ID = {$roomId}"
				;
				$adminGroupId = $U->DB->getOne($query);

				if (empty($adminGroupId) )
				{
					throw new Exception("missing member group for room {$roomId}");
				}

				$mgrAccess = array(
					'static' => array(
						$adminGroupId => 7,
					),
				);
			}
			else
			{
				$mgrAccess = null;
			}


			$rPMenuitem->setContext($context);
			$rPMenuitem->setContextTable($table);
			$rPMenuitem->setContextPrefix($prefix);
			$rPMenuitem->setContextFkName($fkName);
			$rPMenuitem->setContextId($contextId);
			$rPMenuitem->setMgrAccess($mgrAccess);
			$rPMenuitem->init($m);
		}
		$r->free();

		return $arrPMenuitem;
	} // end function getInstancesOf


	function init($m = null)
	{
		$contextId = $this->getContextId();
		$table  = $this->getContextTable();
		$prefix = $this->getContextPrefix();
		$fkName = $this->getContextFkName();
		$appField = $this->getAppField();
		$restrictField = $this->getRestrictField();

		if ( empty($m) )
		{
			$this->initDefault();
			return;
		}

		$this->setContextId($m["{$fkName}"]);
		$this->setAppIdent($m[$appField]);
		$this->setName($m["{$prefix}NAME"]);
		$this->setCap($m["{$prefix}CAP"]);
		$this->setCssIdent($m["{$prefix}CSS_IDENT"]);
		$this->setScript($m["{$prefix}SCRIPT"]);
		$this->setParam($m["{$prefix}PARAM"]);
		$this->setRestrict($m[$restrictField]);
		$this->setSid($m["{$prefix}SID"]);
		$this->setTarget($m["{$prefix}TARGET"]);
		$this->setView($m["{$prefix}VIEW"]);
		$this->setLayout($m["{$prefix}LAYOUT"]);
#		$this->setAccess($m["ACCESS"]);
		$this->setState($m["STATE"]);
		$this->setMenuIdent($m["{$prefix}MENU_IDENT"]);
		$this->setSub($m["{$prefix}SUB"]);
		$this->setCss($m["{$prefix}CSS"]);
		$this->setOrder($m["{$prefix}ORDER"]);
		$this->setOwner($m["OWNER"]);
#		$this->setWgroup($m["WGROUP"]);
		$this->setElementIdent($m["{$prefix}ELEMENT_IDENT"]);
		$this->setMenuitemlayIdent($m["{$prefix}MENUITEMLAY_IDENT"]);

		return true;
	} // end of method init


	function initDefault()
	{
		$this->setId(0);
		$this->setAppIdent($this->APP_IDENT);
		$this->setName('');
		$this->setCap('');
		$this->setCssIdent('');
		$this->setScript('login/show/show.php');
		$this->setParam('');
		$this->setRestrict('Y');
		$this->setSid('Y');
		$this->setTarget('um');
		$this->setView('');
		$this->setLayout('');
#		$this->setAccess(7);
		$this->setState('Y');
		$this->setMenuIdent(0);
		$this->setSub('');
		$this->setCss('');
		$this->setOrder(0);
		$this->setOwner(1);
#		$this->setWgroup(1);
		$this->setElementIdent(0);
		$this->setMenuitemlayIdent(0);

		return true;
	} // end of method initDefault


	// getter
	function getContext()       { return $this->CONTEXT;         }
	function getContextTable()  { return $this->CONTEXT_TABLE;   }
	function getContextPrefix() { return $this->CONTEXT_PREFIX;  }
	function getContextFkName() { return $this->CONTEXT_FK_NAME; }
	function getContextId()     { return $this->CONTEXT_ID;      }
	function getId()        { return $this->DATA['ID'];         }
	function getAppIdent()  { return $this->DATA['APP_IDENT'];  }
	function getName()      { return $this->DATA['NAME'];       }
	function getCap()       { return $this->DATA['CAP'];        }
	function getCssIdent()  { return $this->DATA['CSS_IDENT'];  }
	function getScript()    { return $this->DATA['SCRIPT'];     }
	function getParam()     { return $this->DATA['PARAM'];      }
	function getRestrict()  { return $this->DATA['RESTRICT'];   }
	function getSid()       { return $this->DATA['SID'];        }
	function getTarget()    { return $this->DATA['TARGET'];     }
	function getView()      { return $this->DATA['VIEW'];       }
	function getLayout()    { return $this->DATA['LAYOUT'];     }
#	function getAccess()    { return $this->DATA['ACCESS'];     }
#	function getInsdat()    { return $this->DATA['INSDAT'];     }
	function getState()     { return $this->DATA['STATE'];      }
	function getMenuIdent() { return $this->DATA['MENU_IDENT']; }
	function getSub()       { return $this->DATA['SUB'];        }
	function getCss()       { return $this->DATA['CSS'];        }
	function getOrder()     { return $this->DATA['ORDER'];      }
	function getOwner()     { return $this->DATA['OWNER'];      }
#	function getWgroup()    { return $this->DATA['WGROUP'];     }
	function getElementIdent() { return $this->DATA['ELEMENT_IDENT']; }
	function getMenuitemlayIdent() { return $this->DATA['MENUITEMLAY_IDENT']; }

	// setter
	function setContext($v)       { $this->CONTEXT         = $v; }
	function setContextTable($v)  { $this->CONTEXT_TABLE   = $v; }
	function setContextPrefix($v) { $this->CONTEXT_PREFIX  = $v; }
	function setContextFkName($v) { $this->CONTEXT_FK_NAME = $v; }
	function setContextId($v)     { $this->CONTEXT_ID      = intval($v); }
	function setId($v)        { $this->DATA['ID']         = intval($v); }
	function setAppIdent($v)  { $this->DATA['APP_IDENT']  = intval($v); }
	function setName($v)      { $this->DATA['NAME']       = $v; }
	function setCap($v)       { $this->DATA['CAP']        = $v; }
	function setCssIdent($v)  { $this->DATA['CSS_IDENT']  = $v; }
	function setScript($v)    { $this->DATA['SCRIPT']     = $v; }
	function setParam($v)     { $this->DATA['PARAM']      = $v; }
	function setRestrict($v)
	{
		if ($v === false || $v == 'N') {
			$this->DATA['RESTRICT'] = 'N';
		}
		else {
			$this->DATA['RESTRICT'] = 'Y';
		}
	}
	function setSid($v)
	{
		if ($v == 'N' or empty($v) ) {
			$this->DATA['SID'] = 'N';
		}
		else {
			$this->DATA['SID'] = 'Y';
		}
	}
	function setTarget($v)    { $this->DATA['TARGET']     = $v; }
	function setView($v)      { $this->DATA['VIEW']       = $v; }
	function setLayout($v)    { $this->DATA['LAYOUT']     = $v; }
#	function setAccess($v)    { $this->DATA['ACCESS']     = intval($v); }
#	function setInsdat($v)    { $this->DATA['INSDAT']     = $v; }
	function setState($v)     { $this->DATA['STATE']      = $v; }
	function setMenuIdent($v) { $this->DATA['MENU_IDENT'] = intval($v); }
	function setSub($v)       { $this->DATA['SUB']        = $v; }
	function setCss($v)       { $this->DATA['CSS']        = $v; }
	function setOrder($v)     { $this->DATA['ORDER']      = intval($v); }
	function setOwner($v)     { $this->DATA['OWNER']      = intval($v); }
#	function setWgroup($v)    { $this->DATA['WGROUP']     = intval($v); }
	function setElementIdent($v)
	{
		if ( is_numeric($v) )
		{
			$this->DATA['ELEMENT_IDENT'] = intval($v);
		}
		else
		{
			$s = "select ELEMENT_IDENT from ELEMENT where ELEMENT_NAME = '$v'";
			$e = $this->DB->getOne($s);
			$this->DATA['ELEMENT_IDENT'] = intval($e);
		}
	}
	function setMenuitemlayIdent($v) { $this->DATA['MENUITEMLAY_IDENT'] = intval($v); }


	function getAppField()
	{
		$table = $this->getContextTable();

		if ($table == 'TPL_MENUITEM') {
			return 'TPL_MENUITEM_APP_IDENT';
		}
		else {
			return 'MENUITEM_APP_IDENT';
		}
	}

	function getRestrictField()
	{
		$table = $this->getContextTable();

		if ($table == 'TPL_MENUITEM') {
			return 'TPL_MENUITEM_RESTRICT';
		}
		else {
			return 'MENUITEM_RESTRICT';
		}
	}

	function setMgrAccess($mgrAccess) { $this->mgrAccess = $mgrAccess; }
	function getMgrAccess()
	{
		if (empty($this->mgrAccess) )
		{
			return array();
		}
		else
		{
			return $this->mgrAccess;
		}
	}

#			$IdxSubMenuName         = 'TPL_MENUITEM_SUB_MENU_NAME';
#			$IdxSubMenuName         = 'MENUITEM_SUB_MENU_NAME';

#			$IdxSubMenuitemCssIdent = 'TPL_MENUITEM_SUB_MENUITEM_CSS_IDENT';
#			$IdxSubMenuitemCssIdent = 'MENUITEM_SUB_MENUITEM_CSS_IDENT';

	function create()
	{
		$context = $this->getContext();
		$contextId = $this->getContextId();
		$table  = $this->getContextTable();
		$prefix = $this->getContextPrefix();
		$fkName = $this->getContextFkName();

		$cssIdent = $this->getCssIdent();

		$query =
			 "select {$table}_ID from {$table}"
			." where"
			."     {$prefix}CSS_IDENT = ".$this->DB->quote($cssIdent)
			." and {$fkName} = {$contextId}"
		;
		$n = $this->DB->getOne($query);

		if ( ! empty($n) )
		{
			// item already exists
			SysMsg::showInfo("menu item '$cssIdent' does already exist for $context with id $contextId");
			return $n;
		}

		$appField = $this->getAppField();
		$restrictField = $this->getRestrictField();

		$i = "insert into {$table} set"
			."  {$appField} = " . $this->getAppIdent()
			.", {$prefix}MENU_IDENT = " . $this->getMenuIdent()
#			.", MENUITEM_IDENT"
			.", {$prefix}SUB  = " . $this->DB->quote($this->getSub())
			.", {$prefix}NAME = " . $this->DB->quote($this->getName())
			.", {$prefix}CAP  = " . $this->DB->quote($this->getCap())
#			.", {$prefix}PICT"
			.", {$prefix}ELEMENT_IDENT = " . $this->getElementIdent()
			.", {$prefix}VIEW   = " . $this->DB->quote($this->getView())
			.", {$prefix}LAYOUT = " . $this->DB->quote($this->getLayout())
			.", {$prefix}MENUITEMLAY_IDENT = " . $this->getMenuitemlayIdent()
			.", {$prefix}PARAM  = " . $this->DB->quote($this->getParam())
			.", {$prefix}SCRIPT = " . $this->DB->quote($this->getScript())
			.", {$prefix}TARGET = " . $this->DB->quote($this->getTarget())
			.", {$prefix}ORDER  = " . $this->getOrder()
#			.", {$prefix}ONCLICK"
#			.", {$prefix}ONMOUSEOVER"
#			.", {$prefix}ONMOUSEOUT"
			.", {$prefix}CSS = " . $this->DB->quote($this->getCss())
			.", {$prefix}SID = " . $this->DB->quote($this->getSid())
			.", {$restrictField} = " . $this->DB->quote($this->getRestrict())
			.", {$prefix}CSS_IDENT = " . $this->DB->quote($this->getCssIdent())
#			.", {$prefix}SUB_MENU_NAME"
#			.", {$prefix}SUB_MENUITEM_CSS_IDENT"
			.", {$fkName} = " . $contextId
			.", INSDAT = now()"
			.", OWNER  = " . $this->getOwner()
#			.", WGROUP = " . $this->getWgroup()
#			.", ACCESS = " . $this->getAccess()
			.", STATE  = " . $this->DB->quote($this->getState())
		;
		$r = $this->DB->query($i);

		$id = $this->DB->getLastInsertId();

		$u = "update {$table} set {$prefix}IDENT = {$id} where {$table}_ID = {$id}";
		$r = $this->DB->query($u);

		if ($table = 'MENUITEM')
		{
			$mgrAccess = $this->getMgrAccess();

			require_once(MCP_LIB_PATH . 'DsAccess.php');
			$DsAccess = new DsAccess();
			$DsAccess->registerByRessource($table, $id, 'VMENUITEM', 1, $contextId, 0, $mgrAccess);
		}

		SysMsg::showInfo("menu item '$cssIdent' for $context with id $contextId created");

		return $id;
	} // end method create

} // end class PMenuitem


