<?php
/*
* $McLicense$
*
* $Id$
*
*/


class PProfile
{
	var $DB;
	var $DBStruct;

	private $appId;

	function PProfile()
	{
		global $U;
		$this->DB = &$U->DB;
		$this->DBStruct = &$U->DBStruct;

		$this->appId = mc_Session::getApp();
	} // Ende Konstruktor



	private function getApp()
	{
		return $this->appId;
	}



	function hasParam($p_param_name)
	{
		$l_res = $this->DB->getOne("select count(*) from PARAM where PARAM_NAME = '".$p_param_name."'");

		if (empty($l_res))
		{
			return false;
		}

		return true;
	}



	function getParamCatIdentByName($p_paramcat_name)
	{
		$l_res = $this->DB->getOne("select PARAMCAT_IDENT from PARAMCAT where PARAMCAT_NAME = '".$p_paramcat_name."'");

		if (empty($l_res))
		{
			return false;
		}

		return $l_res;
	}



	function addParam($p_param_name, $p_paramcat_name, $p_param_type, $p_param_default = null, $p_param_input = null)
	{

		if ($this->hasParam($p_param_name))
		{
			SysMsg::showInfo("PARAM_NAME '".$p_param_name."' existiert bereits / already exists");
			return true;
		}

		$l_pcat_ident = $this->getParamCatIdentByName($p_paramcat_name);
		if ($l_pcat_ident == false)
		{
			SysMsg::showError("PARAMCAT '".$p_paramcat_name."' existiert nicht / doesn't exist");
			return false;
		}

		if ($p_param_default === null)
		{
			$p_param_default = 'null';
		}

		if ($p_param_input === null)
		{
			$p_param_input = 'null';
		}

		$this->DB->query(
			 'insert into PARAM ('
			.' PARAM_APP_IDENT, PARAM_PARAMCAT_IDENT, PARAM_NAME, PARAM_TYPE, PARAM_DEFAULT, PARAM_INPUT, STATE'
			.' ) values ('
			.' '.$this->getApp().', '.intval($l_pcat_ident).', "'.$p_param_name.'", "'.$p_param_type.'", "'.$p_param_default.'", "'.$p_param_input.'", "Y"'
			.' )'
		);

		$l_last_insert_id = $this->DB->getLastInsertId();

		$l_upd  =  "update PARAM";
		$l_upd .= " set";
		$l_upd .= " PARAM_IDENT = ".$l_last_insert_id;
		$l_upd .= " where";
		$l_upd .= " PARAM_IDENT is null";
		$this->DB->query($l_upd);

		return $l_last_insert_id;
	}



	function getParam($p_param_name)
	{
		$l_sel  =  "select PARAM_IDENT, PARAM_NAME, PARAM_TYPE, PARAM_DEFAULT, PARAM_PARAMCAT_IDENT";
		$l_sel .= " from PARAM";
		$l_sel .= " where";
		$l_sel .= "     STATE = 'Y'";
		$l_sel .= " and PARAM_NAME = '".$p_param_name."'";
		$l_res = $this->DB->getRow($l_sel, DBMC_FETCHMODE_ASSOC);

		return $l_res;
	}



	function getProfileValue($p_param_name, $p_user_ident = 0, $p_view_ident = 0, $p_room_id = null)
	{
		$l_param = $this->getParam($p_param_name);

		if (empty($l_param))
		{
			SysMsg::showWarning('param for PARAM_NAME "'.$p_param_name.'" not found');
			return;
		}

		if ($p_user_ident == 0 && $l_param['PARAM_PARAMCAT_IDENT'] != 5)
		{
			SysMsg::showWarning('PARAM_NAME "'.$p_param_name.'" is no system param. no user ident given. in order to read non-system-parameters you need to specify a user ident!');
			return;
		}

		if ($p_user_ident == 0 && $p_view_ident != 0)
		{
			SysMsg::showWarning('view ident given but MISSING user ident. in order to read view-parameters you need to specify a user ident!');
			return;
		}

		$l_sel  =  "select PROFILE_".$l_param['PARAM_TYPE']."_VALUE";
		$l_sel .= " from PROFILE";
		$l_sel .= " where";
		$l_sel .= "     STATE = 'Y'";
		$l_sel .= " and PROFILE_PARAM_IDENT = ".intval($l_param['PARAM_IDENT']);
		$l_sel .= " and PROFILE_APP_IDENT  = ".$this->getApp();
		if ($p_user_ident > 0)
		{
			$l_sel .= " and PROFILE_USER_IDENT  = ".intval($p_user_ident);
		}
		if ($p_view_ident > 0)
		{
			$l_sel .= " and PROFILE_VIEW_IDENT  = ".intval($p_view_ident);
		}
		if ($p_room_id !== null)
		{
			$l_sel .= " and COURSE_ID = ".intval($p_room_id);
		}
		$l_res = $this->DB->getRow($l_sel, DBMC_FETCHMODE_ASSOC);

		return $l_res;
	}



	function addProfile($p_param_name, $p_user_ident, $p_view_ident, $p_is_writeable = false, $p_profile_value = false )
	{
		if ($this->hasParam($p_param_name) == false)
		{
			SysMsg::showError("PARAM_NAME '".$p_param_name."' existiert nicht / doesn't exist");
			return true;
		}

		$l_param = $this->getParam($p_param_name);
		if ($l_param == false)
		{
			return false;
		}

		if (empty($p_user_ident))
		{
			$p_user_ident = 'null';
		}

		if (empty($p_view_ident))
		{
			$p_view_ident = 0;
		}

		if ($p_is_writeable == true)
		{
			$p_access = 7;
		}
		else
		{
			$p_access = 0;
		}

		if ($p_profile_value === null)
		{
			$p_profile_value = 'null';
		}
		else if ($p_profile_value === false)
		{
			$p_profile_value = '"'.addcslashes($l_param['PARAM_DEFAULT'], '"').'"';
		}
		else
		{
			$p_profile_value = '"'.addcslashes($p_profile_value, '"').'"';
		}

		$l_id = $this->DB->getOne(
			 'select'
			.'  PROFILE_ID'
			.' from'
			.'  PROFILE'
			.' where'
			.'     PROFILE_APP_IDENT  = '.$this->getApp()
			.' and (PROFILE_USER_IDENT = 0 or PROFILE_USER_IDENT = '.$p_user_ident.')'
			.' and PROFILE_VIEW_IDENT = '.$p_view_ident
			.' and PROFILE_PARAM_IDENT = '.intval($l_param['PARAM_IDENT'])
			.' and STATE = "Y"'
		);

		if ($l_id)
		{
			return true;
		}

		$l_sel  =  "insert into PROFILE";
		$l_sel .= " ( PROFILE_APP_IDENT, PROFILE_USER_IDENT, PROFILE_VIEW_IDENT, PROFILE_PARAM_IDENT, PROFILE_PARAM_NAME,";
		$l_sel .= "   PROFILE_".$l_param['PARAM_TYPE']."_VALUE, ACCESS, STATE )";
		$l_sel .= " values";
		$l_sel .= " ( ".$this->getApp().", ".$p_user_ident.", ".$p_view_ident.", ".intval($l_param['PARAM_IDENT']).", '".$l_param['PARAM_NAME']."',";
		$l_sel .= "   ".$p_profile_value.", ".$p_access.", 'Y')";
		$this->DB->query($l_sel);

		return true;
	}



  /**
  * creates a new user profile / add missing parameters to a users profile
  */
	function repairUserProfile($p_user_ident, $p_default_params = array())
	{
		if (empty($p_user_ident))
		{
			mc_Debug::error($p_user_ident, 'parameter user_ident is empty');
			return false;
		}

		if (is_array($p_default_params) == false)
		{
			mc_Debug::error($p_default_params, 'parameter default_params is not an array');
			return false;
		}

 		// Parameter und Defaultwerte holen
 		$sel = "select PARAM_IDENT, PARAM_NAME, PARAM_TYPE, PARAM_DEFAULT";
 		$sel.=" from PARAM, PARAMCAT";
 		$sel.=" where";
 		$sel.="     PARAM_PARAMCAT_IDENT = PARAMCAT_IDENT";
 		$sel.=" and PARAMCAT_NAME  != 'SYSTEM'";
 		$sel.=" and ( PARAM_INPUT != 'S'  or PARAM_INPUT is null or PARAM_INPUT = '')";
 		$sel.=" and PARAMCAT.STATE = 'Y'";
 		$sel.=" and PARAM.STATE = 'Y'";
 		$result = $this->DB->query($sel);

 		// Parameter eintragen
 		if ($result->numRows() == 0 )
 		{
			mc_Debug::error($result, "no profile template found");
 			return false;
 		}

 		while ($params = $result->fetchRow(DBMC_FETCHMODE_ASSOC))
 		{
 			switch ($params['PARAM_NAME'])
 			{
 				case 'RIGHT' :
 				case 'RIGHT_GROUP' :
 				case 'LANGUAGE' :
 					continue 2;
 					break;

 				case 'HOMENODE' :
					break;

				default :
					break;
			}

			// defaults fr benutzer berschreiben globale defaults (bspw. spracheinstellung)
 			if (isSet($p_default_params[$params['PARAM_NAME']]))
 			{
 				$params['PARAM_DEFAULT'] = $p_default_params[$params['PARAM_NAME']];
 			}

			if ($params['PARAM_TYPE'] == 'INT')
			{
 				$l_default = intval($params['PARAM_DEFAULT']);
			}
			else
			{
 				$l_default = '"'.addslashes($params['PARAM_DEFAULT']).'"';
			}

			$ins  = "insert into PROFILE (PROFILE_USER_IDENT, PROFILE_APP_IDENT, PROFILE_PARAM_IDENT, PROFILE_VIEW_IDENT, PROFILE_PARAM_NAME, PROFILE_PARAM_TYPE, PROFILE_".$params['PARAM_TYPE']."_VALUE, WGROUP, INSDAT, STATE) ";
			$ins .= "VALUES (".$p_user_ident.", ".$this->getApp().", ".$params['PARAM_IDENT'].", 0, '".$params['PARAM_NAME']."', '".$params['PARAM_TYPE']."', ".$l_default.", 0, now(), 'Y')";
 			$this->DB->query($ins);
 		} // end while

		$result->free();

		return true;

	} // Ende Funktion repairUserProfile



###
### CLEANUP PROFILE
###
	function cleanup()
	{
		SysMsg::showMsg('cleaning up PROFILE from invalid accounts. please hang on...');

		$countBefore = $this->DB->getOne('select count(PROFILE_ID) from PROFILE');

		$missing_profile_users = $this->DB->getCol(
			 "select distinct PROFILE_USER_IDENT"
			." from PROFILE"
			." left join USER"
			." on USER_IDENT = PROFILE_USER_IDENT"
			." where"
			."     PROFILE_USER_IDENT > 0"
			." and USER_ID is null"
		);

		foreach($missing_profile_users as $user_id)
		{
			$this->DB->query(
				"delete from PROFILE where PROFILE_USER_IDENT = ".intval($user_id)
			);
		} // end foreach

		$countAfter = $this->DB->getOne('select count(PROFILE_ID) from PROFILE');

		if (count($missing_profile_users))
		{
			$countDel = $countBefore - $countAfter;
			$countAcc = count($missing_profile_users);
			SysMsg::showInfo("{$countDel} entries from {$countAcc} deprecated accounts deleted");
		}
		else
		{
			SysMsg::showInfo('no entries of deprecated accounts found in table PROFILE');
		}

		SysMsg::showMsg('cleaning up PROFILE from invalid room. please hang on...');

		$countBefore = $this->DB->getOne('select count(PROFILE_ID) from PROFILE');

		$missing_profile_rooms = $this->DB->getCol(
			 "select distinct PROFILE.COURSE_ID"
			." from PROFILE"
			." left join COURSE"
			." on COURSE.COURSE_ID = PROFILE.COURSE_ID"
			." where"
			."     PROFILE.COURSE_ID is not null"
			." and COURSE.COURSE_ID is null"
		);

		foreach($missing_profile_rooms as $room_id)
		{
			$this->DB->query(
				"delete from PROFILE where PROFILE.COURSE_ID = ".intval($room_id)
			);
		} // end foreach

		$countAfter = $this->DB->getOne('select count(PROFILE_ID) from PROFILE');

		if (count($missing_profile_rooms))
		{
			$countDel = $countBefore - $countAfter;
			$countRoom = count($missing_profile_rooms);
			SysMsg::showInfo("{$countDel} entries from {$countRoom} deprecated accounts deleted");
		}
		else
		{
			SysMsg::showInfo('no entries of deprecated rooms found in table PROFILE');
		}

		$this->DBStruct->optimize('PROFILE', true);

		return true;
	}

} // Ende Klasse PProfile

