<?php
/*
* $McLicense$
*
* $Id$
*
*/


/**
 * PQTIRegister
 *
 * @author [Autor]
 * @version 1.0
 * @package core
 * @subpackage classes.new
 */
class PQTIRegister
{
	var $DB;

	var $group_name_cache;

	/**
	 * constructor
	 */
	function QTIRegister()
	{
		global $U;
		$this->DB = &$U->DB;
	} // ende constructor



	function getGUID($p_uri)
	{
		$l_pattern = "/GUID_([a-zA-Z0-9:\-]+)/";

		$l_qti = array ();

		$l_course_cfg_path = $p_uri;

		if (file_exists($l_course_cfg_path))
		{
			$l_content = implode('', file($l_course_cfg_path));

			$l_match = array ();
			preg_match($l_pattern, $l_content, $l_match);

			$l_qti = array();
			$qti_items= array();

			if (!empty ($l_match[1]))
			{
				$dom_xml = domxml_open_mem($l_content);
				$qti_comment_array = $dom_xml->get_elements_by_tagname('qticomment');
				$qti_items = $dom_xml->get_elements_by_tagname('item');

				$qti_name = $qti_comment_array[0]->get_content();
				$dom_xml->free();

				$l_qti['id'] = $l_match[1];
				$l_qti['name'] = $qti_name;
				$l_qti['content'] = $l_content;
				$l_qti['test_item_count'] = sizeof($qti_items);
			}
		}

		return $l_qti;
	} // end method getGUID




	function insertQtiFile($p_data)
	{
		if (empty($p_data))
		{
			return false;
		}

		$l_arr_guid = $this->getGUID($p_data['FILE']);

		$res = $this->DB->query(
			 'insert into ELQUES_REG ('
			.'  ELQUES_REG_GUID'
			.', ELQUES_REG_GUVERSION'
			.', ELQUES_REG_FILENAME'
			.', ELQUES_REG_DESC'
			.', ELQUES_REG_XML'
			.', ELQUES_REG_PATH'
			.', ELQUES_REG_ITEMS'
			.', ELQUES_REG_COURSE_CID'
			.', ELQUES_REG_COURSE_NODE_ID'
			.', ELQUES_REG_M2_VERANST_ID'
			.', OWNER'
			.', COURSE_ID'
			.' ) values ('
			.'  '.$this->DB->quote($l_arr_guid['id'])
			.', ""'
			.', '.$this->DB->quote($p_data['FILE'])
			.', '.$this->DB->quote($l_arr_guid['name'])
			.', '.$this->DB->quote($l_arr_guid['content'])
			.', '.$this->DB->quote($p_data['MCQFILE'])
			.', '.intval($l_arr_guid['test_item_count'])
			.', '.intval($p_data['COURSE_CID'])
			.', '.intval($p_data['COURSE_NODE_ID'])
			.', '.intval($p_data['M2_VERANST_ID'])
			.', '.intval($p_data['OWNER'])
			.', '.intval($p_data['COURSE_ID'])
			.' )'
		);

		$insertId = $this->DB->getOne("select LAST_INSERT_ID()");
		$insertId = intval($insertId);

		return $insertId;
	} // end method insertQtiFile




	function isQtiFileRegistered($p_data)
	{
		if (empty($p_data))
		{
			return false;
		}

		$l_arr_guid = $this->getGUID($p_data['FILE']);

		$res = $this->DB->getOne(
			 'select ELQUES_REG_ID from ELQUES_REG'
			.' where'
			.'     ELQUES_REG_GUID       = '.$this->DB->quote($l_arr_guid['id'])
			.' and ELQUES_REG_GUVERSION  = ""'
			.' and ELQUES_REG_FILENAME   = '.$this->DB->quote($p_data['FILE'])
			.' and ELQUES_REG_DESC       = '.$this->DB->quote($l_arr_guid['name'])
			.' and ELQUES_REG_XML        = '.$this->DB->quote($l_arr_guid['content'])
			.' and ELQUES_REG_PATH       = '.$this->DB->quote($p_data['MCQFILE'])
			.' and ELQUES_REG_ITEMS      = '.intval($l_arr_guid['test_item_count'])
			.' and ELQUES_REG_COURSE_CID = '.intval($p_data['COURSE_CID'])
			.' and ELQUES_REG_COURSE_NODE_ID = '.intval($p_data['COURSE_NODE_ID'])
			.' and ELQUES_REG_M2_VERANST_ID  = '.intval($p_data['M2_VERANST_ID'])
			.' and COURSE_ID = '.intval($p_data['COURSE_ID'])
		);

		if (empty($res) )
		{
			return false;
		}

		return intval($res);
	}


}

