<?php
/*
* $McLicense$
*
* $Id$
*
*/


class PView
{
	var $DB;

	function PView()
	{
		global $U;
		$this->DB = &$U->DB;
	} // Ende Konstruktor



	function getViewIdentByName($p_view_name)
	{
		$l_sel  =  "select VIEW_IDENT";
		$l_sel .= " from VIEW";
		$l_sel .= " where";
		$l_sel .= "     VIEW_NAME = '".$p_view_name."'";
		$l_sel .= " and STATE = 'Y'";
		$l_res  = $this->DB->getOne($l_sel);

		if (empty($l_res))
		{
			return 0;
		}

		return $l_res;
	}



	function getMapOfViewIdent($p_name_list = null) {
		return $this->getMap(false, $p_name_list);
	}


	function getMapOfViewName($p_name_list = null) {
		return $this->getMap(true, $p_name_list);
	}



	function getMap($p_has_name_index, $p_name_list = null)
	{
		$l_sel  =  "select VIEW_IDENT, VIEW_NAME, TAB_IDENT, TAB_NAME";
		$l_sel .= " from VIEW, TAB";
		$l_sel .= " where";
		$l_sel .= "     VIEW_TAB_IDENT = TAB_IDENT";
		if (is_array($p_name_list) && sizeof($p_name_list) > 0)
		{
			$l_sel .= " and VIEW_NAME in ('".implode("', '", $p_name_list)."')";
		}
		$l_sel .= " and VIEW.STATE = 'Y'";
		$l_sel .= " and TAB.STATE = 'Y'";
		$l_res  = $this->DB->query($l_sel);

		$l_map = array();
		while ($l_row = $l_res->fetchRow(DBMC_FETCHMODE_ASSOC))
		{
			if ($p_has_name_index == true) {
				$l_map[$l_row['VIEW_NAME']] = $l_row;
			}
			else {
				$l_map[$l_row['VIEW_IDENT']] = $l_row;
			}
		}

		return $l_map;
	}



	function delete($viewName, $killFullComponent = false)
	{
		$viewName = mysql_real_escape_string($viewName);

		$select = "select VIEW_IDENT from VIEW where VIEW_NAME = '{$viewName}'";
		$viewId = $this->DB->getOne($select);
		$viewId = intval($viewId);

		if (empty($viewId) )
		{
			SysMsg::showInfo("VIEW '{$viewName}' not found (already deleted)");
			return true;
		}
		else
		{
			SysMsg::showMsg("VIEW '{$viewName}' found : deleting view...");
		}

		$this->DB->query('delete from VCOL where VCOL_VIEW_IDENT = '.$viewId);
		SysMsg::showInfo("all VCOL entries of view '{$viewName}' deleted");

		if ($killFullComponent)
		{
			$select  = "select TAB_NAME, TAB_IDENT from VIEW, TAB";
			$select .= " where VIEW_NAME = '{$viewName}' and TAB_IDENT = VIEW_TAB_IDENT";
			$arrTabs = $this->DB->getRow($select);
			$tabId = intval($arrTabs[1]);
			$tabName = trim($arrTabs[0]);
			unset($arrTabs);

			if (empty($tabName) )
			{
				SysMsg::showError("table '{$tabName}' is (already) unknown");
				return false;
			}

			$select  = "select distinct VIEW_NAME from VIEW";
			$select .= " where VIEW_NAME != '{$viewName}' and VIEW_TAB_IDENT = {$tabId}";
			$arrViews = $this->DB->getCol($select);
			if ( ! empty($arrViews) )
			{
				$strViews = implode(', ', $arrViews);
				SysMsg::showError("There are more depending views left ({$strViews}). In order to kill the full component you need to removed this views first!");
				return false;
			}
			unset($arrViews);

			$dsIdSelect = "select DS_ID from {$tabName} where DS_ID is not null";

			$select  = "select count(DS_ACCESS_ID) from DS_ACCESS";
			$select .= " where DS_ACCESS_DS_ID in ({$dsIdSelect})";
			$countAccess = $this->DB->getOne($select);

			$query = "delete from DS_ACCESS where DS_ACCESS_DS_ID in ({$dsIdSelect})";
			$this->DB->query($query);
			SysMsg::showInfo("{$countAccess} entries deleted from table 'DS_ACCESS'");


			$select  = "select count(DS_LINK_ID) from DS_LINK";
			$select .= " where DS_LINK_SRC_DS_ID in ({$dsIdSelect})";
			$select .= " or DS_LINK_DEST_DS_ID in ({$dsIdSelect})";
			$countLink = $this->DB->getOne($select);

			$query  = "delete from DS_LINK";
			$query .= " where DS_LINK_SRC_DS_ID in ({$dsIdSelect})";
			$query .= " or DS_LINK_DEST_DS_ID in ({$dsIdSelect})";
			$this->DB->query($query);
			SysMsg::showInfo("{$countLink} entries deleted from table 'DS_LINK'");


			$select  = "select count(DS_ID) from DS";
			$select .= " where DS_ID in ({$dsIdSelect})";
			$countDs = $this->DB->getOne($select);

			$query  = "delete from DS where DS_ID in ({$dsIdSelect})";
			$this->DB->query($query);
			SysMsg::showInfo("{$countDs} entries deleted from table 'DS'");

			// table LINK    is skipped intentionally !
			// table ELEMENT is skipped intentionally !
			// table WRIGHT  is skipped intentionally !

			$this->DB->query('delete from COL where COL_TAB_IDENT = '.$tabId);
			SysMsg::showInfo("all COL entries of table '{$tabName}' deleted");

			$this->DB->query('delete from TAB where TAB_IDENT = '.$tabId);
			SysMsg::showInfo("table '{$tabName}' deleted from TAB");
		}

		$select  = 'select LAYOUT_NAME, LAYOUT_PATH from LAYOUT';
		$select .= ' where LAYOUT_VIEW_IDENT = '.$viewId;
		$layoutData = $this->DB->getRow($select);
		$layoutName = trim($layoutData[0]);
		$layoutPath = trim($layoutData[1]);
		$layoutDir  = MC_LAYOUT_PATH . 'default_theme' . DIRECTORY_SEPARATOR;

		if ( ! empty($layoutName) )
		{
			$arrScript = array(
				'show.php',
				'showform.php',
				'insertform.php',
				'updateform.php',
			);

			foreach ($arrScript as $scriptName)
			{
				$sub = $layoutPath . $scriptName . '.lay';
				$dir = $layoutDir . $sub;
				if ( ! @file_exists($dir) )
				{
					continue;
				}

				if ( @unlink($dir) )
				{
					SysMsg::showInfo("layout file '{$sub}' deleted");
				}
			} // end foreach

			$this->DB->query('delete from LAYOUT where LAYOUT_VIEW_IDENT = '.$viewId);
			SysMsg::showInfo("LAYOUT '{$layoutName}' deleted");
		} // end if

		$this->DB->query('delete from LANGTXT where LANGTXT_VIEW_IDENT = '.$viewId);
		SysMsg::showInfo("all LANGTXT entries of view '{$viewName}' deleted");

		$this->DB->query('delete from EXTFUNC where EXTFUNC_VIEW_IDENT = '.$viewId);
		SysMsg::showInfo("all EXTFUNC entries of view '{$viewName}' deleted");

		$select  = 'select LABEL_IDENT, LABEL_NAME from LABEL';
		$select .= ' where LABEL_VIEW_IDENT = '.$viewId;
		$labelData = $this->DB->getRow($select);

		if ( empty($labelData) )
		{
			SysMsg::showWarning("no LABEL found for view '{$viewName}'!");
		}
		else
		{
			$labelId   = intval($labelData[0]);
			$labelName = trim($labelData[1]);

			$this->DB->query('delete from LABELITEM where LABELITEM_LABEL_IDENT = '.$viewId);
			SysMsg::showInfo("all LABELITEM entries of label '{$labelName}' deleted");

			$this->DB->query('delete from LABEL where LABEL_IDENT = '.$viewId);
			SysMsg::showInfo("all LABEL '{$labelName}' deleted");
		}

		$this->DB->query("delete from MENUITEM where MENUITEM_VIEW = '{$viewName}'");
		SysMsg::showInfo("all MENUITEMS for view '{$viewName}' deleted");

		$this->DB->query("delete from TPL_MENUITEM where TPL_MENUITEM_MENUITEM_VIEW = '{$viewName}'");
		SysMsg::showInfo("all TPL_MENUITEMS for view '{$viewName}' deleted");

		$this->DB->query("delete from VIEW_FUNC where VIEW_FUNC_VIEW_IDENT = '{$viewId}'");
		SysMsg::showInfo("all VIEW_FUNCS for view '{$viewName}' deleted");

		$this->DB->query('delete from VIEW where VIEW_IDENT = '.$viewId);
		SysMsg::showInfo("VIEW '{$viewName}' deleted");

		return true;
	}



}


