<?php
/*
* $McLicense$
*
* $Id$
*
*/


if ( defined("MC_ROOT_PATH") == false)
{
	include_once("../../dblog.inc.php");
}

require_once(MCP_PATH."_classes/Plattform.php");


/**
 * Label
 *
 * @author [Autor]
 * @version 1.0
 * @package core
 * @subpackage classes.new
 */
class Label
	extends Plattform
{
	function Label()
	{
		$this->Plattform();

		return true;
	} // Ende Konstruktor



	function maintainLabel($viewName, $arrItemColumns, $labelName = null, $labelScheme = null)
	{
		SysMsg::showMsg("checking label for view '$viewName'");

		$viewName = trim($viewName);
		$labelScheme = trim($labelScheme);

		$labelName = trim($labelName);
		if (empty($labelName)) {
			$labelName = $viewName;
		}

		if ( ! is_array($arrItemColumns) ) {
			Plattform::error($arrItemColumns, 'parameter 2 is not an array');
			return false;
		}

		if ( empty($arrItemColumns) ) {
			Plattform::error($arrItemColumns, "list of label items is empty (view '$viewName')");
			return false;
		}

	  $viewData = $this->DB->getRow(
			'select * from VIEW where VIEW_NAME = "'.addcslashes($viewName).'"'
			, DB_FETCHMODE_ASSOC
	  );

		$viewId = intval($viewData['VIEW_IDENT']);
		$tabId  = intval($viewData['VIEW_TAB_IDENT']);

	  $result = $this->DB->query(
			 'select VCOL_IDENT, COL_NAME from VCOL, COL where'
			.'     COL_TAB_IDENT = '.$tabId
			.' and VCOL_COL_IDENT = COL_IDENT'
			.' and VCOL_VIEW_IDENT = '.$viewId
	  );

		$arrLabelItems = array();

		while ($row = $result->fetchRow()) {
			$colName = trim($row[1]);

			if ( isset($arrItemColumns[$colName]) ) {
				$vcolIdent = intval($row[0]);
				$arrLabelItems[$vcolIdent] = $arrItemColumns[$colName];
			} // end if
		} // end while
		$result->free();

		if ( empty($arrLabelItems) ) {
			SysMsg::showError("no matching registered columns found for requested columns of view '$viewName'");
			return false;
		}

	  $checkLabelIdents = $this->DB->getCol(
			 'select distinct LABEL_IDENT from LABEL where'
			.' LABEL_NAME = "'.$labelName.'" and  LABEL_VIEW_IDENT = '.$viewId
	  );

		$labelCount = count($checkLabelIdents);

	  $labelIdent = 0;
	  $arrLabelItemVcolIdent = array();

		if ($labelCount == 0) {
			// label does not exist
			SysMsg::showMsg("no label found. create label with name '$labelName' :");
		}
		else if ($labelCount > 1) {
			SysMsg::showMsg("more than one label found for name '$labelName'. deleting ambiguous labels an creating a new one :");
			// delete ambiguous labels
			$del = 'delete from LABEL where LABEL_NAME = "'.$labelName.'" and  LABEL_VIEW_IDENT = '.$viewId;
			$res = $this->DB->query($del);
			// delete related label items
			$del = "delete from LABELITEM where LABELITEM_LABEL_IDENT in (".implode(', ', $checkLabelIdents).")";
			$res = $this->DB->query($del);
		}
		else {
			$labelIdent = intval($checkLabelIdents[0]);

			// check items
			$inStringVcolIdent = implode(', ', array_keys($arrLabelItems));

			$arrLabelItemVcolIdent = $this->DB->getCol(
				 'select distinct LABELITEM_VCOL_IDENT'
				.' from LABELITEM'
				.' where'
				.'     LABELITEM_LABEL_IDENT = '.$labelIdent
				." and LABELITEM_VCOL_IDENT in ($inStringVcolIdent)"
			);
		}
		unset($checkLabelIdents, $labelCount);

	  if ( empty($labelIdent) ) {
	  	$labelIdent = $this->createLabel($viewId, $labelName, $labelScheme);
			if (empty($labelIdent)) {
				return false;
			}
			SysMsg::showInfo("creating label '$labelName' {SUCCEEDED}");
		}

		$order = 0;
		foreach ($arrLabelItems as $vcolIdent => $itemName) {
  		$order++;
  		if (in_array($vcolIdent, $arrLabelItemVcolIdent) ) {
				// item does already exist
  			continue;
  		}

			// item does not exist

  		$isValid = $this->createItem($labelIdent, $vcolIdent, $itemName, $order);
			if ($isValid) {
				SysMsg::showInfo("creating missed label item '$itemName' {SUCCEEDED}");
			}
			else {
				SysMsg::showError("creating missed label item '$itemName' {FAILED}");
			}
		} // end foreach

		return true;
	} // end function createLabel



	function createLabel($viewId, $labelName, $labelScheme) {
		$res = $this->DB->query(
			 'insert into LABEL set'
			.'  LABEL_NAME = "'.addslashes($labelName).'"'
			.', LABEL_SCHEME = "'.addslashes($labelScheme).'"'
			.', LABEL_VIEW_IDENT = '.$viewId
			.', LABEL_TYPE_IDENT = 0'
			.', LABEL_APP_IDENT = '.$this->APP_IDENT
			.', STATE = "Y"'
		);

		$labelIdent = $this->DB->getOne("select last_insert_id()");

		$labelIdent = intval($labelIdent);

		$res = $this->DB->query(
			 'update LABEL set '
			.'  LABEL_IDENT = '.$labelIdent
			.' where'
			.'  LABEL_ID = '.$labelIdent
		);

		return $labelIdent;
	} // end function createLabel



	function createItem($labelIdent, $vcolIdent, $itemName, $order) {

	  $res = $this->DB->query(
			 'insert into LABELITEM set'
			.'  LABELITEM_NAME = "'.addslashes($itemName).'"'
			.', LABELITEM_LABEL_IDENT = '.$labelIdent
			.', LABELITEM_VCOL_IDENT = '.$vcolIdent
			.', LABELITEM_APP_IDENT = '.$this->APP_IDENT
			.', LABELITEM_ORDER = '.$order
			.', STATE = "Y"'
	  );

		return true;
	} // end function createLabel



} // end class Label

