<?php
/*
* $McLicense$
*
* $Id$
*
*/



/**
 *
 */
function __autoload($className)
{
	if ( @include_once(MCP_LIB_PATH . 'Debug' . DIRECTORY_SEPARATOR . $className.'.php') ) {
		return true;
	}
	else if ( @include_once($className.'.php') ) {
		return true;
	}
	else {
		return false;
	}
}



/**
 *
 */
function getDSN($arrConnectData)
{
	extract($arrConnectData);
	$DSN = "mysql://{$dbuser}:{$pwd}@tcp+{$dbhost}:{$dbport}/{$db}";
	return $DSN;
}



$errorReporting = E_ALL;
if (defined("E_STRICT") )
{
	$errorReporting = $errorReporting & ~E_STRICT;
}
if (defined("E_DEPRECATED") )
{
	$errorReporting = $errorReporting & ~E_DEPRECATED;
}
if (defined("E_USER_DEPRECATED") )
{
	$errorReporting = $errorReporting & ~E_USER_DEPRECATED;
}
define('E_MC_ALL', $errorReporting);


if ( ! function_exists('buildPath') )
{
	/**
	 *
	 */
	function buildPath()
	{
		$arrDirectories = func_get_args();
		$path = implode(DIRECTORY_SEPARATOR, $arrDirectories).DIRECTORY_SEPARATOR;
		return $path;
	} // end function buildPath
}



if ( ! function_exists('transcribe') )
{
	/**
	 *
	 */
	function transcribe($aList, $aIsTopLevel = true)
	{
		$isMagic = get_magic_quotes_gpc();
		if (is_array($aList))
		{
			$gpcList = array();
			foreach ($aList as $key => $value)
			{
				if (is_array($value))
				{
					$decodedKey = ($isMagic && !$aIsTopLevel)? stripslashes($key):$key;
					$decodedValue = transcribe($value, false);
				}
				else
				{
					$decodedKey = stripslashes($key);
					$decodedValue = ($isMagic)? stripslashes($value):$value;
				}
				$gpcList[$decodedKey] = $decodedValue;
			} // end foreach

			return $gpcList;
		} // end if

		return (($isMagic)? stripslashes($aList):$aList);
	} // end function transcribe
}



if ( ! function_exists('loadLib') )
{
	/**
	 *
	 */
	function loadLib($file, $libName = null)
	{
		$fileName = basename($file);
		$dirName  = dirname($file);

		$libBaseDir  = $dirName . DIRECTORY_SEPARATOR . 'lib' . DIRECTORY_SEPARATOR;

		if (empty($libName) ) {
			$libFileName = str_replace('.php', '.lib.php', $fileName);
		}
		else {
			$libFileName = $libName.'.lib.php';
		}

		$libSrc = $libBaseDir . $libFileName;

		if ( ! file_exists($libSrc) )
		{
			SysMsg::showError("can not load lib '{$libSrc}' : file not found");
			die();
		}

		include_once($libSrc);

		return true;
	} // end function loadLib
}



if ( ! function_exists('addIncludePath') )
{
	/**
	 * @DEPRECATED ! only supported up to mc20.stable
	 */
	function addIncludePath($addPath)
	{
		if ( is_array($addPath) ) {
			$addPath = implode(PATH_SEPARATOR, $addPath);
		}
		$oldPath  = get_include_path();

		// start always with local directory
		$newPath = '.' . PATH_SEPARATOR . $addPath . PATH_SEPARATOR . $oldPath;

		// make paths unique
		$newPath = implode(PATH_SEPARATOR, array_unique(explode(PATH_SEPARATOR, $newPath)));

		set_include_path($newPath);
	} // end function addIncludePath
}