<?php
/*
* $McLicense$
*
* $Id$
*
*/


if (file_exists('../_inc/standalone.php')) {
	@include_once('../_inc/standalone.php');
}

$localPath = dirname(__FILE__) . DIRECTORY_SEPARATOR;
$corePath = MCP_LIB_PATH . 'core' . DIRECTORY_SEPARATOR;
$logPath = MCP_PATH . MCP_LOG_DIR . DIRECTORY_SEPARATOR;
$logUrl  = MCP_URI . MCP_LOG_DIR . '/';

$post = &$_POST;

if ( ! empty($_GET['show']) ) {
	$file = basename($_GET['show']);
	if (is_file($logPath . $file) ) {
		$strOut = file_get_contents($logPath . $file);
		$htmlOut = htmlentities($strOut);
		unset($strOut);
		echo "<pre style='font-size:12px;'>{$htmlOut}</pre>";
		die();
	}
}

$cfg = parse_ini_file($localPath . 'compare_db_contents.ini', true);
require_once($corePath . 'PMap.php');

function replace(&$str, &$arr) {
	$arrKeys = array_keys($arr);
	$str = str_replace($arrKeys, $arr, $str);
} // end function replace


function normalizePrimaryKeys(&$value, $key) {
	$value = str_replace(" ", "", $value);
	$value = explode(".", $value);
} // end function normalizePrimaryKeys


# DATABASE_ACCESS OLD
$old = $cfg['DB_LOGIN_OLD'];
$dsnOld = getDSN($old);
$dbOld = DBMC::connect($dsnOld);

# DATABASE_ACCESS NEW
$new = $cfg['DB_LOGIN_NEW'];
$dsnNew = getDSN($new);
$dbNew = DBMC::connect($dsnNew);

$PMap = new PMap();

// fetch string replace array
$arrReplaceOld = array_flip($cfg['REPLACE_OLD']['replace']);
$arrReplaceNew = array_flip($cfg['REPLACE_NEW']['replace']);
$arrReplace = array_merge($arrReplaceNew, $arrReplaceOld);
#$arrReplace[$old['db']] = $new['db']; // not correct. must replace both db names with same token !!!
$arrReplace = array_unique($arrReplace);
unset($arrReplaceNew, $arrReplaceOld);

$arrInsertPresets = $cfg['INSERT_PRESETS'];

// fetch blacklisted tables from log file it log file exists
$fb_name = $logPath . "_dbCompare.{$old['db']}-{$new['db']}.BLACKLIST.txt";
if (! isset($post['blacklist']) && file_exists($fb_name) ) {
	$post['blacklist'] = file_get_contents($fb_name);
}
// fetch default of blacklisted tables if blacklist is empty
if (empty($post['blacklist']) ) {
	$post['blacklist'] = implode("\n", $cfg['BLACKLIST']['tables']);
}

// when comparing table contents the columns with the names given from this array will be ignored in all tables
$arrBLColumns = $cfg['BLACKLIST']['columns'];
// flip backlist for search with "isset" instead of "in_array"
$arrBlacklistedColumns = array_flip($arrBLColumns);
unset($arrBLColumns);

$primaryKeySeparator = $cfg['MPS']['separator'];

// scheme:  [table_name]=> [dot-seperated list of column names for unique key]
// example: "LANGTXT"=>"LANGTXT_VIEW_IDENT.LANGTXT_SCRIPT_IDENT.LANGTXT_VARIABLE",
$arrTabPrimary = $cfg['MPS']['unique'];
array_walk($arrTabPrimary, 'normalizePrimaryKeys');


echo <<<PAGESTART

<script type="text/javascript">
<!--

  disableScrolling();

	function start_check() {}

	function hauAb( str ) {
		document.check.blacklist.value = document.check.blacklist.value + " \\n" + str;
		document.check.submit();
	}

	window.onload = "start_check(); document.check.blacklist.focus();";

//-->
</script>

<style type="text/css">
body {
	font-family: verdana, helvetica, arial;
	font-size: 12px;
}

td {
	vertical-align: top;
	padding: 5px 20px 5px 3px;
	font-family: verdana, helvetica, arial;
	font-size: 12px;
}
td.action {
	width: 50px;
}
td.count {
	width: 50px;
}

input {
	padding: 0px;
	font-family: verdana, helvetica, arial;
	font-size: 12px;
}

input.checkbox {
	width: 20px;
}

textarea {
	width: 300px;
	height: 100px;
	font-family: 'courier new';
	font-size: 11px;
}
.r1 {
	background-color: rgb(230,250,240);
}
.r0 {
	background-color: rgb(200,230,210);
}

.warning {
	background-color: #FFA0A0;
}

</style>

PAGESTART;

$spacer = '
<tr><td colspan="3" height="10"></td>';
$target = 'target="_blank"';
#$type = 'type="text/html"';
$type = '';
$extension = date('YmdHis') . '.mps';

// init odd/even flag
$r = 0;

// bool entrance room omly
if (empty($_POST) ) {
	$_POST['e_only'] = 1;
}

$cap = ' nur Eingangsraum vergleichen';
if (empty($_POST['e_only']) ) {
	$eOnly = '<input class="checkbox" type="checkbox" name="e_only" value="1">'.$cap;
	$roomId = null;
}
else {
	$eOnly = '<input class="checkbox" type="checkbox" name="e_only" value="1" checked="checked">'.$cap;
	$roomId = 0;
}

// split blacklist into array and add table "IDENT"
$post['blacklist'] = trim($post['blacklist']);
preg_match_all("/([^\s]+)[,\s]*/", $post['blacklist'], $blacklistedMatch);
$blacklistedTables = $blacklistedMatch[1];
natcasesort($blacklistedTables);
$post['blacklist'] = implode("\n", $blacklistedTables);
$blacklistedTables[] = "IDENT";
unset($blacklistedMatch);

// store blacklist into file
$handle = &fopen($fb_name, 'wr');
fwrite($handle, $post['blacklist']); // table blacklist only
fclose($handle);
chmod($fb_name, 0777);

// if no parameter "count" was submitted use 999 for count => show 999 tables => show all tables
if (empty($post['count']) ) {
	$count = 1;
}
else {
	$count = intval($post['count']);
}

$arrChangesHtml = array();

if ($count)
{
	$arrTablesOld = $dbOld->getCol('show tables');
	$arrTablesNew = $dbNew->getCol('show tables');

	// only tables which exist in both databases need comparison
	$arrTablesIntersect = array_intersect($arrTablesOld, $arrTablesNew);

	// remove blacklisted tables and exceptions from intersection
	// array arrTables is a list of tables which exists in BOTH databases
	$arrTables = array_diff($arrTablesIntersect, $blacklistedTables);
	unset($arrTablesIntersect, $blacklistedTables);

	// compare next <$count> tables
	foreach($arrTables as $table)
	{
		if (empty($table) ) {
			// just in case...
			continue;
		}

		echo "Vergleiche Tabelle {$table} :<br />";

		$PMap->setConnection($dbOld);

		$tabDescOld = $dbOld->query('describe '.$table);
		if (empty($tabDescOld) ) {
			die('old table not described : '.$table);
		}

		$arrTabDesc = array();
		$arrColNames = array();
		$arrFkTokenMapOld = array();
		$arrBlacklistedColumns[$table.'_PARENT_ID'] = true;

		while($colDesc = $tabDescOld->fetchRow(DBMC_FETCHMODE_ASSOC) )
		{
			$colName = $colDesc['Field'];

			$arrTabDesc[$colName] = $colDesc;

			ob_start();
			if ( ! isset($arrBlacklistedColumns[$colName]) ) {
				$arrColNames[] = $colName;
				// store map data if column is (used as) foreign key
				// returns FALSE if column is not mapped
				$arrFkTokenMapOld[$colName] = $PMap->getFkMapByColName($colName, $roomId);
			}
			$msg = ob_get_clean();

			if ( ! empty($arrFkTokenMapOld[$colName]) ) {
				// map loaded
				echo "Loading Map for {$old['dbhost']}.{$old['db']}.{$table}.{$colName} ...";
				echo $msg;
				echo "done.<br>";
			}

			if ($colDesc['Key'] != "PRI") {
				continue;
			}

			// preset primary key as order
			$order = $colName;

			// save primary key
			$primaryKeyName = $colName;
		} // end while
		$tabDescOld->free();
		unset($tabDescOld, $colName, $colDesc);

		if (empty($primaryKeyName) ) {
			mc_Debug::error(null, "missing primary key column in table {$table}");
			die();
		}

		// compare structures: die if structure is not equal (enough)
		$tabDescNew = $dbNew->query('describe '.$table);
		if (empty($tabDescNew) ) {
			die("new table not described : {$table}");
		}

		// search in column descriptions for mismatches between old and new table
		while($descNew = $tabDescNew->fetchRow(DBMC_FETCHMODE_ASSOC) )
		{
			$colName = $descNew['Field'];

			if ( isset($arrBlacklistedColumns[$colName]) ) {
				continue;
			}

			if (isset($arrTabDesc[$colName]) ) {
				$descOld = $arrTabDesc[$colName];
			}
			else {
				die("missing (new) column {$colName} in old table {$table}");
			}

			if ($descNew['Type'] != $descOld['Type']) {
				$msg = "Description mismatch for Type of {$table}.{$colName} !";
				$msg.= "<br>old: {$descOld['Type']}<br>new: {$descNew['Type']}";
				SysMsg::showError($msg);
				die();
			}

			if ($descNew['Null'] != $descOld['Null']) {
				$msg = "Description mismatch for Null of {$table}.{$colName} !";
				$msg.= "<br>old: {$descOld['Null']}<br>new: {$descNew['Null']}";
				SysMsg::showError($msg);
				die();
			}

/*
			// not important for content comparison
			if ($descNew['Key']     != $descOld['Key']    ) { }
			if ($descNew['Default'] != $descOld['Default']) { }
			if ($descNew['Extra']   != $descOld['Extra']  ) { }
*/
		} // end while
		$tabDescNew->free();
		unset($descNew, $descOld, $colName);

// HINT: the compared tables have the same Fields, Types and Null-Settings now!

#		sort($arrColNames);

		// create list of selected columns from not-blacklisted columns
		$columns = implode(", ", $arrColNames);

		// must restrict to room id if column exists and room id is not null
		if ( ! in_array('COURSE_ID', $arrColNames) ) {
			$where = '';
		}
		else if ($roomId === null) {
			$where = '';
		}
		else {
			$where = 'where COURSE_ID = '.$roomId;
		}

		// create order statement (tables without primary column cause
		if (empty($arrTabPrimary[$table]) ) {
			$orderBy = '';
			$arrUniqueCols = array($primaryKeyName);
			// e.g. $arrUniqueCols = array( 'COURSE_ID' ) // from COURSE
		}
		else {
			$order = implode(", ", $arrTabPrimary[$table]);
			$orderBy = 'order by '.$order;
			$arrUniqueCols = $arrTabPrimary[$table];
			// e.g. $arrUniqueCols = $arrTabPrimary['COL'] = array( 'COL_TAB_IDENT', 'COL_NAME' )
		}

		$select = "select {$columns} from {$table} {$where} {$orderBy}";
		unset($cols, $where, $order, $orderBy);

		$arrMappedWhere = array();

		// e.g. $arrUniqueCols = array( 'COL_TAB_IDENT', 'COL_NAME' )
		foreach ($arrUniqueCols as $colName)
		{
			$arrMappedWhere[] = "{$colName} = \\\"{\$mappedRow['{$colName}']}\\\"";
		} // end foreach

		// for unique key description in mps file header
		$strMpsKey = implode($primaryKeySeparator, $arrUniqueCols);

		// key statement for sql
		$strSqlKey = "concat_ws( \"{$primaryKeySeparator}\", ".implode(', ', $arrUniqueCols)." )";

		// for loading maps in mps file header
		$strMpsMap = implode("\" />\n  <mpsmap value=\"", $arrUniqueCols);

		// key attribute of mps tags
		$strTmplItemKey = "\$key=\"{\$mappedRow['".implode("']}{$primaryKeySeparator}{\$mappedRow['", $arrUniqueCols)."']}\";";

		// for condition of mysql statement
		$strTmplItemMappedWhere = "\$mappedWhere=\"".implode("\n and ", $arrMappedWhere)."\";";

		unset($colName, $arrValueWhere, $arrMappedWhere);

		// load additional maps depending on selected table
		switch($table) {

			case 'ENTREL_ITEM' :
				$arrMultiMap = $PMap->getEntrelViewIdentMap();
				break;

			case 'LABELITEM' :
				$arrMultiMap = $PMap->getLabelViewIdentMap();
				break;

			case 'VCOL' :
				$arrMultiMap = $PMap->getViewTabIdentMap();
				break;

			default :
				break;
		} // end switch

		// fetch data from table
		$resultContentOld = $dbOld->query($select);
		$numRowsOld = $resultContentOld->numRows();

		$arrContentOld = array();
		$arrMapFailsOld = array();

		if ($numRowsOld > 0)
		{
			while ($row = $resultContentOld->fetchRow(DBMC_FETCHMODE_ASSOC) )
			{
				$primaryKeyValue = $row[$primaryKeyName];

				// returns values mapped to token
				// parameter $row is returned as reference with NULL set to 'NULL'
				$mappedRow = $PMap->mapResultRow($row
					, $arrFkTokenMapOld
					, $arrMultiMap
					, $arrMapFailsOld
				);

				// contains $mappedRow['colName'], result is $mappedWhere
				eval($strTmplItemMappedWhere);

				// contains $mappedRow['colName'], result is $key
				eval($strTmplItemKey);

				$mappedWhere = str_replace('= "NULL"', 'is NULL', $mappedWhere);

				unset($mappedRow[$primaryKeyName]);

				$arrContentOld[$key]['values'] = $mappedRow;
				$arrContentOld[$key]['primary'] = $primaryKeyValue;
				$arrContentOld[$key]['condition'] = $mappedWhere;

			} // end while ($resultContentOld)
			$resultContentOld->free();
			unset($row, $mappedRow, $mappedWhere, $primaryKeyMappedValue, $key);

		} // end if ($numRowsOld)

		unset($arrFkTokenMapOld, $arrMultiMap);

		// END of token mapping for OLD database content



		// START of token mapping for NEW database content

		$PMap->setConnection($dbNew);

		$arrFkTokenMapNew = array();
		foreach($arrColNames as $colName)
		{
			ob_start();
			$arrFkTokenMapNew[$colName] = $PMap->getFkMapByColName($colName, $roomId);
			$msg = ob_get_clean();

			if ( ! empty($arrFkTokenMapNew[$colName]) ) {
				// map loaded
				echo "Loading Map for {$new['dbhost']}.{$new['db']}.{$table}.{$colName} ...";
				echo $msg;
				echo "done.<br>";
			}
		} // end foreach
		unset($colName);

		// load additional maps depending on selected table
		switch($table) {

			case 'ENTREL_ITEM' :
				$arrMultiMap = $PMap->getEntrelViewIdentMap();
				break;

			case 'LABELITEM' :
				$arrMultiMap = $PMap->getLabelViewIdentMap();
				break;

			case 'VCOL' :
				$arrMultiMap = $PMap->getViewTabIdentMap();
				break;

			default :
				break;
		} // end switch

		if (empty($primaryKeyName) ) {
			mc_Debug::error(null, "missing primary key column in table {$table}");
			die();
		}

		$arrContentNew = array();
		$arrMapFailsNew = array();

		$resultContentNew = $dbNew->query($select);

		if ($resultContentNew->numRows() > 0)
		{
			while ($row = $resultContentNew->fetchRow(DBMC_FETCHMODE_ASSOC))
			{
				$primaryKeyMappedValue = $row[$primaryKeyName];

				$mappedRow = $PMap->mapResultRow($row
					, $arrFkTokenMapNew
					, $arrMultiMap
					, $arrMapFailsNew
				);

				// contains $mappedRow['colName'], result is $key
				eval($strTmplItemKey);

				unset($mappedRow[$primaryKeyName]);

				$arrContentNew[$key]['values'] = $mappedRow;
				$arrContentNew[$key]['primary'] = $primaryKeyMappedValue;

			} // end while ($resultContentNew)
			$resultContentNew->free();
			unset($row, $mappedRow, $mappedWhere, $primaryKeyMappedValue, $key);

		} // end if ($resultContentNew->numRows)

		unset($arrFkTokenMapNew, $arrMapEVI, $arrMapLVI, $arrMapVTI);

		$arrUpdate = array();
		$arrDelete = array();

		$countContentOld = count($arrContentOld);
		$countContentNew = count($arrContentNew);

		if (empty($countContentOld) && empty($countContentNew) ) {
			// no content available
		}
		else
		{
			$arrOldKeys = array_keys($arrContentOld);

			foreach($arrOldKeys as $oldKey)
			{
				if ( ! isset($arrContentNew[$oldKey]) ) {
					// deleted row (no match found in new content)
					$primaryKeyValue = $arrContentOld[$oldKey]['primary'];
					$strCondition = $arrContentOld[$oldKey]['condition'];

					$arrDelete[$primaryKeyValue] = "
  <mpsitem action=\"delete\">
delete from {$table}
	where
     {$strCondition}
;
  </mpsitem>";

					unset($arrContentOld[$oldKey]);

					continue;
				}

				// updated row

				$arrValuesOld = &$arrContentOld[$oldKey]['values'];
				$arrValuesNew = &$arrContentNew[$oldKey]['values'];

				// replace some database specific settings with token (e.g. host name)
				replace($arrValuesOld, $arrReplace);
				replace($arrValuesNew, $arrReplace);

				$strCompareOld = implode("]|[", $arrValuesOld);
				$strCompareNew = implode("]|[", $arrValuesNew);

				if ($table == "LAYOUT_ITEM") {
					$strCompareOld = preg_replace("/(^[\r\n]*|[\r\n]+)[\s\t]*[\r\n]+/", "\n", $strCompareOld);
					$strCompareNew = preg_replace("/(^[\r\n]*|[\r\n]+)[\s\t]*[\r\n]+/", "\n", $strCompareNew);
				}

				if ($strCompareOld == $strCompareNew) {
					// content is equal

					// remove compared items from both arrays
					unset($arrContentOld[$oldKey], $arrContentNew[$oldKey]);

					continue;
				}
				else {
					// debugging here
#					echo "<hr>$strCompareOld<hr>$strCompareNew<hr>";
				}

				$arrOldValues = array();
				$arrFieldUpdates = array();

				foreach($arrColNames as $colName)
				{
					$strValueOld = &$arrValuesOld[$colName];
					$strValueNew = &$arrValuesNew[$colName];

					if ($strValueOld == $strValueNew) {
						// same string, no update
						continue;
					}
					else {
						// debugging here
#						echo "<hr>$strValueOld<hr>$strValueNew<hr>";
					}


					// gather field updates
					if ($strValueNew == "NULL") {
						$arrFieldUpdates[] = $colName.' = NULL';
					}
					else {
						$arrFieldUpdates[] = $colName.' = "'.addcslashes($strValueNew, '"\\').'"';
					}

					// gather field history
					if ($strValueOld == "NULL") {
						$arrOldValues[] = $colName.' = NULL';
					}
					else {
						$arrOldValues[] = $colName.' = "'.addcslashes($strValueOld, '"\\').'"';
					}
				} // end foreach($arrColNames)

				if ( ! empty($arrFieldUpdates) )
				{
					$strOldValues = implode("\n, ", $arrOldValues);
					$strUpdates   = implode("\n, ", $arrFieldUpdates);
					$strCondition = $arrContentOld[$oldKey]['condition'];

					$arrUpdate[] = "
<!--
{$strOldValues}
-->
  <mpsitem action=\"update\" key=\"{$oldKey}\">
update {$table} set
  {$strUpdates}
 where
     {$strCondition}
;
  </mpsitem>";

				} // end if ($arrFieldUpdate)

				// remove compared items from both arrays
				unset($arrContentOld[$oldKey], $arrContentNew[$oldKey]);

			} // end foreach($arrOldKeys)

			unset($arrOldKeys);
		} // end if

		$countDelete = count($arrDelete);
		$countUpdate = count($arrUpdate);
		$countInsert = count($arrContentNew); // remaining entries are inserts

		$anyChanges = $countDelete + $countInsert + $countUpdate;

#		$r = 1 - $r; // trigger odd/even

		if ( empty($anyChanges) )
		{
			$arrChangesHtml[] = "
<tr class=\"r{$r}\">
	<td colspan=\"3\">table <b>{$table}</b></td>
</tr>";
		}
		else {
			$arrChangesHtml[] = "
<tr class=\"r{$r}\">
	<td colspan=\"3\">
		<b>*** <a href=\"javascript:hauAb('{$table}')\" title=\"Add table to blacklist.\">[^]</a>
		{$table} [ $countContentOld => $countContentNew ]
		</b>
	</td>
</tr>";
		}

		if ( ! empty($arrMapFailsOld) ) {
			foreach($arrMapFailsOld as $colName => $arrFails) {
				$strFails = implode(", ", $arrFails);
				$arrChangesHtml[] = "
<tr>
	<td class=\"warning\" colspan=\"2\">OLD Map Fail :</td>
	<td class=\"warning\">{$colName} in ( {$strFails} )</td>
</tr>";
			}
		}

		if ( ! empty($arrMapFailsNew) ) {
			foreach($arrMapFailsNew as $colName => $arrFails) {
				$strFails = implode(", ", $arrFails);
				$arrChangesHtml[] = "
<tr>
	<td class=\"warning\" colspan=\"2\">NEW Map Fail :</td>
	<td class=\"warning\">{$colName} in ( {$strFails} )</td>
</tr>";
			}
		}

		if (empty($countContentOld) && empty($countContentNew) ) {
			$arrChangesHtml[] = "
<tr>
	<td colspan=\"3\">both tables are empty</td>
</tr>";
		}

		// ### DELETEs
		if ($countDelete > 0)
		{
			$arrPrimaryKeys = array_keys($arrDelete);
			$strCsPrimaryKeys = implode(', ', $arrPrimaryKeys);

			$arrChangesHtml[] = "
<tr>
	<td class=\"action\">DELETEs</td>
	<td class=\"count\">: {$countDelete}</td>
	<td>{$primaryKeyName} in ( {$strCsPrimaryKeys} )</td>
</tr>";

			$fileMpsDeleteName = $table . '.delete.' . $extension;
			$file = $logPath . $fileMpsDeleteName;
			$href = "?show={$fileMpsDeleteName}";

			if ($hdl = fopen($file, 'w+'))
			{
				$strMpsItems = implode("\n\n", $arrDelete);
				$strMps = "
<mpstable name=\"{$table}\">
  <mpskey value=\"{$strMpsKey}\" separator=\"{$primaryKeySeparator}\" />
  <mpsmap value=\"{$strMpsMap}\" />

<!--
  {$primaryKeyName} in ( {$strCsPrimaryKeys} )
-->

{$strMpsItems}

</mpstable>";

				fwrite($hdl, $strMps);
				fclose($hdl);
				chmod($file, 0777);

				unset($strMps);

				$arrChangesHtml[] = "
<tr>
	<td></td><td></td><td><a href=\"{$href}\" {$target} {$type}>{$file}</a></td>
</tr>";
			} // end if (fopen)

			$arrChangesHtml[] = $spacer;
		}
		else {

			$arrChangesHtml[] = "
<tr>
	<td class=\"action\">DELETEs</td>
	<td class=\"count\">: 0</td>
	<td></td>
</tr>";

		} // end if ($countDelete)

		unset($arrDelete);



		// ### INSERTs

		if ($countInsert > 0)
		{
			$arrMpsMaps = array();
			// add MAP-loader
			foreach($arrUniqueCols as $mapName)
			{
				$arrMpsMaps[] = '  <mpsmap value="'.$mapName.'" />';
			} // end foreach ($arrUniqueCols)
			unset($mapName);

			// add AUTO-inserts
			$arrMpsAuto = array();
			foreach($arrColNames as $colName) {
				if (empty($arrInsertPresets[$colName]) ) {
					continue;
				}

				$method = $arrInsertPresets[$colName];
				if ($method == 'INS_ID' || $method == 'NEXTIDENT') {
					$arrMpsAuto[] = '  <mpsauto field="'.$colName.'" method="'.$method.'" />';
				}
			} // end foreach ($arrColNames)
			unset($colName, $method);

			// separator
			$arrMpsItems = array();
#			$arrInsertIds = array();

			foreach($arrContentNew as $key => $newItem)
			{
				$mappedRow = &$newItem['values'];

				$attrKey = str_replace('NULL', '', $key);

				$idx = $newItem['primary']; // == $primaryKeyValue
#				$idx[] = $attrKey; // == $primaryKeyValue

				$arrInsertFields = array();
				$arrInsertValues = array();

				foreach($mappedRow as $colName => $mappedValue)
				{
					if ( ! empty($arrInsertPresets[$colName]) )
					{
						switch($arrInsertPresets[$colName])
						{
							case 'INS_ID' :
							case 'NEXTIDENT' :
								// skip column ( predefined by tag MPSAUTO )
								continue 2;

							case 'NULL' :
								$mappedValue = 'NULL';
								break;

							case 'APP_IDENT' :
								$mappedValue = '%APP_IDENT%';
								break;

							case 'PATH' :
								$mappedValue = replace($mappedValue, $arrReplace);
								break;

							default :
								mc_Debug::error($arrInsertPresets[$colName], 'unknown ignore type');
						} // end switch
					} // end if

					if ($mappedValue != 'NULL')
					{
						$colType = strtoupper(substr($arrTabDesc[$colName]['Type'], 0, 4));
						switch($colType)
						{
							case 'CHAR' :
							case 'VARC' : #VARCHAR
							case 'TEXT' :
							case 'DATE' :
							case 'BLOB' :
							case 'BIGT' : #BIGTEXT
							case 'TIME' : #TIME/TIMESTAMP
							case 'LONG' : #LONGTEXT
								$mappedValue = '"'.addslashes($mappedValue).'"';
							default:
								break;
						}
					}

					$arrInsertFields[] = $colName;
					$arrInsertValues[] = $mappedValue;
				} // end foreach ($arrContentNew)

				$strInsertFields = implode(', ', $arrInsertFields);
				$strInsertValues = implode(', ', $arrInsertValues);

				$arrMpsItems[$idx] = "
  <mpsitem action=\"insert\" key=\"{$attrKey}\">
insert into {$table} (
  {$strInsertFields}
) values (
  {$strInsertValues}
)
  </mpsitem>";

			} // end foreach ($arrContentNew)

			$strCsInsertIds = implode(', ', array_keys($arrMpsItems) );
			$arrChangesHtml[] = "
<tr>
	<td class=\"action\">INSERTs</td>
	<td class=\"count\">: {$countInsert}</td>
	<td>{$primaryKeyName} in ( {$strCsInsertIds} )</td>
</tr>";
#	<td>mysqldump {$new['db']} {$table} -t --where=\"{$primaryKeyName} in ( {$strCsInsertIds} )\" >> {$table}.sql</td>

			$fileMpsInsertName = $table . '.insert.' . $extension;
			$file = $logPath . $fileMpsInsertName;
			$href = "?show={$fileMpsInsertName}";

			if ($hdl = fopen($file, 'w+'))
			{
				$strMpsMaps = implode(', ', $arrMpsMaps);
				$strMpsAuto = implode(', ', $arrMpsAuto);
				$strMpsItems = implode(', ', $arrMpsItems);
				unset($arrMpsMaps, $arrMpsAuto, $arrMpsItems);
				$strMps = "
<mpstable name=\"{$table}\">
  <mpskey value=\"{$strMpsKey}\" separator=\"{$primaryKeySeparator}\" />
  {$strMpsMaps}
  {$strMpsAuto}

<!--
  {$primaryKeyName} in ( {$strCsInsertIds} )
-->

{$strMpsItems}

</mpstable>";
				unset($strMpsMaps, $strMpsAuto, $strMpsItems);

				fwrite($hdl, $strMps);
				fclose($hdl);
				chmod($file, 0777);

				$arrChangesHtml[] = "
<tr>
	<td></td><td></td><td><a href=\"{$href}\" {$target} {$type}>{$file}</a></td>
</tr>";
				unset($strMps);
			} // end if (fopen)

			$arrChangesHtml[] = $spacer;
		}
		else {

			$arrChangesHtml[] = "
<tr>
	<td class=\"action\">INSERTs</td>
	<td class=\"count\">: 0</td>
	<td></td>
</tr>";

		} // end if ($countNew > 0)

		unset($arrMpsInsert);



		### UPDATEs

		$arrChangesHtml[] = "
<tr>
	<td class=\"action\">UPDATEs</td>
	<td class=\"count\">: {$countUpdate}</td>
	<td></td>
</tr>";

		if ($countUpdate > 0)
		{
			$strMpsUpdate = "
<mpstable name=\"{$table}\">
  <mpskey value=\"{$strMpsKey}\" separator=\"{$primaryKeySeparator}\" />
  <mpsmap value=\"{$strMpsMap}\" />

".implode("\n\n", $arrUpdate)."

</mpstable>";

			$fileMpsUpdateName = $table . '.update.' . $extension;
			$file = $logPath . $fileMpsUpdateName;
			$href = "?show={$fileMpsUpdateName}";

			if ($hdl = fopen($file, 'w+'))
			{
				fwrite($hdl, $strMpsUpdate);
				fclose($hdl);
				chmod($file, 0777);

				unset($strMpsUpdate);

				$arrChangesHtml[] = "
<tr>
	<td></td><td></td><td><a href=\"{$href}\" {$target} {$type}>{$file}</a></td>
</tr>";
			} // end if (fopen)

			$arrChangesHtml[] = $spacer;
		} // end if ($countUpdate > 0)

		unset($arrUpdate);

		if ($anyChanges > 0)
		{
			// leave table loop if table has any changes
			$arrChangesHtml[] = $spacer;
			break;
		}

		// no changes; add table to blacklist and check next table
		$post['blacklist'] .= "\n" . $table;

	} // end foreach ($arrTables)

} // end if (post[send])

$outBlacklist = str_replace("\\\\", "\\", $post['blacklist']);

if ( empty($arrChangesHtml) ) {
	$strHtml	= '';
}
else {
	$strChangesHtml = implode("\n", $arrChangesHtml);
	$strHtml = "<table width=\"100%\">\n{$strChangesHtml}\n</table>";
}

echo <<<COMPAREPAGE

<form name="check" method="post" action="">
<hr />
<table>
	<tr>
		<td>Table Blacklist</td>
		<td>Nach <input type="text" name="count" size="5" value="{$count}"> veränderten Tabellen anhalten</td>
	</tr>
	<tr>
		<td><textarea type="text" name="blacklist">{$outBlacklist}</textarea></td>
		<td>{$eOnly}</td>
	</tr>
	<tr>
		<td><input type="submit" name="send" value="Check Table Contents"></td>
		<td></td>
	</tr>
</table>
</form>
<HR />
{$strHtml}
<p><a href="index.php">Zur&uuml;ck zur Helper-&Uuml;bersicht</a></p>
</body>
</html>

COMPAREPAGE;

