<?php
/*
* $McLicense$
*
* $Id$
*
*/


if (file_exists('../_inc/standalone.php'))
{
	include_once('../_inc/standalone.php');
}

$File->TEST = false;

if (empty($_POST['revision']))
{
	$revision = '';
	$result = '';
}
else
{
	$revision = $_POST['revision'];
	$revision = str_replace('\\\\', '\\', $revision);
	$revision = str_replace('\\"', '"', $revision);

	$h = fopen('revision.log', 'w');
	fwrite($h, $revision);
	fclose($h);

	ob_start();
	$l_content = file('revision.log');

	$revision_list = parseContent($l_content);

	$file_list = fetchFileList($revision_list);

	$rev = reset($revision_list);

	$updDir = dirname(dirname(__FILE__));
	if (basename(dirname($updDir)) == 'maintenance')
	{
		$l_src_dir  = dirname(dirname($updDir));
	}
	else
	{
		$l_src_dir  = dirname($updDir);
	}

	$l_dest_dir = $updDir . DIRECTORY_SEPARATOR . 'files_to_R'.$rev['REVISION'];

	$arrDeleted = fetchDeleteList($revision_list);
	$arrKDeleted = array_flip($arrDeleted);

	copyFileList($File, $file_list, $l_src_dir, $l_dest_dir, $arrKDeleted);

	echo "\n\nfiles saved into {$l_dest_dir}\n\n";
	echo "list of deleted items:\n'".implode("',\n'", $arrDeleted)."',\n";

	$result = ob_get_contents();
	ob_end_clean();

	$revision = htmlspecialchars($revision);
}




function copyFileList(&$File, $list, $src, $dest, $arrKDeleted)
{
	$c = 0;

	foreach ($list as $path)
	{
		if ( ! file_exists($src.$path)  && isset($arrKDeleted[$path]) )
		{
			continue;
		}

		$dest_path = $dest.'/files/'.$path;

		if ($File->copy($src.$path, $dest_path))
		{
			$c++;
		}
	}

	echo $c." path statements copied\n";

	return true;
}




function fetchFileList($list)
{
/*
	$l_entry = array(
		'REVISION' => int,
		'AUTHOR'   => '',
		'DATE'     => '',
		'MESSAGE'  => '',
		'ADD' => array(),
		'DEL' => array(),
		'MOD' => array(),
	);
*/

	$l_arr = array();

	foreach ($list as $entry)
	{
		$l_arr = array_merge($l_arr, $entry['ADD']);
		$l_arr = array_merge($l_arr, $entry['MOD']);
	}

	array_unique($l_arr);

	sort($l_arr);

	return $l_arr;
}




function fetchDeleteList($list)
{
/*
	$l_entry = array(
		'REVISION' => int,
		'AUTHOR'   => '',
		'DATE'     => '',
		'MESSAGE'  => '',
		'ADD' => array(),
		'DEL' => array(),
		'MOD' => array(),
	);
*/

	$l_arr = array();

	foreach ($list as $entry)
	{
		$l_arr = array_merge($l_arr, $entry['DEL']);
	}

	array_unique($l_arr);

	sort($l_arr);

	$list = array();
	foreach($l_arr as $del)
	{
		$list[] = substr($del, 1);
	}

	return $list;
}




function parseContent($l_content)
{
	if (empty($l_content))
	{
		return array();
	}

	$l_entries = array();
	$l_entry = array();
	$l_log_message = false;
	$l_log_changes = false;

	$l_strip_path = '/trunk';

	// adding stop-line for last entry
	$l_content[] = 'Revision:';

	foreach ($l_content as $line)
	{
		$line = trim($line);
		if (empty($line))
		{
			continue;
		}

		if ($l_log_message == true)
		{
			if (substr($line, 0, 4) == '----')
			{
				$l_log_message = false;
				$l_log_changes = true;
				continue;
			}

			$l_entry['MESSAGE'][] = $line;

			continue;
		}

		if (strpos($line, 'Revision:') === 0)
		{
			if (empty($l_entry) == false)
			{
				$l_entries[$l_entry['REVISION']] = $l_entry;
			}
			$l_log_changes = false;
			$l_log_message = false;

			$l_entry = array(
				'REVISION' => intval(substr($line, 10)),
				'AUTHOR'   => '',
				'DATE'     => '',
				'MESSAGE'  => '',
				'ADD' => array(),
				'DEL' => array(),
				'MOD' => array(),
			);
			continue;
		}
		else
		{
			if ($l_log_changes == true)
			{
				$l_index = null;
				if      (substr($line, 0, 10) == 'Modified :')
				{
					$line = str_replace('Modified : '.$l_strip_path, '', $line);
					$l_index = 'MOD';
				}
				else if (substr($line, 0,  9) == 'Deleted :')
				{
					$line = str_replace('Deleted : '.$l_strip_path, '', $line);
					$l_index = 'DEL';
					if (in_array($line, $l_entry['ADD']))
					{
						continue;
					}
				}
				else if (substr($line, 0,  7) == 'Added :')
				{
					$line = str_replace('Added : '.$l_strip_path, '', $line);
					$l_index = 'ADD';
					if (in_array($line, $l_entry['DEL']))
					{
						continue;
					}
				}

				if ($l_index)
				{
					$copyPos = strpos(strtolower($line), ' (copy from path: ');
					if ($copyPos !== false)
					{
						$line = substr($line, 0, $copyPos);
					}
					$l_entry[$l_index][] = $line;
				}
				else
				{
					echo 'unknown type : '.$line.'<br />';
				}

				continue;
			}
		}

		if (strpos($line, 'Author:') === 0)
		{
			$l_entry['AUTHOR'] = substr($line, 8);
			continue;
		}

		if (strpos($line, 'Date:') === 0)
		{
			$l_entry['DATE'] = substr($line, 6);
			continue;
		}

		if (strpos($line, 'Message:') === 0)
		{
			$l_log_message = true;
			continue;
		}

	}

	echo count($l_entries)." entries processed\n";

	return $l_entries;

}



?><html>
<HEAD>
<title>metacoon patch tool</title>
<meta http-equiv="expires" content="0">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
</HEAD>
<body>
  <form name="log" action="" method="post">
		<textarea name="revision" style="display:block; width:100%; height:45%; border:2px ridge; background-color:#F0F0F0; font-family:\'courier new\',serif; font-size:11px;"><?php echo $revision; ?></textarea>
		<input type="submit" name="send" value="fetch files [<?php echo date('H:i:s'); ?>]">
		<hr />
		<textarea name="result" style="display:block; width:100%; height:45%; border:2px ridge; background-color:#F0F0F0; font-family:\'courier new\',serif; font-size:11px;"><?php echo $result; ?></textarea>
  </form>
</body>
</html>