<?php
/*
* $McLicense$
*
* $Id$
*
*/

/*
$this       =  Patch()
$l_DBStruct =  $this->DBStruct;
$l_File     =  $this->File;
$l_Stack    = &$this->Stack;
*/

if (file_exists('../_inc/standalone.php'))
{
	include_once('../_inc/standalone.php');
}

set_time_limit(900);

SysMsg::showMsg('check and refresh (probably add) table indices');

$DBStruct->refreshStructures();

// drop all indices
if ( ! empty($dropAllIndices) ) {

	$arrAllTables = $DBStruct->getAllTableNamesAsArray();
	foreach($arrAllTables as $table)
	{
		if($table == 'mc_phpbb_search_wordlist')
		{
			SysMsg::showInfo("skipping table {$table} (auto increment column is different from primary key)");
			continue;
		}

		$DBStruct->dropAllIndicesOnTable($table);
	} // end foreach($arrAllTables)

	$DBStruct->refreshStructures();
} // end if ($dropAllIndices)

// recreate standard indices for component tables

$select = 'select distinct TAB_NAME from VIEW, TAB where VIEW_TAB_IDENT = TAB_IDENT order by TAB_NAME';
$arrComponentTables = $DBStruct->DB->getCol($select);
foreach ($arrComponentTables as $table)
{
	if ( ! $DBStruct->tableExists($table) ) {
		continue;
	}

	$DBStruct->createIndexOnTable($table, "{$table}_ID,STATE");
	$DBStruct->createIndexOnTable($table, "DS_ID,STATE");
	$DBStruct->createIndexOnTable($table, "INSDAT");
} // end foreach ($arrComponentTables)

$DBStruct->refreshStructures();

// recreate special indices

$DBStruct->createIndexOnTable("BINFILE", "BINFILE_VIEW_IDENT,BINFILE_FK_IDENT");

$DBStruct->createIndexOnTable("CHAT_MESSAGE", "CHAT_MESSAGE_SEND_CHAT_USER_IDENT");
$DBStruct->createIndexOnTable("CHAT_MESSAGE", "CHAT_MESSAGE_TIMESTAMP,CHAT_MESSAGE_RCPT_CHAT_USER_IDENT,CHAT_MESSAGE_RCPT_CHAT_ROOM_ID,CHAT_MESSAGE_SEND_CHAT_USER_IDENT,COURSE_ID,STATE");

$DBStruct->createIndexOnTable("CHAT_USER", "CHAT_USER_USER_IDENT");

$DBStruct->createIndexOnTable("COL", "COL_TAB_IDENT,COL_IDENT");

$DBStruct->createIndexOnTable("COURSE_CONF", "COURSE_ID");

// @TODO COURSE_FAVORITES
// @TODO COURSE_NODE
// @TODO COURSE_TRACK

$DBStruct->createIndexOnTable("DS", "DS_RES_ID,COURSE_ID");
$DBStruct->createIndexOnTable("DS", "DS_RES_ID,DS_FK_ID,STATE");

// @TODO DSLOCK

$DBStruct->createIndexOnTable("DS_ACCESS", "DS_ACCESS_DS_ID");
$DBStruct->createIndexOnTable("DS_ACCESS", "DS_ACCESS_WGROUP_IDENT,DS_ACCESS_ACCESS,STATE");
$DBStruct->createIndexOnTable("DS_ACCESS", "DS_ACCESS_DS_ID,DS_ACCESS_WGROUP_IDENT,DS_ACCESS_WGROUP_TYPE,DS_ACCESS_ACCESS,DATE_FROM,DATE_TILL,FLAGS,STATE");

$DBStruct->createIndexOnTable("DS_LINK", "DS_LINK_DEST_DS_ID,DS_LINK_SRC_DS_ID");
$DBStruct->createIndexOnTable("DS_LINK", "DS_LINK_SRC_DS_ID");

$DBStruct->createIndexOnTable("ELEMENT", "ELEMENT_IDENT");
$DBStruct->createIndexOnTable("ELEMENT", "ELEMENT_VIEW_IDENT");
$DBStruct->createIndexOnTable("ELEMENT", "ELEMENT_KIND,STATE");
$DBStruct->createIndexOnTable("ELEMENT", "ELEMENT_NAME,STATE");

// @TODO ENTREL
// @TODO ENTREL_ITEM
// @TODO ELQUES_REG
// @TODO ELQUES_TEST
// @TODO ELQUES_TEST_ITEM
// @TODO ELQUES_TEST_RESULT

$DBStruct->createIndexOnTable("EXTENSION", "EXTENSION_NAME");

$DBStruct->createIndexOnTable("EXTFUNC", "EXTFUNC_EXTFUNC_TYPE_IDENT");
$DBStruct->createIndexOnTable("EXTFUNC", "EXTFUNC_VIEW_IDENT");
$DBStruct->createIndexOnTable("EXTFUNC", "EXTFUNC_ELEMENT_IDENT");
$DBStruct->createIndexOnTable("EXTFUNC", "EXTFUNC_EXTENSION_ID");

$DBStruct->createIndexOnTable("EXTFUNC_TYPE", "EXTFUNC_TYPE_IDENT");
$DBStruct->createIndexOnTable("EXTFUNC_TYPE", "EXTFUNC_TYPE_NAME");

$DBStruct->createIndexOnTable("EXTMENU", "EXTMENU_NAME,STATE");

$DBStruct->createIndexOnTable("EXTMENUITEM", "EXTMENUITEM_MENU_IDENT");
$DBStruct->createIndexOnTable("EXTMENUITEM", "EXTMENUITEM_MENUITEMLAY_IDENT");
$DBStruct->createIndexOnTable("EXTMENUITEM", "COURSE_ID,EXTMENUITEM_SUB");

$DBStruct->createIndexOnTable("EXTMENUITEMLAY", "EXTMENUITEMLAY_IDENT");
$DBStruct->createIndexOnTable("EXTMENUITEMLAY", "EXTMENUITEMLAY_MENULAY_IDENT");

$DBStruct->createIndexOnTable("EXTMENULAY", "EXTMENULAY_NAME");
$DBStruct->createIndexOnTable("EXTMENULAY", "EXTMENULAY_IDENT");

// @TODO FIELD_RIGHTS

$DBStruct->createIndexOnTable("KATA", "KATA_NAME,LANGUAGE");
$DBStruct->createIndexOnTable("KATA", "KATA_IDENT,LANGUAGE");

// @TODO KATADEL
// @TODO KATADELITEM
// @TODO KATADELMAP
// @TODO KATADELMAPITEM

#$DBStruct->createIndexOnTable("LABEL", "LABEL_VIEW_IDENT,LABEL_NAME,STATE");
$DBStruct->createIndexOnTable("LABEL", "LABEL_VIEW_IDENT,STATE");

$DBStruct->createIndexOnTable("LABELITEM", "LABELITEM_LABEL_IDENT,LABELITEM_VCOL_IDENT,STATE");

$DBStruct->createIndexOnTable("LANGTXT", "LANGTXT_SCRIPT_IDENT,LANGTXT_VIEW_IDENT,COURSE_ID,LANGUAGE,STATE");
$DBStruct->createIndexOnTable("LANGTXT", "LANGTXT_VARIABLE");

$DBStruct->createIndexOnTable("LAYOUT", "LAYOUT_NAME");

$DBStruct->createIndexOnTable("LINK", "LINK_D_ID,LINK_D_TAB_IDENT,STATE");
$DBStruct->createIndexOnTable("LINK", "LINK_D_ID,COURSE_ID,LINK_D_VIEW");
$DBStruct->createIndexOnTable("LINK", "LINK_S_TAB_IDENT,LINK_S_ID");
$DBStruct->createIndexOnTable("LINK", "LINK_S_VIEW_IDENT,LINK_S_ID");
$DBStruct->createIndexOnTable("LINK", "LINK_D_TAB_IDENT,LINK_D_ID");
$DBStruct->createIndexOnTable("LINK", "LINK_D_VIEW_IDENT,LINK_D_ID");

$DBStruct->createIndexOnTable("LINK_TYPE", "LINK_TYPE_IDENT");
$DBStruct->createIndexOnTable("LINK_TYPE", "LINK_TYPE_NAME");

$DBStruct->createIndexOnTable("LOGIN", "LOGIN_USER_IDENT");
$DBStruct->createIndexOnTable("LOGIN", "LOGIN_NAME,STATE");

$DBStruct->createIndexOnTable("LOG_ROOM", "LOG_ROOM_USER_IDENT,LOG_ROOM_COURSE_ID,LOG_ROOM_BOARDTIME");

$table = "MC_ALUM_MAILSEND_LOG";
// method returns case sensitive table name by reference
if ( $DBStruct->tableExists($table) )
{
	#$DBStruct->createIndexOnTable($table, "MC_ALUM_MAILSEND_LOG_MC_ALUM_MAILSEND_ID");
	$DBStruct->createIndexOnTable($table, "MC_ALUM_MAILSEND_LOG_MC_ALUM_MAILSEND_ID,MC_ALUM_MAILSEND_USER_IDENT");
}

$DBStruct->createIndexOnTable("MC_CONFIG", "MC_CONFIG_NAME");

#$DBStruct->createIndexOnTable("MC_MAILSEND_LOG", "MC_MAILSEND_LOG_MC_MAILSEND_ID");
$DBStruct->createIndexOnTable("MC_MAILSEND_LOG", "MC_MAILSEND_LOG_MC_MAILSEND_ID,MC_MAILSEND_USER_IDENT");

// @TODO MC_TEXT

$DBStruct->createIndexOnTable("MENU", "MENU_NAME,COURSE_ID");

$DBStruct->createIndexOnTable("MENUITEM", "MENUITEM_MENU_IDENT,MENUITEM_SUB,COURSE_ID");
$DBStruct->createIndexOnTable("MENUITEM", "MENUITEM_MENU_IDENT,MENUITEM_MENUITEMLAY_IDENT,COURSE_ID");
$DBStruct->createIndexOnTable("MENUITEM", "COURSE_ID,STATE,MENUITEM_ELEMENT_IDENT");
$DBStruct->createIndexOnTable("MENUITEM", "MENUITEM_CSS_IDENT,COURSE_ID,STATE");

$DBStruct->createIndexOnTable("MENUITEMLAY", "MENUITEMLAY_IDENT,MENUITEMLAY_MENULAY_IDENT");

#$DBStruct->createIndexOnTable("MENULAY", "MENULAY_NAME,MENULAY_IDENT");
$DBStruct->createIndexOnTable("MENULAY", "MENULAY_NAME");

$DBStruct->createIndexOnTable("MIMETYPE", "MIMETYPE_EXT");

$DBStruct->createIndexOnTable("PARAM", "PARAM_NAME,STATE");

// @TODO POLL

$DBStruct->createIndexOnTable("PROFILE", "PROFILE_PARAM_IDENT,PROFILE_USER_IDENT,COURSE_ID,PROFILE_VIEW_IDENT,STATE");
$DBStruct->createIndexOnTable("PROFILE", "PROFILE_PARAM_IDENT,PROFILE_VIEW_IDENT");
$DBStruct->createIndexOnTable("PROFILE", "COURSE_ID,PROFILE_USER_IDENT");
$DBStruct->createIndexOnTable("PROFILE", "COURSE_ID,PROFILE_VIEW_IDENT");

// @TODO PROFILE_ROOM_TYPE
// @TODO QTI2_RESULT

$DBStruct->createIndexOnTable("REL_COURSE_ROOM_STRUCTURE", "REL_COURSE_ROOM_STRUCTURE_ROOM_STRUCTURE_IDENT,REL_COURSE_ROOM_STRUCTURE_COURSE_ID");
$DBStruct->createIndexOnTable("REL_COURSE_ROOM_STRUCTURE", "REL_COURSE_ROOM_STRUCTURE_TOP_IDENT");

$DBStruct->createIndexOnTable("REL_COURSE_USER", "REL_COURSE_USER_COURSE_ID,REL_COURSE_USER_USER_IDENT,REL_COURSE_USER_CONFIRM");
$DBStruct->createIndexOnTable("REL_COURSE_USER", "REL_COURSE_USER_COURSE_ID,REL_COURSE_USER_CONFIRM");
$DBStruct->createIndexOnTable("REL_COURSE_USER", "REL_COURSE_USER_USER_IDENT,REL_COURSE_USER_CONFIRM");
// from member count
// @TODO: check if global count is faster (skipping rooms by processing result)
$DBStruct->createIndexOnTable("REL_COURSE_USER", "REL_COURSE_USER_COURSE_ID,STATE");
$DBStruct->createIndexOnTable("REL_COURSE_USER", "REL_COURSE_USER_USER_IDENT,REL_COURSE_USER_CONFIRM,STATE");

$DBStruct->createIndexOnTable("REL_G_U", "REL_G_U_USER_IDENT,REL_G_U_WGROUP_IDENT");
$DBStruct->createIndexOnTable("REL_G_U", "REL_G_U_WGROUP_IDENT");
$DBStruct->createIndexOnTable("REL_G_U", "REL_G_U_USER_IDENT,REL_G_U_WGROUP_COURSE_ID");

// @TODO REL_POLL_DATASET
// @TODO REL_USER
// @TODO REL_VREIHE_USER

$DBStruct->createIndexOnTable("ROOM_MODEL", "ROOM_MODEL_NAME,STATE");

$DBStruct->createIndexOnTable("ROOM_STRUCTURE", "ROOM_STRUCTURE_IDENT,STATE");
$DBStruct->createIndexOnTable("ROOM_STRUCTURE", "ROOM_STRUCTURE_PARENT_IDENT,STATE");

// @TODO ROOM_TYPE

$DBStruct->createIndexOnTable("SCRIPT", "SCRIPT_NAME,STATE");

$DBStruct->createIndexOnTable("SESSION", "SESSION_USER_IDENT");
$DBStruct->createIndexOnTable("SESSION", "SESSION_SID");
$DBStruct->createIndexOnTable("SESSION", "SESSION_LASTACTION");
$DBStruct->createIndexOnTable("SESSION", "SESSION_CURRENT_COURSE_ID");

$DBStruct->createIndexOnTable("SIMPLADR", "SIMPLADR_USER_IDENT,STATE");

$DBStruct->createIndexOnTable("SN", "SN_EMPFAENGER,SN_STATUS");
$DBStruct->createIndexOnTable("SN", "SN_EMPFAENGER,SN_ABSENDER,SN_DATUM_VON,SN_STATUS,STATE");

$DBStruct->createIndexOnTable("TAB", "TAB_IDENT,STATE");
$DBStruct->createIndexOnTable("TAB", "TAB_NAME,STATE");

$DBStruct->createIndexOnTable("TOOL", "TOOL_IDENT,STATE");
$DBStruct->createIndexOnTable("TOOL", "TOOL_NAME,STATE");

// @TODO more TPL_EXTMENUITEM
$DBStruct->createIndexOnTable("TPL_EXTMENUITEM", "TPL_EXTMENUITEM_ROOM_TYPE_IDENT");

// @TODO more TPL_MENU
$DBStruct->createIndexOnTable("TPL_MENU", "TPL_MENU_ROOM_TYPE_IDENT");

// @TODO more TPL_MENUITEM
$DBStruct->createIndexOnTable("TPL_MENUITEM", "TPL_MENUITEM_ROOM_TYPE_IDENT,TPL_MENUITEM_MENUITEM_SUB");

// @TODO more TPL_WGROUP
#$DBStruct->createIndexOnTable("TPL_WGROUP", "TPL_WGROUP_ROOM_TYPE_IDENT");
$DBStruct->createIndexOnTable("TPL_WGROUP", "TPL_WGROUP_ROOM_TYPE_IDENT,TPL_WGROUP_TYPE,STATE");

// @TODO more TPL_WRIGHT
$DBStruct->createIndexOnTable("TPL_WRIGHT", "TPL_WRIGHT_ROOM_TYPE_IDENT");

$DBStruct->createIndexOnTable("USER", "USER_IDENT,STATE");
$DBStruct->createIndexOnTable("USER", "USER_NAME,STATE");
$DBStruct->createIndexOnTable("USER", "USER_NAME,USER_AUTH_TYPE,STATE");

$DBStruct->createIndexOnTable("USER_ICONS", "CHAT_ICON_IDENT,STATE");

$DBStruct->createIndexOnTable("VCAL_ENTRY", "VCAL_ENTRY_IDENT,STATE");
$DBStruct->createIndexOnTable("VCAL_ENTRY", "VCAL_ENTRY_IDENT,OWNER");
$DBStruct->createIndexOnTable("VCAL_ENTRY", "VCAL_ENTRY_IDENT,OWNER,VCAL_ENTRY_APP_IDENT,STATE");
$DBStruct->createIndexOnTable("VCAL_ENTRY", "VCAL_ENTRY_IDENT,VCAL_ENTRY_ROOM_IDENT,OWNER,VCAL_ENTRY_APP_IDENT,STATE");
$DBStruct->createIndexOnTable("VCAL_ENTRY", "VCAL_ENTRY_IDENT,OWNER,VCAL_ENTRY_APP_IDENT,STATE");

$DBStruct->createIndexOnTable("VCAL_ENTRY_USER_REL", "VCAL_ENTRY_USER_REL_ENTRY_IDENT,VCAL_ENTRY_USER_REL_USER_IDENT,STATE");
$DBStruct->createIndexOnTable("VCAL_ENTRY_USER_REL", "VCAL_ENTRY_USER_REL_ENTRY_IDENT,VCAL_ENTRY_USER_REL_WGROUP_IDENT,STATE");
$DBStruct->createIndexOnTable("VCAL_ENTRY_USER_REL", "VCAL_ENTRY_USER_REL_ENTRY_IDENT,VCAL_ENTRY_USER_REL_WGROUP_IDENT,VCAL_ENTRY_USER_REL_USER_IDENT,STATE");
$DBStruct->createIndexOnTable("VCAL_ENTRY_USER_REL", "VCAL_ENTRY_USER_REL_ENTRY_IDENT,OWNER,STATE");
$DBStruct->createIndexOnTable("VCAL_ENTRY_USER_REL", "VCAL_ENTRY_USER_REL_WGROUP_IDENT,STATE");
$DBStruct->createIndexOnTable("VCAL_ENTRY_USER_REL", "VCAL_ENTRY_USER_REL_USER_IDENT,STATE");
$DBStruct->createIndexOnTable("VCAL_ENTRY_USER_REL", "VCAL_ENTRY_USER_REL_USER_IDENT");
$DBStruct->createIndexOnTable("VCAL_ENTRY_USER_REL", "OWNER");

$DBStruct->createIndexOnTable("VCOL", "VCOL_VIEW_IDENT,VCOL_COL_IDENT,STATE");
$DBStruct->createIndexOnTable("VCOL", "VCOL_VIEW_IDENT,VCOL_IDENT,STATE");
$DBStruct->createIndexOnTable("VCOL", "VCOL_FORMNAME,STATE");

$DBStruct->createIndexOnTable("VIEW", "VIEW_IDENT,STATE");
$DBStruct->createIndexOnTable("VIEW", "VIEW_NAME,STATE");
$DBStruct->createIndexOnTable("VIEW", "VIEW_TAB_IDENT,STATE");
$DBStruct->createIndexOnTable("VIEW", "VIEW_ELEMENT_IDENT,VIEW_WNEW_ORDER,STATE");

$DBStruct->createIndexOnTable("VTREE_NODE", "VTREE_NODE_ID,VTREE_NODE_DELETED");
$DBStruct->createIndexOnTable("VTREE_NODE", "VTREE_NODE_PARENT_ID,VTREE_NODE_COURSE_ID,VTREE_NODE_DELETED");
$DBStruct->createIndexOnTable("VTREE_NODE", "VTREE_NODE_COURSE_ID,ACCESS");
$DBStruct->createIndexOnTable("VTREE_NODE", "VTREE_NODE_COURSE_ID,WGROUP,ACCESS");
$DBStruct->createIndexOnTable("VTREE_NODE", "OWNER");

$DBStruct->createIndexOnTable("WGROUP", "WGROUP_IDENT,STATE");
$DBStruct->createIndexOnTable("WGROUP", "WGROUP_NAME,STATE");
$DBStruct->createIndexOnTable("WGROUP", "OWNER,WGROUP_TYPE");
$DBStruct->createIndexOnTable("WGROUP", "WGROUP_NAME,COURSE_ID,STATE");
$DBStruct->createIndexOnTable("WGROUP", "COURSE_ID,WGROUP_TYPE,STATE");
$DBStruct->createIndexOnTable("WGROUP", "COURSE_ID,WGROUP_NAME,STATE");

$DBStruct->createIndexOnTable("WRIGHT", "WRIGHT_WGROUP_IDENT,WRIGHT_ELEMENT_IDENT,STATE");
$DBStruct->createIndexOnTable("WRIGHT", "WRIGHT_ELEMENT_IDENT,COURSE_ID,STATE");
$DBStruct->createIndexOnTable("WRIGHT", "WRIGHT_WGROUP_IDENT,WRIGHT_SIUD,STATE");
$DBStruct->createIndexOnTable("WRIGHT", "WRIGHT_ELEMENT_IDENT,COURSE_ID,WRIGHT_SIUD,STATE");
$DBStruct->createIndexOnTable("WRIGHT", "COURSE_ID,STATE");
$DBStruct->createIndexOnTable("WRIGHT", "WRIGHT_WGROUP_IDENT,WRIGHT_ELEMENT_IDENT,STATE,WRIGHT_APP_IDENT");

# WRIGHT_ITEM is deprecated since revision 974
#$DBStruct->createIndexOnTable("WRIGHT_ITEM", "WRIGHT_ITEM_WRIGHT_SET_IDENT,STATE");

$DBStruct->createIndexOnTable("mc_phpbb_attach_quota", "quota_type");
$DBStruct->createIndexOnTable("mc_phpbb_attachments", "attach_id,post_id");
$DBStruct->createIndexOnTable("mc_phpbb_attachments", "attach_id,privmsgs_id");
$DBStruct->createIndexOnTable("mc_phpbb_attachments", "post_id");
$DBStruct->createIndexOnTable("mc_phpbb_attachments", "privmsgs_id");
$DBStruct->createIndexOnTable("mc_phpbb_attachments_desc", "filetime");
$DBStruct->createIndexOnTable("mc_phpbb_attachments_desc", "physical_filename(10)");
$DBStruct->createIndexOnTable("mc_phpbb_attachments_desc", "filesize");
$DBStruct->createIndexOnTable("mc_phpbb_auth_access", "group_id");
$DBStruct->createIndexOnTable("mc_phpbb_auth_access", "forum_id");
$DBStruct->createIndexOnTable("mc_phpbb_banlist", "ban_ip,ban_userid");
$DBStruct->createIndexOnTable("mc_phpbb_categories", "cat_order");
$DBStruct->createIndexOnTable("mc_phpbb_easymod_processed_files", "mod_processed_file");
$DBStruct->createIndexOnTable("mc_phpbb_easymod_processed_files", "mod_id");
$DBStruct->createIndexOnTable("mc_phpbb_forum_prune", "forum_id");
$DBStruct->createIndexOnTable("mc_phpbb_forums", "forum_order");
$DBStruct->createIndexOnTable("mc_phpbb_forums", "cat_id");
$DBStruct->createIndexOnTable("mc_phpbb_forums", "forum_last_post_id");
$DBStruct->createIndexOnTable("mc_phpbb_groups", "group_single_user");
$DBStruct->createIndexOnTable("mc_phpbb_posts", "forum_id");
$DBStruct->createIndexOnTable("mc_phpbb_posts", "topic_id");
$DBStruct->createIndexOnTable("mc_phpbb_posts", "poster_id");
$DBStruct->createIndexOnTable("mc_phpbb_posts", "post_time");
$DBStruct->createIndexOnTable("mc_phpbb_privmsgs", "privmsgs_from_userid");
$DBStruct->createIndexOnTable("mc_phpbb_privmsgs", "privmsgs_to_userid");
$DBStruct->createIndexOnTable("mc_phpbb_search_results", "session_id");
#$DBStruct->createIndexOnTable("mc_phpbb_search_wordlist", "word_id");
$DBStruct->createIndexOnTable("mc_phpbb_search_wordmatch", "post_id");
$DBStruct->createIndexOnTable("mc_phpbb_search_wordmatch", "word_id");
$DBStruct->createIndexOnTable("mc_phpbb_sessions", "session_user_id");
$DBStruct->createIndexOnTable("mc_phpbb_sessions", "session_id,session_ip,session_user_id");
$DBStruct->createIndexOnTable("mc_phpbb_sessions_keys", "last_login");
$DBStruct->createIndexOnTable("mc_phpbb_topics", "forum_id");
$DBStruct->createIndexOnTable("mc_phpbb_topics", "topic_moved_id");
$DBStruct->createIndexOnTable("mc_phpbb_topics", "topic_status");
$DBStruct->createIndexOnTable("mc_phpbb_topics", "topic_type");
$DBStruct->createIndexOnTable("mc_phpbb_topics_watch", "topic_id");
$DBStruct->createIndexOnTable("mc_phpbb_topics_watch", "user_id");
$DBStruct->createIndexOnTable("mc_phpbb_topics_watch", "notify_status");
$DBStruct->createIndexOnTable("mc_phpbb_user_group", "group_id");
$DBStruct->createIndexOnTable("mc_phpbb_user_group", "user_id");
$DBStruct->createIndexOnTable("mc_phpbb_users", "user_session_time");
$DBStruct->createIndexOnTable("mc_phpbb_vote_desc", "topic_id");
$DBStruct->createIndexOnTable("mc_phpbb_vote_results", "vote_option_id");
$DBStruct->createIndexOnTable("mc_phpbb_vote_results", "vote_id");
$DBStruct->createIndexOnTable("mc_phpbb_vote_voters", "vote_id");
$DBStruct->createIndexOnTable("mc_phpbb_vote_voters", "vote_user_id");
$DBStruct->createIndexOnTable("mc_phpbb_vote_voters", "vote_user_ip");

$DBStruct->createIndexOnTable("mc_scorm_items", "idscorm_organization,item_identifier");
$DBStruct->createIndexOnTable("mc_scorm_items_track", "idscorm_organization");
$DBStruct->createIndexOnTable("mc_scorm_items_track", "idscorm_item");
$DBStruct->createIndexOnTable("mc_scorm_items_track", "idUser");
$DBStruct->createIndexOnTable("mc_scorm_items_track", "idscorm_tracking");
$DBStruct->createIndexOnTable("mc_scorm_organizations", "org_identifier,idscorm_package");
$DBStruct->createIndexOnTable("mc_scorm_resources", "idsco,idscorm_package");
$DBStruct->createIndexOnTable("mc_scorm_tracking", "idUser,idscorm_resource");
$DBStruct->createIndexOnTable("mc_scorm_tracking", "idUser");
$DBStruct->createIndexOnTable("mc_scorm_tracking", "idscorm_resource");

$DBStruct->createIndexOnTable("smil_fachgebiet", "id");

