<?php

if (file_exists('../_inc/standalone.php'))
{
	include_once('../_inc/standalone.php');
}
include_once(MC_LIB_PATH . 'DsAccess.php');

SysMsg::showMsg("add r/w-permission for room data (some room administrators were unable to change room data)", true);
$table = 'COURSE';


// fetch table data and room administrator group from related room
$query = "select {$table}.{$table}_ID, {$table}.DS_ID, WGROUP_ID"
	." from {$table}, WGROUP"
	." where {$table}.STATE != 'T'"
	." and WGROUP.COURSE_ID = {$table}.COURSE_ID"
	." and WGROUP_NAME = 'KURSADMIN'"
;
$result = $MC->DB->query($query);

$DsAccess = new DsAccess();
$countUpdated = 0;
$countSkipped = 0;

while( list($roomId, $dsId, $roomAdminGroupId) = $result->fetchRow() )
{
	$roomId = intval($roomId);
	$dsId   = intval($dsId);
	$roomAdminGroupId = intval($roomAdminGroupId);

	// read multi group access
	$originalMgrAccess = $DsAccess->getMgrAccessByDsId($dsId, false);
	$newMgrAccess = $originalMgrAccess;

	// add group permission to existing permissions
	$newMgrAccess['static'][$roomAdminGroupId] = 6;

	// remove group from existing permissions
	#unset($newMgrAccess[$roomAdminGroupId]);

	// compare permissions (multi-dimensional arrays are properly compared, yes)
	if ($newMgrAccess == $originalMgrAccess)
	{
		// nothing changed, skip write
		$countSkipped++;
		continue;
	}

	$DsAccess->write($dsId, $newMgrAccess, 1, $roomId);
	$countUpdated++;
}
$result->free();

SysMsg::showInfo("{$countUpdated} permission(s) updated");
SysMsg::showInfo("{$countSkipped} permission(s) skipped (already up to date)");

