<?php


/*
$this       =  Patch()
$l_DBStruct =  $this->DBStruct;
$l_File     =  $this->File;
$l_Stack    = &$this->Stack;
*/

if (file_exists('../_inc/standalone.php'))
{
	include_once('../_inc/standalone.php');
}

$dir_rooms = MC_PAGE_PATH;
$dir_tmpls = MC_PAGE_PATH.'Templates'.DIRECTORY_SEPARATOR.'ext_room_pages'.DIRECTORY_SEPARATOR;

// fix external pages
if ( !$handle = opendir($dir_rooms) )
{
	SysMsg::showError('unable to open directory "'.$dir_rooms.'"');
	return false;
}

$c = 0; // counter

$bak_dir = $l_Conf->getBackupPath().'#extern_pages.BAK';
mkdir($bak_dir, 0777);

while ( ($file = readdir($handle)) !== false)
{
  if ( ($file == ".") || ($file == "..") || ($file == ".svn") )
  {
  	continue;
  }

  if ( !is_dir($dir_rooms.$file) )
  {
		continue;
	}

  if (preg_match('/^C[0-9]+$/U', $file) == 0)
  {
		continue;
	}

  if ( !is_dir($dir_rooms.$file.DIRECTORY_SEPARATOR.'DE') )
  {
		continue;
	}

	mkdir($bak_dir.DIRECTORY_SEPARATOR.$file, 0777);

	mkdir($bak_dir.DIRECTORY_SEPARATOR.$file.DIRECTORY_SEPARATOR.'DE', 0777);

	$c += intval(fixShowlist($dir_rooms.$file.DIRECTORY_SEPARATOR.'DE', $bak_dir.DIRECTORY_SEPARATOR.$file.DIRECTORY_SEPARATOR.'DE'.DIRECTORY_SEPARATOR));

  if ( !is_dir($dir_rooms.$file.DIRECTORY_SEPARATOR.'EN') )
  {
		continue;
	}

	mkdir($bak_dir.DIRECTORY_SEPARATOR.$file.DIRECTORY_SEPARATOR.'EN', 0777);

	$c += intval(fixShowlist($dir_rooms.$file.DIRECTORY_SEPARATOR.'EN', $bak_dir.DIRECTORY_SEPARATOR.$file.DIRECTORY_SEPARATOR.'EN'.DIRECTORY_SEPARATOR));

} // end while $handle

closedir($handle);

SysMsg::showInfo($c.' page file(s) have been rewritten.');



// fix template pages
if ( !$handle = opendir($dir_tmpls) )
{
	SysMsg::showError('unable to open directory "'.$dir_tmpls.'"');
	return false;
}

$c = 0; // counter

$bak_dir = $l_Conf->getBackupPath().'#extern_templates.BAK';
mkdir($bak_dir, 0777);

while ( ($file = readdir($handle)) !== false)
{
  if ( ($file == ".") || ($file == "..") || ($file == ".svn") )
  {
  	continue;
  }

  if ( !is_dir($dir_tmpls.$file) )
  {
		continue;
	}


  if (preg_match('/^T[0-9]+$/U', $file) == 0)
  {
		continue;
	}

  if ( !is_dir($dir_tmpls.$file.DIRECTORY_SEPARATOR.'DE') )
  {
		continue;
	}

	mkdir($bak_dir.DIRECTORY_SEPARATOR.$file, 0777);

	mkdir($bak_dir.DIRECTORY_SEPARATOR.$file.DIRECTORY_SEPARATOR.'DE', 0777);

	$c += intval(fixShowlist($dir_tmpls.$file.DIRECTORY_SEPARATOR.'DE', $bak_dir.DIRECTORY_SEPARATOR.$file.DIRECTORY_SEPARATOR.'DE'.DIRECTORY_SEPARATOR));

  if ( !is_dir($dir_tmpls.$file.DIRECTORY_SEPARATOR.'EN') )
  {
		continue;
	}

	mkdir($bak_dir.DIRECTORY_SEPARATOR.$file.DIRECTORY_SEPARATOR.'EN', 0777);

	$c += intval(fixShowlist($dir_tmpls.$file.DIRECTORY_SEPARATOR.'EN', $bak_dir.DIRECTORY_SEPARATOR.$file.DIRECTORY_SEPARATOR.'EN'.DIRECTORY_SEPARATOR));

} // end while $handle

SysMsg::showInfo($c.' template file(s) have been rewritten.');



function fixShowlist($p_path, $p_bak_dir)
{
	if (!$handle = opendir($p_path))
	{
		SysMsg::showError('unable to open directory "'.$p_path.'"');
		return false;
	}

	$count = 0;

  while ( ($file = readdir($handle)) !== false)
  {
    if ( ($file == ".") || ($file == "..") || ($file == ".svn") )
    {
    	continue;
    }

		$src = $p_path.DIRECTORY_SEPARATOR.$file;

    if ( !is_file($src) )
    {
			continue;
    }

		$contents = file_get_contents($src);

		if (strpos($contents, '{$showlist(') === false)
		{
			continue;
		}

//		SysMsg::showMsg('checking in file '.$src.' {SUCCEEDED}');

		$hash = md5($contents);
//  {$showlist('VPROJECT',40,'PROJEKTLISTE','2 ASC','M2_PROJECT_KATEGORIE_ID=4 AND RELEASE=\'Y\' ','class="hg_c-indi03_030"','class="hg_c-sys01_100"','','')}
//		$contents = preg_replace('/\{\s*\$showlist\((.*)\)\s*\}/Ums', '{$showlist($1)}', $contents);
		$contents = preg_replace('/\{\s*\$showlist\(([^}]*)class=&quot;([^}]*)&quot;([^}]*)class=&quot;([^}]*)&quot;([^}]*)\)\s*\}/Ums', '{$showlist(${1}${2}${3}${4}${5})}', $contents);
		$contents = preg_replace('/\{\s*\$showlist\(([^}]*)class="([^}]*)"([^}]*)class="([^}]*)"([^}]*)\)\s*\}/Ums', '{$showlist(${1}${2}${3}${4}${5})}', $contents);
		$contents = preg_replace('/\{\s*\$showlist\(([^}]*)(?:\s+and|\s+AND)?\s*(?:RELEASE|RELSTATE)\s*=\s*(?:\\\\\'Y\\\\\'|\'Y\'|\\\\"Y\\\\"|"Y"|&quot;Y&quot;)\s*\'(.*)\)\s*\}/Ums', '{$showlist(${1}\'${2})}', $contents);
		$contents = preg_replace('/\{\s*\$showlist\(([^}]*)=\s*(?:\\\\\'|\'|\\\\"|"|&quot;)([\S_]+)(?:\\\\\'|\'|\\\\"|"|&quot;)([^}]*)\)\s*\}/Ums', '{$showlist(${1}=[${2}]${3})}', $contents);

		if ($hash == md5($contents))
		{
			continue;
		}

//		SysMsg::showTask('changes made in file '.$src.' {SUCCEEDED}');

		if ( !copy($src, $p_bak_dir.$file) )
		{
			SysMsg::showError('cannot backup file '.$src.' into '.$p_bak_dir.$file.'. rewrite {CANCELED}');
			continue;
		}

//echo htmlspecialchars(strip_tags($contents));
//continue;

		if ( !$h = fopen($src, 'w') )
		{
			SysMsg::showError('cannot open file '.$src.'. rewrite {CANCELED}');
			continue;
		}

		fwrite($h, $contents);
		fclose($h);

		$count++;
//		SysMsg::showMsg('rewriting file '.$src.' {SUCCEEDED}');

  } // end while

  closedir($handle);

	return $count;
} // end of function fixShowlist


