<?php

if (empty($DBStruct) || ! is_object($DBStruct) )
{
    throw new Exception('object $DBStruct is not available');
}

$DBStruct -> createTable('ESOBJECT_CONVERSION', "(
  `ESOBJECT_CONVERSION_ID` int(11) NOT NULL AUTO_INCREMENT,
  `ESOBJECT_CONVERSION_OBJECT_ID` int(11) NOT NULL,
  `ESOBJECT_CONVERSION_FORMAT` varchar(255) NOT NULL,
  `ESOBJECT_CONVERSION_MIMETYPE` varchar(255) NOT NULL,
  `ESOBJECT_CONVERSION_DIR_SEPERATOR` varchar(255) NOT NULL,
  `ESOBJECT_CONVERSION_FILENAME` varchar(255) NOT NULL,
  `ESOBJECT_CONVERSION_OUTPUT_FILENAME` varchar(255) NOT NULL,
  `ESOBJECT_CONVERSION_RENDER_PATH` varchar(255) NOT NULL,
  `ESOBJECT_CONVERSION_TIME` int(11) NOT NULL,
  `ESOBJECT_CONVERSION_STATUS` varchar(255) NOT NULL,
  PRIMARY KEY (`ESOBJECT_CONVERSION_ID`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;
");

$DBStruct -> createTable('ESOBJECT_LOCK', "(
  `ESOBJECT_CONVERSION_ID` int(11) NOT NULL AUTO_INCREMENT,
  `ESOBJECT_LOCK_REP_ID` varchar(255) NOT NULL,
  `ESOBJECT_LOCK_OBJECT_ID` varchar(255) NOT NULL,
  `ESOBJECT_LOCK_OBJECT_VERSION` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`ESOBJECT_CONVERSION_ID`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;
");

$DBStruct -> changeCol('esobject', 'ESOBJECT_MIMETYPE', array(
    'Type' => 'varchar(100)',
    'Null' => 'YES',
    'Default' => 'NULL',
));

/*
 * ADD MIMETYPES
 * */
 
$mimetypes = array(
    'xlsm' => 'application/vnd.ms-excel.sheet.macroEnabled.12',
    'dotx' => 'application/vnd.openxmlformats-officedocument.wordprocessingml.template',
    'docm' => 'application/vnd.ms-word.document.macroEnabled.12',
    'dotm' => 'application/vnd.ms-word.template.macroEnabled.12',
    'xltx' => 'application/vnd.openxmlformats-officedocument.spreadsheetml.template',
    'xltm' => 'application/vnd.ms-excel.template.macroEnabled.12',
    'xlam' => 'application/vnd.ms-excel.addin.macroEnabled.12',
    'xlsb' => 'application/vnd.ms-excel.sheet.binary.macroEnabled.12',
    'potx' => 'application/vnd.openxmlformats-officedocument.presentationml.template',
    'ppsx' => 'application/vnd.openxmlformats-officedocument.presentationml.slideshow',
    'ppam' => 'application/vnd.ms-powerpoint.addin.macroEnabled.12',
    'pptm' => 'application/vnd.ms-powerpoint.presentation.macroEnabled.12',
    'potm' => 'application/vnd.ms-powerpoint.template.macroEnabled.12',
    'ppsm' => 'application/vnd.ms-powerpoint.slideshow.macroEnabled.12',
    'ppt' => 'application/vnd.ms-powerpoint',
    'odg' => 'application/vnd.oasis.opendocument.graphics',
    'odc' => 'application/vnd.oasis.opendocument.chart',
    'odf' => 'application/vnd.oasis.opendocument.formula',
    'odi' => 'application/vnd.oasis.opendocument.image',
    'odm' => 'application/vnd.oasis.opendocument.text-master',
    'ott' => 'application/vnd.oasis.opendocument.text-template',
    'ots' => 'application/vnd.oasis.opendocument.spreadsheet-template',
    'otp' => 'application/vnd.oasis.opendocument.presentation-template',
    'otg' => 'application/vnd.oasis.opendocument.graphics-template'
);


//get "office" module id
    $result = $U->DB->query("SELECT ESMODULE_ID FROM ESMODULE WHERE ESMODULE_NAME = 'office'");
    $row = $result -> fetchRow(DBMC_FETCHMODE_ASSOC);
    $esModuleId = $row['ESMODULE_ID'];

    foreach($mimetypes as $ext => $mimetype) {
        
    //insert mimetype 
    $result = $U->DB->query("SELECT MIMETYPE_ID FROM MIMETYPE WHERE MIMETYPE_TYPE = '".$mimetype."'");
    if($result->numRows() == 0) {
        $result = $U->DB->query("insert into MIMETYPE (MIMETYPE_EXT, MIMETYPE_TYPE, MIMETYPE_APPLICATION, MIMETYPE_ICON, STATE) values
        ('".$ext."', '".$mimetype."', '', 'dummy.gif', 'Y');");
        $insertIdB = mysql_insert_id();
        $result = $U->DB->query("UPDATE MIMETYPE SET MIMETYPE_IDENT = " . $insertIdB . " WHERE MIMETYPE_ID = " . $insertIdB);
        if($result)
            SysMsg::showInfo("insert mimetype \"".$mimetype."\" : {SUCCEED}"); 
    } else {
        $row = $result -> fetchRow(DBMC_FETCHMODE_ASSOC);
        $insertIdB = $row['MIMETYPE_IDENT'];
    }
        
        
    //insert mimetype-module record
    $mimetypeIdent = $insertIdB;
    if(!empty($mimetypeIdent)) {
        $result = $U->DB->query("SELECT * FROM REL_ESMODULE_MIMETYPE WHERE REL_ESMODULE_MIMETYPE_MIMETYPE_IDENT = ".$mimetypeIdent." AND REL_ESMODULE_MIMETYPE_ESMODULE_ID = ".$esModuleId." AND REL_ESMODULE_MIMETYPE_TYPE = '".$mimetype."';");
        if($result->numRows() == 0) {    
            $result = $U->DB->query("insert into REL_ESMODULE_MIMETYPE (REL_ESMODULE_MIMETYPE_MIMETYPE_IDENT, REL_ESMODULE_MIMETYPE_ESMODULE_ID, REL_ESMODULE_MIMETYPE_TYPE) values (".$mimetypeIdent.", ".$esModuleId.", '".$mimetype."');");
        
        SysMsg::showInfo("insert rel record for  \"".$mimetype."\" to REL_ESMODULE_MIMETYPE : {SUCCEED}"); 
        }
    }
    
    
}

$result = $U->DB->query("UPDATE REL_ESMODULE_MIMETYPE SET REL_ESMODULE_MIMETYPE_TYPE = 'audio/x-wav' WHERE REL_ESMODULE_MIMETYPE_TYPE = 'audio/wav';");
if($result)
    SysMsg::showInfo("update rel record for \"audio/x-wav\" : {SUCCEED}"); 


$resu = $U->DB->query("INSERT into REL_ESMODULE_MIMETYPE (REL_ESMODULE_MIMETYPE_ESMODULE_ID, REL_ESMODULE_MIMETYPE_TYPE) values (1, 'application/vnd.ms-excel');");
if($resu)
    SysMsg::showInfo("insert rel record \"application/vnd.ms-excel\" : {SUCCEED}"); 
    

    
$result = $U->DB->query("UPDATE REL_ESMODULE_MIMETYPE SET REL_ESMODULE_MIMETYPE_ESMODULE_ID = 3 WHERE REL_ESMODULE_MIMETYPE_TYPE = 'application/vnd.oasis.opendocument.text';");
if($result)
    SysMsg::showInfo("update rel record for \"application/vnd.oasis.opendocument.text\" : {SUCCEED}"); 
$result = $U->DB->query("UPDATE REL_ESMODULE_MIMETYPE SET REL_ESMODULE_MIMETYPE_ESMODULE_ID = 3 WHERE REL_ESMODULE_MIMETYPE_TYPE = 'application/vnd.oasis.opendocument.spreadsheet';");
if($result)
    SysMsg::showInfo("update rel record for \"application/vnd.oasis.opendocument.spreadsheet\" : {SUCCEED}"); 
$result = $U->DB->query("UPDATE REL_ESMODULE_MIMETYPE SET REL_ESMODULE_MIMETYPE_ESMODULE_ID = 3 WHERE REL_ESMODULE_MIMETYPE_TYPE = 'application/vnd.oasis.opendocument.presentation';");
if($result)
    SysMsg::showInfo("update rel record for \"application/vnd.oasis.opendocument.presentation\" : {SUCCEED}"); 