<?php

define('USE_DS_ACCESS', ''); // just needs to be defined !!!


$MC_INCLUDE_PATH = explode(':', ini_get("include_path"));

# LANGUAGE MAP
$_LANG = array();
$_LANG[1] = 'DE';
$_LANG[2] = 'EN';
$_LANG['DE'] = 1;
$_LANG['EN'] = 2;

# PERMISSION OVERRULE
# sets the overrule filter for user-group-relations
# (administrators with matching overrule type are automatically counted as member of all groups of each course)
# type values:  4 = ADMIN, 2 = PLATTFORMADMIN, 1 = KURSADMIN --> the parameter is matched against $_SESSION['IS_ADMIN'] (binary conjunction)
define("ADMIN_OVERRULE_MASK","6"); // default: 6 (ADMIN | PLATTFORMADMIN)


# ERROR HANDLING
define('MC_DIE_ON_ERROR', false);
define('MC_DEBUG',   $DEBUG);
define('MC_DEVMODE', $DEVMODE);


# HTML DEFAULT CHARACTER SET
define('MC_CHAR_SET', 'utf-8');


# SESSION SETTINGS
define('MC_SESSION_MAX_LIFETIME', 3660);
define('MC_SESSION_NAME_INT', $INT_SESS_NAME);
define('MC_SESSION_NAME_EXT', $EXT_SESS_NAME);


# ROOM STRUCTURE SWITCH
define("ROOM_STRUCTURE_ENABLED", true);


# DATABASE DEFINITIONS
define("DSN", 	    $DSN);
define("MC_DBHOST", $dbhost);
define("MC_DBNAME", $db);
define("MC_DBUSER", $dbuser);
define("MC_DBPASS",  $pwd);
// +++++ deprecated
define("M2_DBHOST", $dbhost);
define("M2_DBNAME", $db);
define("M2_DBUSER", $dbuser);
define("M2_DBPWD",  $pwd);
// -----


# INTERNAL PATH DEFINITIONS
define("MC_SCHEME",  $MC_SCHEME);
define("MC_HOST",    $MC_HOST);
define("MC_PATH",    $MC_PATH);
define("MC_DOCROOT", $MC_DOCROOT);
define("MC_ROOT_PATH", MC_DOCROOT.MC_PATH);
define("MC_BASE_DIR", MC_ROOT_PATH);
define("MC_URL",  MC_SCHEME.'://'.MC_HOST.MC_PATH);
define("MC_EMBED_PATH",   MC_ROOT_PATH."func/embed/");
define("MC_EXTERN_PATH",  MC_ROOT_PATH."extern/");
define("MC_IMG_URI",      MC_URL."design/m2xcross/img/");	// URI zum image-verzeichnis
define("MC_LANG_PATH",    MC_ROOT_PATH."lang/");
define("MC_LAYOUT_PATH",  MC_ROOT_PATH."layout/");
define("MC_MODULES_PATH", MC_ROOT_PATH."modules/");
define("MC_MODULES_URI",  MC_URL."modules/");
define("MC_LIB_PATH",     MC_ROOT_PATH."func/classes.new/");	// path to metacoon library

define("CC_CONF_PATH",     MC_ROOT_PATH."conf/");	//
define("CC_CONF_APPFILE",  "ccapp-registry.properties.xml");	//
define("CC_LOCALE_PATH",   MC_ROOT_PATH."locale/");	//
define("CC_LOCALE_FILE",  "lang.common.php");	//
define('CC_RENDER_PATH',   $CC_RENDER_PATH);

define("LIB_NEW_FULLPATH",  MC_LIB_PATH);	// deprecated parameter


# EXTERNAL FUNCTION MODULES
// setting pear directory as include directory
$MC_INCLUDE_PATH[] = MC_ROOT_PATH."func/extern/pear1.7.2/";
$MC_INCLUDE_PATH[] = MC_ROOT_PATH."func/extern/";

// path to smarty directory
define("LIB_SMARTY_FULLPATH", MC_ROOT_PATH."func/extern/smarty/libs/");

// path to nusoap directory ???
// define("LIB_NUSOAP_FULLPATH", MC_ROOT_PATH."func/extern/nusoap/");


# COMPONENT PERMISSION BINARY INDEX
define("MC_RIGHT_SHOW",   1);
define("MC_RIGHT_INSERT", 2);
define("MC_RIGHT_UPDATE", 3);
define("MC_RIGHT_DELETE", 4);
define("MC_RIGHT_FILE",   5);
define("MC_RIGHT_LINK",   6);
define("MC_RIGHT_POLL",   7);
define("MC_RIGHT_MBOARD", 8);

# DATASET PERMISSION DECIMAL INDEX
define("MC_GROUP_DELETE",   1);
define("MC_GROUP_UPDATE",   2);
define("MC_GROUP_SHOW",     4);
define("MC_OTHER_DELETE",   8);
define("MC_OTHER_UPDATE",  16);
define("MC_OTHER_SHOW",    32);
define("MC_DS_DELETE",   MC_GROUP_DELETE + MC_OTHER_DELETE);
define("MC_DS_UPDATE",   MC_GROUP_UPDATE + MC_OTHER_UPDATE);
define("MC_DS_SHOW",     MC_GROUP_SHOW   + MC_OTHER_SHOW);
define("MC_DS_GROUP",    MC_GROUP_DELETE + MC_GROUP_UPDATE + MC_GROUP_SHOW);
define("MC_DS_OTHER",    MC_OTHER_DELETE + MC_OTHER_UPDATE + MC_OTHER_SHOW);
define("MC_DS_ALL",      MC_DS_GROUP + MC_DS_OTHER);
define("MC_DS_NO_GROUP", MC_DS_ALL - MC_DS_GROUP);

# DATASET FLAGS DECIMAL INDEX
define("MC_FLAG_SYSTEM",    1);
define("MC_FLAG_HIDDEN",    2);
define("MC_FLAG_MARKED",    4);
define("MC_FLAG_SMALL",     8);
define("MC_FLAG_ARCHIV",   16);
define("MC_FLAG_ACTIVE",   32);
//define("MC_FLAG_???",   64);
//define("MC_FLAG_???",  128);
//define("MC_FLAG_???",  256);
//define("MC_FLAG_???",  512);
//define("MC_FLAG_???", 1024);

define("MC_FLAG_MATCH_NOT_VISIBLE", MC_FLAG_HIDDEN + MC_FLAG_ARCHIV);
#define("MC_FLAG_MATCH_", ?);


/*** END of DEFINITION block ***/

// declaring include paths
array_unshift($MC_INCLUDE_PATH, '.');
ini_set("include_path", implode(';', array_unique($MC_INCLUDE_PATH)));
unset($MC_INCLUDE_PATH);

//deprecated
define("MC_ROOT_URI",  MC_URL);
