<?php

/**
 * Build a base-class providing the underlying infrastructure for the actual
 * application-class which will provide neccessary functionality.
 *
 *
 */
abstract class ESRender_Application_Abstract
implements ESRender_Application_Interface
{

	/**
	 *
	 * @var DBMC $Database
	 */
	public function __construct(DBMC $Database)
	{
		$this->setDatabase($Database);
	}

	/**
	 *
	 */
	public function __destruct()
	{
		$this->Logger = null;
		$this->Database = null;
	}

	/**
	 * (non-PHPdoc)
	 * @see ESRender_Application_Interface::getDefaultDisplayMode()
	 */
	public function getDefaultDisplayMode()
	{
		return ESRender_Application_Interface::DISPLAY_MODE_WINDOW;
	}

	/**
	 * (non-PHPdoc)
	 * @see ESRender_Application_Interface::getDefaultWidth()
	 */
	public function getDefaultWidth()
	{
		return ESRender_Application_Interface::DEFAULT_WIDTH;
	}

	/**
	 * (non-PHPdoc)
	 * @see ESRender_Application_Interface::getDefaultHeight()
	 */
	public function getDefaultHeight()
	{
		return ESRender_Application_Interface::DEFAULT_HEIGHT;
	}

	/**
	 *
	 *
	 * @var DBMC
	 */
	private $Database = null;

	/**
	 *
	 *
	 * @param DBMC $Database
	 * @return ESRender_Application_Abstract
	 */
	protected function setDatabase(DBMC $Database)
	{
		$this->Database = $Database;
		return $this;
	}

	/**
	 *
	 * @return DBMC
	 */
	public function getDatabase()
	{
		return $this->Database;
	}

	/**
	 * Contains the logger to use, if any has been set.
	 *
	 * @var Logger
	 */
	private $Logger = null;

	/**
	 * Set an optional logger.
	 *
	 * @param Logger $Logger
	 * @return ESRender_Application_Abstract
	 */
	public function setLogger(Logger $Logger = null)
	{
		$this->Logger = $Logger;
		return $this;
	}

	/**
	 * Return the current logger, or null if none set.
	 *
	 * @return Logger
	 */
	protected function getLogger()
	{
		return $this->Logger;
	}

}
