<?php

/**
 * Overwrite given username by default.
 *
 */
class ESRender_Plugin_SetDefaultUsername
extends ESRender_Plugin_Abstract
{

	/**
	 * Hold the default username.
	 *
	 * @var string
	 */
	private $username = '';

	/**
	 *
	 * @param string $username the default username to set.
	 */
	public function __construct($username)
	{
		$this->username = $username;
	}

	/**
	 * Set username after loading application-config.
	 *
	 * (non-PHPdoc)
	 * @see ESRender_Plugin_Abstract::postLoadApplication()
	 */
	public function postLoadApplication(
		EsApplication &$remote_rep,
		EsApplication &$remote_app,
		&$object_id,
		&$course_id,
		&$resource_id,
		&$username)
	{
		$username = $this->username;
	}

}
