<?php
/*
* $McLicense$
*
* $Id$
*
*/


set_time_limit(7200); // 2h
if ( ! defined('DEFAULT_MEMORY_LIMIT') )
{
	define('DEFAULT_MEMORY_LIMIT', ini_get("memory_limit") );
}
ini_set("display_errors", 1);

$errorReporting = E_ALL;
if (defined("E_STRICT") )
{
	$errorReporting = $errorReporting & ~E_STRICT;
}
if (defined("E_DEPRECATED") )
{
	$errorReporting = $errorReporting & ~E_DEPRECATED;
}
if (defined("E_USER_DEPRECATED") )
{
	$errorReporting = $errorReporting & ~E_USER_DEPRECATED;
}
error_reporting($errorReporting);
date_default_timezone_set('Europe/Berlin'); // TODO

// preparing global settings and objects
global $MC_BUFFER, $U;
// closing system buffer (if running)
$MC_BUFFER = @ob_get_clean();

define('MCP_PATH', dirname(__FILE__) . DIRECTORY_SEPARATOR);
define('MCP_DIR',  basename(MCP_PATH) );
define('MCP_INC_PATH', MCP_PATH . '_inc' . DIRECTORY_SEPARATOR);

$parentPath = dirname(MCP_PATH);
if (basename($parentPath) == 'maintenance')
{
	// developers mode, update loaded as part of maintenance tools 
	define('MCP_DEVMODE', TRUE);
	define('MCP_PF_INST_PATH', dirname($parentPath) . DIRECTORY_SEPARATOR);
}
else
{
	// customer mode, update loaded by update framework
	define('MCP_DEVMODE', FALSE);
	define('MCP_PF_INST_PATH', $parentPath . DIRECTORY_SEPARATOR);
}
define('MCP_PF_CONF_PATH', MCP_PF_INST_PATH . 'conf' . DIRECTORY_SEPARATOR);

require(MCP_INC_PATH . 'php_comp.php');

// load original platform configuration
try
{
	require(MCP_PF_CONF_PATH . 'system.conf.php');
	require(MCP_PF_CONF_PATH . 'db.conf.php');
	require(MCP_PF_CONF_PATH . 'defines.conf.php');
	require(MCP_PF_CONF_PATH . 'extlib.conf.php');
	//require(MCP_PF_CONF_PATH . 'old_versions.compat.php');
	require(MCP_PF_CONF_PATH . 'modules.conf.php');
	require(MCP_PF_CONF_PATH . 'custom.conf.php');
	if (defined('MC_DOCROOT_URL') )
	{
		// BC for revision 1090 or higher
		$MC_BASE_DIR = MC_BASE_DIR;
		$MC_BASE_URI = MC_DOCROOT_URL;
	}
	else if (defined('MC_BASE_URL') )
	{
		// BC for revision 1090 or higher
		$MC_BASE_DIR = MC_BASE_DIR;
		$MC_BASE_URI = MC_BASE_URL;
	}
}
catch (Exception $e)
{
	die('unable to load original platform configuration');
}

if (MCP_DEVMODE) {
	define("MCP_URL", MC_URL . 'maintenance/' . MCP_DIR . '/');
}
else {
	define("MCP_URL", MC_URL . MCP_DIR . '/');
}

// php settings
ini_set('arg_separator.input',  '&');
ini_set('arg_separator.output', '&');
ini_set("memory_limit","300M");
ini_set("implicit_flush", 1);

error_reporting($errorReporting);

### load defines for update here
require(MCP_INC_PATH . 'defines.php');

// initialize API (work in progress)
require(MCP_LIB_PATH . 'U.class.php');
$U = new mc_U();
$U->initDBStruct();

// $DEFAULT_LANG[_ID] and $DEFAULT_TIMEZONE are set by extract($arrMcConfigAll)
global $DEFAULT_LANG_ID, $DEFAULT_LANG, $DEFAULT_TIMEZONE;
global $l_strLang, $l_intLang;

$arrMcConfigAll = $U->Config->getAll();
extract($arrMcConfigAll); // make system parameters available
unset($arrMcConfigAll);

//$_LANG = $U->Config->getLangMap();
$_LANG = array('DE' => 1, 'EN' => 2, '1' => 'DE', '2' => 'EN');
if ( ! empty($DEFAULT_LANG) )
{
	// deprecated version (revisions 1 to 1094)
	// MC_CONFIG contained DEFAULT LANG as numeric value  
	$DEFAULT_LANG_ID = $DEFAULT_LANG; 
	$DEFAULT_LANG = $_LANG[$DEFAULT_LANG_ID];
}
else if ( ! empty($DEFAULT_LANG_ID) )
{
	// new version (revisions > 1094)
	// MC_CONFIG now containes DEFAULT LANG_ID
	// (same as DEFAULT_LANG before but with fixed name)  
	$DEFAULT_LANG = $_LANG[$DEFAULT_LANG_ID];
}
else
{
	throw new Exception("neither DEFAULT_LANG nor DEFAULT_LANG_ID are properly set");
}
$l_intLang = $DEFAULT_LANG_ID;
$l_strLang = $DEFAULT_LANG;

$U->loadSession(MCP_SESSION_NAME);

$buffer = @ob_get_clean();
if ($buffer)
{
	dump($buffer);
	die('<hr>buffer dumped. script execution stopped.');
}

if (empty($hideEnvironment) )
{
	mc_Debug::showEnvironment();
	@ob_flush();
}

include_once(MCP_INC_PATH.'lang.php');
include_once(MCP_INC_PATH.'token.php');
include_once(MCP_INC_PATH.'toolinfo.php');

$buffer = @ob_get_clean();
if ($buffer)
{
	dump($buffer);
	die('<hr>buffer dumped. script execution stopped.');
}

